load("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 06 PCA NUM FACT/.RData")
setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 06 PCA NUM FACT")
train_data<-PCA_TRAIN_data.final_num_factors[,]
test_data<-PCA_TEST_data.final_num_factors[,]
###############DATA###################
a_names<-NA
for (i in 1:dim(train_data)[2]){
  print(names(train_data)[i])
  if(is.factor(train_data[,i]) == "TRUE")
  {a_names<-append(a_names, names(train_data)[i])}}

a_names<-a_names[-c(1:2)]
b_values<-which(names(train_data) %in% a_names)

train_data_num<-train_data[,]
test_data_num<-test_data[,]
for (i in b_values){
  print(names(train_data)[i])
  train_data_num[,i]<-as.numeric(train_data_num[,i])
  test_data_num[,i]<-as.numeric(test_data_num[,i])}

train_data_u<-train_data_num[,]
test_data_u<-test_data_num[,]

train_data_u2<-train_data_u[,-c(1)]
test_data_u2<-test_data_u[,-c(1)]

#########################################################################################
#                           MODELIAI
########################################################################################
expected_value <- factor(c(test_data[,(1)]))
Predicted_values<-as.data.frame(test_data$TARGET)
names(Predicted_values)[1]<-'Real_target'
########################################################################################
#                             LDA
########################################################################################

library(klaR)
library(psych)
library(MASS)
library(ggord)
library(devtools)

LD_linear <- lda(TARGET~., train_data)

p<- predict(LD_linear, test_data[,-c(1)])
predicted_value<-p$class
Predicted_values$LDA_linear<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

Palyginimo<-as.data.frame(bin_cm$record_level_cm)
a<-names(Palyginimo)
a<-a[c(1:6,12,13,16,17,18,22)]
Palyginimo<-Palyginimo[,which(names(Palyginimo) %in% a)]
library(MLmetrics)
Palyginimo$AUC<-AUC(predicted_value, expected_value)
library(dgof)
Palyginimo$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
Palyginimo$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
Palyginimo$Error_rate<-1-Palyginimo$Accuracy
Palyginimo$Type_I_err<-Palyginimo$Pred_0_Ref_1/(Palyginimo$Pred_0_Ref_1+Palyginimo$Pred_1_Ref_1)
Palyginimo$Type_II_err<-Palyginimo$Pred_1_Ref_0/(Palyginimo$Pred_1_Ref_0+Palyginimo$Pred_0_Ref_0)
Palyginimo$MCC<-((Palyginimo$Pred_0_Ref_0*Palyginimo$Pred_1_Ref_1)-(Palyginimo$Pred_1_Ref_0*Palyginimo$Pred_0_Ref_1))/
  sqrt(as.numeric(Palyginimo$Pred_0_Ref_0+Palyginimo$Pred_1_Ref_0)*as.numeric(Palyginimo$Pred_0_Ref_0+Palyginimo$Pred_0_Ref_1)*as.numeric(Palyginimo$Pred_1_Ref_1+Palyginimo$Pred_1_Ref_0)*as.numeric((Palyginimo$Pred_1_Ref_1+Palyginimo$Pred_0_Ref_1)))
Palyginimo$G_mean<-sqrt(as.numeric(Palyginimo$Recall)*as.numeric(Palyginimo$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
Palyginimo$Gini<-2*Palyginimo$AUC-1
Palyginimo$Modelis<-"LDA (linear)"

############################################################################################
#                       GLM 
############################################################################################

#REG MODEL
reg_model<-glm(TARGET~.,  data=train_data, family = binomial(link = 'logit'))
reg_model
summary(reg_model)


a_names<-"none"
a_names<-a_names[-1]

start.time<-Sys.time()
for (i in (1:dim(train_data)[2])){
  print(i)
  a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
  a_value<-as.numeric(a_order[1])
  if (a_value==1){
    a_value<-as.numeric(a_order[2])
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_data) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_data[,-c(b_names)], family = binomial(link = 'logit'))
    }}
  else{
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_data) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_data[,-c(b_names)], family = binomial(link = 'logit'))}
  }
}

summary(reg_model)$coefficients
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken
summary(reg_model)

#PREDICT
pred<-predict(reg_model,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$LG_basic<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
library(MLmetrics)
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"LG basic"
Palyginimo<-rbind(Palyginimo, New_row_pal)

#VAR IMPORTANCE
library(tidyverse)
library(caret)
coef(reg_model)
coef_reg_model<-as.data.frame(summary(reg_model)$coef[,1])
names(coef_reg_model)<-'reiksme'
coef_reg_model$mod<-abs(as.numeric(coef_reg_model$reiksme))
coef_reg_model$pav<-row.names(coef_reg_model)
coef_reg_model$pav<-row.names(coef_reg_model)

library(caret)
aa<-varImp(reg_model, scale = FALSE)
aa$pav<-row.names(aa)
#roc_imp <- filterVarImp(x = train_data[, -1], y = train_data$TARGET)
#head(roc_imp)
# https://topepo.github.io/caret/variable-importance.html
#write.csv(varImp(reg_model, scale = FALSE), 'C:/Users/Dovile/Desktop/Reg_iportance.csv')
#write.csv(roc_imp, 'C:/Users/Dovile/Desktop/Reg_iportance2.csv')
library(dplyr)
coef_reg_model<-left_join(coef_reg_model, aa, by = 'pav')
names(coef_reg_model)[4]<-"Var_imp"
#https://topepo.github.io/caret/variable-importance.html

#https://stats.stackexchange.com/questions/464803/variable-importance-logistic-and-random-forest
#If you like the variable importance to reflect how useful the variable is at predicting correctly, 
#I think a fairer comparison might be change in deviance, so we can try something like:
v_glm = anova(reg_model)[-1,2,drop=FALSE]
v_glm = v_glm[order(v_glm[,1]),drop=FALSE,]
v_glm[,1] = 100*v_glm[,1]/max(v_glm[,1])
barplot(t(v_glm),horiz=FALSE,main="glm_deviance",las=2.5)
v_glm$pav<-row.names(v_glm)
#
coef_reg_model<-left_join(coef_reg_model, v_glm, by = 'pav')
names(coef_reg_model)[5]<-"v_glm"


#The list of importance
coef_reg_model<-coef_reg_model[order(coef_reg_model$mod, decreasing = TRUE),]
start.time<-Sys.time()
reg_model_coef<-glm(TARGET~.,  data=train_data[,c(1,which(colnames(train_data) %in% coef_reg_model[1:30,'pav']))], family = binomial(link = 'logit'))
summary(reg_model_coef)

pred<-predict(reg_model_coef,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$LG_Coefficients<-predicted_value

bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"LG Coefficients"
Palyginimo<-rbind(Palyginimo, New_row_pal)

coef_reg_model<-coef_reg_model[order(coef_reg_model$Var_imp, decreasing = TRUE),]
reg_model_var<-glm(TARGET~.,  data=train_data[,c(1,which(colnames(train_data) %in% coef_reg_model[1:30,'pav']))], family = binomial(link = 'logit'))
summary(reg_model_var)
pred<-predict(reg_model_var,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$LG_VarImport<-predicted_value

bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"LG VarImport"
Palyginimo<-rbind(Palyginimo, New_row_pal)


coef_reg_model<-coef_reg_model[order(coef_reg_model$v_glm, decreasing = TRUE),]
reg_model_VarAnova<-glm(TARGET~.,  data=train_data[,c(1,which(colnames(train_data) %in% coef_reg_model[1:30,'pav']))], family = binomial(link = 'logit'))
summary(reg_model_VarAnova)

pred<-predict(reg_model_VarAnova,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$LG_VarAnova<-predicted_value

bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"LG VarAnova"
Palyginimo<-rbind(Palyginimo, New_row_pal)

########################################################################################################################
#                                               DECISION TREE
####################################################################################################################

library(DAAG)
library(party)
library(rpart)
library(rpart.plot)
library(mlbench)
library(caret)
library(pROC)
library(tree)

set.seed(1234)
#Tree Classification CART.
tree <- rpart(TARGET~.,data=train_data) 
rpart.plot(tree)
printcp(tree)

#tree <- rpart(TRUE_STATUS~.,data=train_2,cp=0.06) #depends on 0.06 on root node error rel error https://www.r-bloggers.com/2021/04/decision-trees-in-r/
predicted_value<-predict(tree, test_data, type = "vector")
predicted_value<-ifelse(predicted_value==1,0,1)
predicted_value<-as.factor(predicted_value)
Predicted_values$DT<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
library(MLmetrics)
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"DT"
Palyginimo<-rbind(Palyginimo, New_row_pal)

########################################################################################################################
#                                               RANDOM FOREST
####################################################################################################################
#https://www.geeksforgeeks.org/random-forest-approach-in-r-programming/

library(caTools)
library(randomForest)
set.seed(120)  # Setting seed
classifier_RF = randomForest(x = train_data[-1],
                             y = train_data$TARGET,
                             ntree = 500)

classifier_RF
predicted_value = predict(classifier_RF, newdata = test_data[-1])
Predicted_values$RF_basic<-predicted_value

table(predicted_value)
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"RF basic"

Palyginimo<-rbind(Palyginimo, New_row_pal)

plot(classifier_RF)
RF_import<-as.data.frame(importance(classifier_RF))

varImpPlot(classifier_RF)

RF_import$pav<-row.names(RF_import)
RF_import<-RF_import[order(RF_import$MeanDecreaseGini, decreasing = TRUE),]
train_dataRF<-train_data[,c(1,which(colnames(train_data) %in% RF_import[1:30,'pav']))]

library(randomForest)
set.seed(120)  # Setting seed
classifier_RF_import = randomForest(x = train_dataRF[-c(1)],
                                    y = train_data$TARGET,
                                    ntree = 300)

classifier_RF_import
predicted_value = predict(classifier_RF_import, newdata = test_data[-1])
Predicted_values$RF_less_features<-predicted_value

bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"RF less features"
Palyginimo<-rbind(Palyginimo, New_row_pal)
plot(classifier_RF)
#RF_import<-as.data.frame(importance(classifier_RF))
varImpPlot(classifier_RF)

########################################################################################################################
#                                                     XGBOOST
########################################################################################################################

library(xgboost) # for xgboost
library(tidyverse) # general utility functions


X = data.matrix(train_data[,-c(1)])
X_test = data.matrix(test_data[,-c(1)])

#labels
y<-as.matrix(train_data$TARGET)
y_test<-as.matrix(test_data$TARGET)


xgb_train <- xgboost::xgb.DMatrix(data = X, label = y)
xgb_test <- xgboost::xgb.DMatrix(data = X_test, label = y_test)

set.seed(120)

xgb <- xgboost(data = xgb_train, # the data   
               nround = 300, # max number of boosting iterations
               objective = "binary:logistic")  # the objective function

#max_depth [default=6]
#https://xgboost.readthedocs.io/en/stable/parameter.html

y_pred <- predict(xgb, X_test)
print(length(y_pred))
print(length(y_test))

predicted_value<-ifelse(y_pred>0.5,1,0)
predicted_value<-as.factor(predicted_value)
Predicted_values$XGBoost_Binary<-predicted_value

library(pROC)
roc_object <- roc(as.numeric(expected_value), as.numeric(predicted_value))
auc(roc_object)

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(pROC)
roc_object <- roc(as.numeric(expected_value), as.numeric(predicted_value))
auc(roc_object)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"XGBoost Binary"
Palyginimo<-rbind(Palyginimo, New_row_pal)

set.seed(120)
xgb_softmax <- xgboost(data = xgb_train, # the data   
                       nround = 300, # max number of boosting iterations uztektu 50
                       objective = "multi:softmax",
                       num_class = 2)  # the objective function

y_pred <- predict(xgb_softmax, X_test)
print(length(y_pred))
print(length(y_test))

predicted_value<-ifelse(y_pred>0.5,1,0)
predicted_value<-as.factor(predicted_value)
Predicted_values$XGBoost_Softmax<-predicted_value

library(pROC)
roc_object <- roc(as.numeric(expected_value), as.numeric(predicted_value))
auc(roc_object)
####
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(pROC)
roc_object <- roc(as.numeric(expected_value), as.numeric(predicted_value))
auc(roc_object)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"XGBoost Softmax"
Palyginimo<-rbind(Palyginimo, New_row_pal)

#####imortance

importance_matrix <- xgb.importance(model = xgb)
print(importance_matrix)
xgb.plot.importance(importance_matrix = importance_matrix[1:30])

####kuris geriausias 10 pagrindiniu kintamuju
importance_matrix <-importance_matrix [order(importance_matrix$Gain, decreasing = TRUE),]
a_names<-importance_matrix$Feature[1:30]

train_data2<-train_data[,c(which(colnames(train_data) %in% a_names))]
test_data2<-test_data[,c(which(colnames(test_data) %in% a_names))]
train_data2$LF_UAB<-as.numeric(train_data2$LF_UAB)
train_data2$Director_owner_the_same<-as.numeric(train_data2$Director_owner_the_same)
test_data2$LF_UAB<-as.numeric(test_data2$LF_UAB)
test_data2$Director_owner_the_same<-as.numeric(test_data2$Director_owner_the_same)


X2<-as.matrix(train_data2)
X2_test<-as.matrix(test_data2)

xgb_train2 <- xgboost::xgb.DMatrix(data = X2, label = y)
xgb_test2 <- xgboost::xgb.DMatrix(data = X2_test, label = y_test)

set.seed(120)

xgb_2 <- xgboost(data = xgb_train2, # the data   
                 nround = 300, # max number of boosting iterations
                 objective = "binary:logistic")  # the objective function

#max_depth [default=6]
#https://xgboost.readthedocs.io/en/stable/parameter.html

y_pred <- predict(xgb_2, X2_test)
print(length(y_pred))
print(length(y_test))

predicted_value<-ifelse(y_pred>0.5,1,0)
predicted_value<-as.factor(predicted_value)
Predicted_values$XGBoost_less_feat_Binary<-predicted_value

library(pROC)
roc_object <- roc(as.numeric(expected_value), as.numeric(predicted_value))
auc(roc_object)
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"XGBoost less features Binary"
Palyginimo<-rbind(Palyginimo, New_row_pal)

####XGB_SOFT
importance_matrix <- xgb.importance(model = xgb_softmax)
print(importance_matrix)
xgb.plot.importance(importance_matrix = importance_matrix[1:30])

importance_matrix <-importance_matrix [order(importance_matrix$Gain, decreasing = TRUE),]
a_names<-importance_matrix$Feature[1:30]

train_data2<-train_data_num[,c(which(colnames(train_data_num) %in% a_names))]
test_data2<-test_data_num[,c(which(colnames(test_data_num) %in% a_names))]

X2<-as.matrix(train_data2)
X2_test<-as.matrix(test_data2)

xgb_train2 <- xgboost::xgb.DMatrix(data = X2, label = y)
xgb_test2 <- xgboost::xgb.DMatrix(data = X2_test, label = y_test)

set.seed(120)
xgb_soft_less <- xgboost(data = xgb_train2, # the data   
                         nround = 300, # max number of boosting iterations
                         objective = "multi:softmax",
                         num_class = 2)  # the objective function

#max_depth [default=6]
#https://xgboost.readthedocs.io/en/stable/parameter.html

y_pred <- predict(xgb_soft_less, X2_test)
print(length(y_pred))
print(length(y_test))

predicted_value<-ifelse(y_pred>0.5,1,0)
predicted_value<-as.factor(predicted_value)
Predicted_values$XGBoost_less_feat_Softmax<-predicted_value
library(pROC)
roc_object <- roc(as.numeric(expected_value), as.numeric(predicted_value))
auc(roc_object)
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"XGBoost less features Softmax"
Palyginimo<-rbind(Palyginimo, New_row_pal)


###################################################################
# NAIVE
############################################################
library(e1071)
set.seed(120)
naive.fit=naiveBayes(TARGET~.,data=train_data)
summary(naive.fit)

# Predicting test set results
predicted_value=predict(naive.fit,test_data)

Predicted_values$Naive_bayes<-predicted_value
library(pROC)
roc_object <- roc(as.numeric(expected_value), as.numeric(predicted_value))
auc(roc_object)
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"Naive Bayes"
Palyginimo<-rbind(Palyginimo, New_row_pal)


#########################################################################################################################
#                                                               Knn
#########################################################################################################################
library(class)
knn_3<-knn(train_data[,-c(1)], test_data[,-c(1)], train_data$TARGET, k = 3)
predicted_value <- as.factor(c(knn_3))
Predicted_values$Knn_3<-predicted_value
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"Knn-3"

Palyginimo<-rbind(Palyginimo, New_row_pal)

#######################K5
library(class)
knn_5<-knn(train_data[,-c(1)], test_data[,-c(1)], train_data$TARGET, k = 5)
predicted_value <- as.factor(c(knn_5))
Predicted_values$Knn_5<-predicted_value
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"Knn-5"

Palyginimo<-rbind(Palyginimo, New_row_pal)

#########################K7
knn_7<-knn(train_data[,-c(1)], test_data[,-c(1)], train_data$TARGET, k = 7)
predicted_value <- as.factor(c(knn_7))
Predicted_values$Knn_7<-predicted_value
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"Knn-7"
Palyginimo<-rbind(Palyginimo, New_row_pal)

#########################################################################################################################
#                                                               ADA Boost
#########################################################################################################################
library(tidyverse)
library(caret)
library(adabag)

#ada_model<-train(TARGET~., method='AdaBoost.M1', data= train_data )

ada_model<-boosting(TARGET~., data=train_data, boos=TRUE, mfinal=50)
pred = predict(ada_model, test_data)
predicted_value <- factor(c(pred$class))
Predicted_values$Ada_boost<-predicted_value
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"Adaboost"
Palyginimo<-rbind(Palyginimo, New_row_pal)



#########################################################################################################################
#                                                              ANN 
#########################################################################################################################
##NO FACTOR ATRIBUTES

library(tidyverse)
library(keras)
#install_keras()
library(tensorflow)
#install_tensorflow()
library(DMwR)
#install.packages(c("zoo","xts","quantmod")) ## and perhaps mode
#install.packages( "Path/To/DMwR_0.4.1.tar.gz", repos=NULL, type="source" )
#install.packages("DMwR_0.4.1.tar.gz")
#install.packages("remotes")
#library(remotes)
#remotes::install_github("cran/DMwR")
#use_condaenv("r-tensorflow")
#install.packages('devtools')
#library(devtools)
#devtools::install_github("rstudio/tensorflow")

########

X_train<- train_data_num[, -c(1)]
y_train <- to_categorical(as.numeric(train_data_num$TARGET)-1)
X_test <- test_data_num[, -c(1)]
y_test <- to_categorical(as.numeric(test_data_num$TARGET)-1)
X_train <- as.matrix(X_train)
X_test <- as.matrix(X_test)

set.seed(120)
model <- keras_model_sequential() 

model %>% 
  layer_dense(units = 100, activation = 'relu', input_shape = ncol(X_train)) %>% 
  layer_dropout(rate = 0.4) %>% 
  layer_dense(units = 50, activation = 'relu') %>%
  layer_dropout(rate = 0.2) %>%
  layer_dense(units = 25, activation = 'relu') %>%
  layer_dropout(rate = 0.2) %>%
  layer_dense(units = 2, activation = 'sigmoid')

model %>% compile(
  loss = 'binary_crossentropy',
  optimizer = 'adam',
  metrics = c('accuracy')
)

model %>% fit(
  X_train, y_train, 
  epochs = 50, 
  batch_size = 32,
  validation_split = 0.2
)

model %>% save_model_hdf5("model_ANN_both.h5")

model %>% evaluate(X_test, y_test)

pred <- model %>% predict(X_test) %>% k_argmax() %>% k_get_value()
predicted_value<-as.factor(pred)
Predicted_values$ANN3<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"ANN-3"

Palyginimo<-rbind(Palyginimo, New_row_pal) 

####################################################
set.seed(120)
model2 <- keras_model_sequential() 

model2 %>% 
  layer_dense(units = 30, activation = 'relu', input_shape = ncol(X_train)) %>% 
  layer_dropout(rate = 0.4) %>% 
  layer_dense(units = 10, activation = 'relu') %>%
  layer_dropout(rate = 0.2) %>%
  layer_dense(units = 2, activation = 'sigmoid')

model2 %>% compile(
  loss = 'binary_crossentropy',
  optimizer = 'adam',
  metrics = c('accuracy')
)

model2 %>% fit(
  X_train, y_train, 
  epochs = 50, 
  batch_size = 32,
  validation_split = 0.2
)

model2 %>% save_model_hdf5("model_2ANN_both.h5")

model2 %>% evaluate(X_test, y_test)

pred <- model2 %>% predict(X_test) %>% k_argmax() %>% k_get_value()
predicted_value<-as.factor(pred)
Predicted_values$ANN2<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"ANN-2"

Palyginimo<-rbind(Palyginimo, New_row_pal)

####################################################
set.seed(120)
model1 <- keras_model_sequential() 

model1 %>% 
  layer_dense(units = 24, activation = 'relu', input_shape = ncol(X_train)) %>% 
  layer_dropout(rate = 0.2) %>%
  layer_dense(units = 2, activation = 'sigmoid')

model1 %>% compile(
  loss = 'binary_crossentropy',
  optimizer = 'adam',
  metrics = c('accuracy')
)

model1 %>% fit(
  X_train, y_train, 
  epochs = 50, 
  batch_size = 32,
  validation_split = 0.2
)

model1 %>% save_model_hdf5("model_1ANN_both.h5")

model1 %>% evaluate(X_test, y_test)

pred <- model1 %>% predict(X_test) %>% k_argmax() %>% k_get_value()
predicted_value<-as.factor(pred)
Predicted_values$ANN1<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"ANN-1"

Palyginimo<-rbind(Palyginimo, New_row_pal)


####################################################
set.seed(120)
model4 <- keras_model_sequential() 

model4 %>% 
  layer_dense(units = 100, activation = 'relu', input_shape = ncol(X_train)) %>% 
  layer_dropout(rate = 0.4) %>%
  layer_dense(units = 50, activation = 'relu') %>%
  layer_dropout(rate = 0.2) %>%
  layer_dense(units = 25, activation = 'relu') %>%
  layer_dropout(rate = 0.2) %>%
  layer_dense(units = 5, activation = 'relu') %>%
  layer_dropout(rate = 0.2) %>%
  layer_dense(units = 2, activation = 'sigmoid')

model4 %>% compile(
  loss = 'binary_crossentropy',
  optimizer = 'adam',
  metrics = c('accuracy')
)

model4 %>% fit(
  X_train, y_train, 
  epochs = 50, 
  batch_size = 32,
  validation_split = 0.2
)

model4 %>% save_model_hdf5("model_4ANN_both.h5")

model4 %>% evaluate(X_test, y_test)

pred <- model4 %>% predict(X_test) %>% k_argmax() %>% k_get_value()
predicted_value<-as.factor(pred)
Predicted_values$ANN4<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"ANN-4"

Palyginimo<-rbind(Palyginimo, New_row_pal)

#########################################################################################################################
#                                                              ELM
#                                             The Extreme Learning Machine Algorithm
#########################################################################################################################
library(elmNNRcpp)
set.seed(120)
ELM_model<-elm(TARGET~., train_data, nhid=150, actfun="sig")
pred<-predict(ELM_model, newdata = test_data[,-1])
predicted_value<-as.factor(pred)
Predicted_values$ELM_150<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"ELM_150"

Palyginimo<-rbind(Palyginimo, New_row_pal)

###################################################################################
library(elmNNRcpp)
set.seed(120)
ELM_model<-elm(TARGET~., train_data, nhid=100, actfun="sig")
pred<-predict(ELM_model, newdata = test_data[,-1])
predicted_value<-as.factor(pred)
Predicted_values$ELM_100<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"ELM_100"

Palyginimo<-rbind(Palyginimo, New_row_pal)

###################################################################################
library(elmNNRcpp)
set.seed(120)
ELM_model<-elm(TARGET~., train_data, nhid=200, actfun="sig")
pred<-predict(ELM_model, newdata = test_data[,-1])
predicted_value<-as.factor(pred)
Predicted_values$ELM_200<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"ELM_200"

Palyginimo<-rbind(Palyginimo, New_row_pal)

###################################################################################
library(elmNNRcpp)
set.seed(120)
ELM_model<-elm(TARGET~., train_data, nhid=300, actfun="sig")
pred<-predict(ELM_model, newdata = test_data[,-1])
predicted_value<-as.factor(pred)
Predicted_values$ELM_300<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"ELM_300"

Palyginimo<-rbind(Palyginimo, New_row_pal)


#########################################################################################################################
#                                                              CNN
#########################################################################################################################
##NO FACTOR ATRIBUTES
################ library
library(lattice)
library(tidyverse)
library(keras)
library(grid)
library(tensorflow)
library(DMwR)

#~~~~~~~~~~~~~~~~~~~~~DATA

xtrain = as.matrix(train_data_num[, -1])
ytrain = as.matrix(train_data_num[, 1])
xtest = as.matrix(test_data_num[, -1])
ytest = as.matrix(test_data_num[, 1]) 

dim(xtrain) # 101129    100
dim(ytrain) # 101129      1


xtrain = array(xtrain, dim = c(nrow(xtrain), 100, 1))
xtest = array(xtest, dim = c(nrow(xtest), 100, 1))
ytrain = to_categorical(ytrain)

dim(xtrain)
dim(ytrain)

#__________________models 1-------------------------
set.seed(120)

model5 = keras_model_sequential() %>%
  layer_conv_1d(filters=64, kernel_size=2, input_shape=c(100,1), activation="relu") %>%
  layer_conv_1d(filters = 32, kernel_size = c(2), activation = "relu") %>% 
  layer_max_pooling_1d(2) %>% 
  layer_dropout(rate = 0.2) %>% 
  layer_conv_1d(filters = 32, kernel_size = c(2), activation = "relu") %>% 
  layer_conv_1d(filters = 16, kernel_size = c(2), activation = "relu") %>% 
  layer_max_pooling_1d(2) %>% 
  layer_dropout(rate = 0.2) %>% 
  layer_conv_1d(filters = 16, kernel_size = c(2), activation = "relu") %>% 
  layer_max_pooling_1d(2) %>% 
  layer_flatten() %>%
  layer_dropout(rate = 0.2) %>% 
  layer_dense(units = 2, activation = "softmax")

model5 %>% compile(loss = 'binary_crossentropy',
                   optimizer = 'adam',
                   metrics = 'accuracy')

model5 %>% summary()

#model %>% fit(xtrain, ytrain, epochs=100, verbose=0) #verbose nerodys eigos

model5 %>% fit(
  xtrain, ytrain, 
  epochs = 50, 
  batch_size = 32,
  validation_split = 0.2
)

scores = model5 %>% evaluate(xtrain, ytrain, verbose = 0) 
print(scores)

ypred = model5 %>% predict(xtest)
#head(ypred)
yhat = data.frame("ypred" = ifelse(max.col(ypred[ ,1:2])==1, "0", "1"))
model5 %>% save_model_hdf5("model_CNN5_both.h5")

predicted_value<-as.factor(yhat$ypred)
Predicted_values$CNN_5<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"CNN-5"
Palyginimo<-rbind(Palyginimo, New_row_pal)

#__________________models 2-------------------------
set.seed(120)

model6 = keras_model_sequential() %>%
  layer_conv_1d(filters=32, kernel_size=2, input_shape=c(100,1), activation="relu") %>%
  layer_conv_1d(filters = 16, kernel_size = c(2), activation = "relu") %>% 
  layer_max_pooling_1d(2) %>% 
  layer_dropout(rate = 0.2) %>% 
  layer_conv_1d(filters = 8, kernel_size = c(2), activation = "relu") %>% 
  layer_max_pooling_1d(2) %>% 
  layer_flatten() %>%
  layer_dropout(rate = 0.2) %>% 
  layer_dense(units = 2, activation = "softmax")

model6 %>% compile(loss = 'binary_crossentropy',
                   optimizer = 'adam',
                   metrics = 'accuracy')

model6 %>% summary()

#model %>% fit(xtrain, ytrain, epochs=100, verbose=0) #verbose nerodys eigos

model6 %>% fit(
  xtrain, ytrain, 
  epochs = 50, 
  batch_size = 32,
  validation_split = 0.2
)

scores = model6 %>% evaluate(xtrain, ytrain, verbose = 0) 
print(scores)

ypred = model6 %>% predict(xtest)
#head(ypred)
yhat = data.frame("ypred" = ifelse(max.col(ypred[ ,1:2])==1, "0", "1"))
model6 %>% save_model_hdf5("model_CNN3_both.h5")

predicted_value<-as.factor(yhat$ypred)
Predicted_values$CNN_3<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"CNN-3"
Palyginimo<-rbind(Palyginimo, New_row_pal)

#__________________models 3-------------------------
set.seed(120)

model7 = keras_model_sequential() %>%
  layer_conv_1d(filters=16, kernel_size=2, input_shape=c(100,1), activation="relu") %>%
  layer_max_pooling_1d(2) %>% 
  layer_dropout(rate = 0.2) %>% 
  layer_conv_1d(filters = 8, kernel_size = c(2), activation = "relu") %>% 
  layer_max_pooling_1d(2) %>% 
  layer_flatten() %>%
  layer_dropout(rate = 0.2) %>% 
  layer_dense(units = 2, activation = "softmax")

model7 %>% compile(loss = 'binary_crossentropy',
                   optimizer = 'adam',
                   metrics = 'accuracy')

model7 %>% summary()

#model %>% fit(xtrain, ytrain, epochs=100, verbose=0) #verbose nerodys eigos

model7 %>% fit(
  xtrain, ytrain, 
  epochs = 50, 
  batch_size = 32,
  validation_split = 0.2
)

scores = model7 %>% evaluate(xtrain, ytrain, verbose = 0) 
print(scores)

ypred = model7 %>% predict(xtest)
#head(ypred)
yhat = data.frame("ypred" = ifelse(max.col(ypred[ ,1:2])==1, "0", "1"))
model7 %>% save_model_hdf5("model_CNN2_both.h5")

predicted_value<-as.factor(yhat$ypred)
Predicted_values$CNN_2<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"CNN-2"
Palyginimo<-rbind(Palyginimo, New_row_pal)


################################################
#SVM
############################################
start.time<-Sys.time()
## SVM-Polynomial

library(e1071)
library(caret)
library(NLP)
library(tm)
library(readr)
library(Hmisc)
poly.svmfit=svm(TARGET~.,data=train_data_num,kernel="polynomial")
predicted_value=predict(poly.svmfit,test_data_num[,-c(1)])
pred<-predicted_value
predicted_value<-as.data.frame(pred)
predicted_value<-as.factor(predicted_value$pred)
Predicted_values$SVM_poly<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"SVM polynomial"

Palyginimo<-rbind(Palyginimo, New_row_pal) 

library(e1071)
radial.svmfit=svm(TARGET~.,data=train_data_num,kernel="radial")
predicted_value2=predict(radial.svmfit,test_data_num[,-c(1)])
#Predicted_values$SVM_radial<-predicted_value

predicted_value<-as.data.frame(predicted_value2)
predicted_value<-as.factor(predicted_value$predicted_value2)
Predicted_values$SVM_radial<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"SVM radial"
Palyginimo<-rbind(Palyginimo, New_row_pal) 



#########################################################################################################################
#                                                       unsupervised learning
#########################################################################################################################

#########################################################################################################################
#                                                              K-MEANS
#########################################################################################################################

#https://stackoverflow.com/questions/20621250/simple-approach-to-assigning-clusters-for-new-data-after-k-means-clustering
#https://www.statology.org/elbow-method-in-r/#:~:text=One%20of%20the%20most%20common%20ways%20to%20choose%20a%20value,bend%20appears%20in%20the%20plot.
#https://towardsdatascience.com/a-continuously-updating-k-means-algorithm-89584ca7ee63
#Calculate the distance of a new data point from all the cluster centers and find the minimum of those distances.
#Check if the minimum distance is less than the threshold value. If true, we assign the new data point to the corresponding cluster. Then, update the cluster center of that cluster.
#If False, create a new cluster and assign the new data point as its center. Also, the data point becomes a part of the cluster.
#rWe can repeat the same steps with a list of new data points to update our model. Our model now is better than previous because it has seen more data.

library("flexclust")
set.seed(120)
cl1 = kcca(train_data_u2, k=2, kccaFamily("kmeans"))

pred <- predict(cl1, newdata=test_data_u2)
predicted_value<-as.data.frame(pred)
table(predicted_value$pred, test_data_u$TARGET)
prop.table(table(predicted_value$pred, test_data_u$TARGET),2)

predicted_value$pred_test<-ifelse(predicted_value$pred ==1, 0,1)
predicted_value<-as.factor(predicted_value$pred)
Predicted_values$Kmeans<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"Kmeans"
Palyginimo<-rbind(Palyginimo, New_row_pal)

#########################################################################################################################
#                                                 ISOLATION FOREST
#########################################################################################################################

library(isotree)
iso_t <- isolation.forest(as.matrix(train_data_u2))
pred <- predict(iso_t, as.matrix(test_data_u2))
predicted_value <- as.factor(ifelse(pred > 0.5, 1, 0))
Predicted_values$Iso_tree<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"Isotree"
Palyginimo<-rbind(Palyginimo, New_row_pal)


#########################################################################################################################
#                                                ONE CLASS SVM
#########################################################################################################################
start.time<-Sys.time()

train_data_one<-subset(train_data_u, TARGET == 0)
train_data_one<-train_data_one[,-c(1)]

library(e1071)
library(caret)
library(NLP)
library(tm)
library(readr)
library(Hmisc)
svm.model <- svm(train_data_one, y=NULL, type='one-classification', nu=0.10, scale=FALSE, kernel="radial")

pred <- predict(svm.model, test_data_u2)
table(pred)
predicted_value <- as.factor(ifelse(pred == 'TRUE', 0, 1))
Predicted_values$One_svm<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"One SVM"
Palyginimo<-rbind(Palyginimo, New_row_pal)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

#########################################################################################################################
#                                                SOM
#########################################################################################################################
library(kohonen)
library(tibble)
train_data_num <- as_tibble(train_data_num)
test_data_num <- as_tibble(test_data_num)

library(dplyr)
Train_Scaled2 <- train_data_num %>%
  select(-TARGET) %>%
  as.matrix()

trainY<-as.factor(train_data_num$TARGET)
trainY<-factor(trainY)

newData2 <- test_data_num %>%
  select(-TARGET) %>%
  as.matrix()

set.seed(223)
map1 <- xyf(Train_Scaled2,
            classvec2classmat(factor(trainY)),
            grid = somgrid(5, 5, "hexagonal"),
            rlen = 500)
plot(map1, type='codes',palette.name = rainbow)

par(mfrow = c(1,2))
plot(map1,
     type = 'codes',
     main = c("Codes X", "Codes Y"))
map1.hc <- cutree(hclust(dist(map1$codes[[2]])), 2)
add.cluster.boundaries(map1, map1.hc)
par(mfrow = c(1,1))

nodeCols <- c("cyan3",  "purple")
plot(map1, type = "mapping", pch = 21,
     bg = nodeCols[as.numeric(train_data_num$TARGET)],
     shape = "straight", bgcol = "lightgrey")

#SAVE BEFORE
test<-test_data_num
test[,1] <- 0
testXY <- list(independent = newData2, dependent = test[,1])


pred <- predict(map1, newdata = newData2, whatmap = 1)

nodeCols <- c("cyan3",  "purple")
plot(map1, type = "mapping", classif = pred, pch = 21,
     bg = nodeCols[as.numeric(test_data_num$TARGET)],
     shape = "straight", bgcol = "lightgrey")

predicted_value<-pred$predictions[[2]]
Predicted_values$SOM<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"SOM"
Palyginimo<-rbind(Palyginimo, New_row_pal)

