load("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2023 01 09 VAR IMPORT/.RData")
setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2023 01 09 VAR IMPORT")

###########################RANK###########################

names(cohens_d_target)[1]<-'Feature'
cohens_d_target$effsize_MOD<-abs(cohens_d_target$effsize)

#binary naudoju ne softmax
FEATURE<-VAR_import[,c(1,5,8,10)]

cohens_d_target_II<-subset(cohens_d_target, !magnitude=='negligible')

library(dplyr)
FEATURE<-left_join(FEATURE, cohens_d_target_II[c("Feature", 'effsize_MOD', 'magnitude')], by=c('Feature'))

names(FEATURE)<-c(names(FEATURE)[1:4], paste('C_D', names(FEATURE)[5:6], sep = '_'))

kruskal_II<-subset(kruskal_target, kruskal_pvalue_if==0)
names(kruskal_II)[1]<-'Feature'

FEATURE<-left_join(FEATURE, kruskal_II[c("Feature", 'kruskal_stat_mod')], by=c('Feature'))

names(Koreliacija_target_atrinkti)[1]<-'Feature'
FEATURE<-left_join(FEATURE, Koreliacija_target_atrinkti[c("Feature", 'Corr_target_mod')], by=c('Feature'))

FEATURE_RF2<-left_join(FEATURE, RF_import2, by=c('Feature'))


x<-c(1,6,8,4,2,10, NA)
rank(x)


prank<-function(x){
  r<-rank(x)/sum(!is.na(x))
  r[is.na(x)]<-NA
  r
}
prank(x)
#prank<-function(x) ifelse(is.na(x),NA,rank(x)/sum(!is.na(x)))
for (i in (1:dim(FEATURE)[2])){
  print(names(FEATURE)[i])
  print(sum(!is.na(FEATURE[,i])))
}

FEATURE_RANK<-data.frame(FEATURE$Feature)
#FEATURE_RANK$XGB_softmax<-as.numeric(prank(FEATURE$XGB_softmax_Gain))
FEATURE_RANK$XGB_binary<-as.numeric(prank(FEATURE$XGB_binary_Gain))
FEATURE_RANK$RF<-as.numeric(prank(FEATURE$RF_MeanDecreaseGini))
FEATURE_RANK$LASSO<-as.numeric(prank(FEATURE$Lasso_import_moduliu))
FEATURE_RANK$Cohens_D<-as.numeric(prank(FEATURE$C_D_effsize_MOD))
FEATURE_RANK$Kruskal<-as.numeric(prank(FEATURE$kruskal_stat_mod))
FEATURE_RANK$Corr<-as.numeric(prank(FEATURE$Corr_target_mod))

FEATURE_RANK$SUM_ALL<-rowSums(FEATURE_RANK[,-c(1)], na.rm = TRUE)
FEATURE_RANK$SUM_NA<-rowSums(is.na(FEATURE_RANK[,1:8]))

#TOP 100
FEATURE_RANK_100<-FEATURE_RANK[,]
FEATURE_RANK_100<-FEATURE_RANK_100[order(FEATURE_RANK_100$SUM_ALL, decreasing = TRUE),]
FEATURE_RANK_100<-FEATURE_RANK_100[1:100,]

FEATURE_RANK_noNA<-subset(FEATURE_RANK, SUM_NA==0)

#################################################################
# ONLY ANALIZED FEATURES
#################################################################
FEATURE_AN<-FEATURE[,]
FEATURE_AN<-FEATURE_AN[order(FEATURE_AN$XGB_binary_Gain, decreasing = TRUE), ]
FEATURE_AN[101:972, 'XGB_binary_Gain']<-NA
FEATURE_AN<-FEATURE_AN[order(FEATURE_AN$RF_MeanDecreaseGini, decreasing = TRUE), ]
FEATURE_AN[101:972, 'RF_MeanDecreaseGini']<-NA
FEATURE_AN<-FEATURE_AN[order(FEATURE_AN$Lasso_import_moduliu, decreasing = TRUE), ]
FEATURE_AN[101:972, 'Lasso_import_moduliu']<-NA
FEATURE_AN<-FEATURE_AN[order(FEATURE_AN$C_D_effsize_MOD, decreasing = TRUE), ]
FEATURE_AN[101:972, 'C_D_effsize_MOD']<-NA
FEATURE_AN<-FEATURE_AN[order(FEATURE_AN$kruskal_stat_mod, decreasing = TRUE), ]
FEATURE_AN[101:972, 'kruskal_stat_mod']<-NA
FEATURE_AN<-FEATURE_AN[order(FEATURE_AN$Corr_target_mod, decreasing = TRUE), ]
FEATURE_AN[101:972, 'Corr_target_mod']<-NA



FEATURE_RANK_AN<-data.frame(FEATURE_AN$Feature)
FEATURE_RANK_AN$XGB_binary<-as.numeric(prank(FEATURE_AN$XGB_binary_Gain))
FEATURE_RANK_AN$RF<-as.numeric(prank(FEATURE_AN$RF_MeanDecreaseGini))
FEATURE_RANK_AN$LASSO<-as.numeric(prank(FEATURE_AN$Lasso_import_moduliu))
FEATURE_RANK_AN$Cohens_D<-as.numeric(prank(FEATURE_AN$C_D_effsize_MOD))
FEATURE_RANK_AN$Kruskal<-as.numeric(prank(FEATURE_AN$kruskal_stat_mod))
FEATURE_RANK_AN$Corr<-as.numeric(prank(FEATURE_AN$Corr_target_mod))

FEATURE_RANK_AN$SUM_ALL<-rowSums(FEATURE_RANK_AN[,-c(1)], na.rm = TRUE)
FEATURE_RANK_AN$SUM_NA<-rowSums(is.na(FEATURE_RANK_AN[,1:8]))


FEATURE_RANK_100AN<-FEATURE_RANK_AN[,]
FEATURE_RANK_100AN<-FEATURE_RANK_100AN[order(FEATURE_RANK_100AN$SUM_ALL, decreasing = TRUE),]
FEATURE_RANK_100AN<-FEATURE_RANK_100AN[1:100,]

sum(FEATURE_RANK_100AN$FEATURE_AN.Feature %in% FEATURE_RANK_100$FEATURE.Feature)
#74 sutampa


FEATURE_RANK_AN_noNA<-subset(FEATURE_RANK_AN, SUM_NA==0)


###################################
a_names<-FEATURE_RANK_100$FEATURE.Feature
a_names<-c('TARGET', a_names)

train_data_100<-train_data[, which(names(train_data) %in% a_names)]
test_data_100<-test_data[, which(names(test_data) %in% a_names)]

########################
a_names<-FEATURE_RANK_noNA$FEATURE.Feature
a_names<-c('TARGET', a_names)

train_data_noNA<-train_data[, which(names(train_data) %in% a_names)]
test_data_noNA<-test_data[, which(names(test_data) %in% a_names)]


######################################normalization#####################

df<-FEATURE
library(caret)
df<-preProcess(df, method=c("range"))
FEATURE_Norm<-predict(df, FEATURE)

sum(FEATURE_Norm$XGB_binary_Gain >= 0.01, na.rm = 'TRUE') #113
sum(FEATURE_Norm$XGB_binary_Gain >= 0.1, na.rm = 'TRUE') #6
sum(FEATURE_Norm$RF_MeanDecreaseGini > 0.045, na.rm = 'TRUE') #8  #42
sum(FEATURE_Norm$Lasso_import_moduliu >= 0.01, na.rm = 'TRUE') #9
sum(FEATURE_Norm$kruskal_stat_mod >= 0.01, na.rm = 'TRUE') #3
sum(FEATURE_Norm$Corr_target_mod >= 0.01, na.rm = 'TRUE') #27


#####################################################################
b<-colSums(FEATURE[,c(2:5,7:8)], na.rm = 'TRUE')

FEATURE_one<-FEATURE[,]
FEATURE_one$RF_MeanDecreaseGini<-FEATURE_one$RF_MeanDecreaseGini/b[2]
FEATURE_one$Lasso_import_moduliu<-FEATURE_one$Lasso_import_moduliu/b[3]
FEATURE_one$C_D_effsize_MOD<-FEATURE_one$C_D_effsize_MOD/b[4]
FEATURE_one$kruskal_stat_mod<-FEATURE_one$kruskal_stat_mod/b[5]
FEATURE_one$Corr_target_mod<-FEATURE_one$Corr_target_mod/b[6]
colSums(FEATURE_one[,c(2:5,7:8)], na.rm = 'TRUE')


sum(FEATURE_one$XGB_binary_Gain >= 0.1, na.rm = 'TRUE') #2
sum(FEATURE_one$RF_MeanDecreaseGini >= 0.1, na.rm = 'TRUE') #0
sum(FEATURE_one$Lasso_import_moduliu >= 0.1, na.rm = 'TRUE') #2
sum(FEATURE_one$kruskal_stat_mod >= 0.1, na.rm = 'TRUE') #1
sum(FEATURE_one$Corr_target_mod >= 0.1, na.rm = 'TRUE') #0

sum(FEATURE_one$XGB_binary_Gain >= 0.01, na.rm = 'TRUE') #8
sum(FEATURE_one$RF_MeanDecreaseGini >= 0.01, na.rm = 'TRUE') #8
sum(FEATURE_one$Lasso_import_moduliu >= 0.01, na.rm = 'TRUE') #18
sum(FEATURE_one$kruskal_stat_mod >= 0.01, na.rm = 'TRUE') #3
sum(FEATURE_one$Corr_target_mod >= 0.01, na.rm = 'TRUE') #23

sum(FEATURE_one$XGB_binary_Gain[1:100]) #0.73
FEATURE_one<-FEATURE_one[order(FEATURE_one$RF_MeanDecreaseGini, decreasing ='TRUE'),]
sum(FEATURE_one$RF_MeanDecreaseGini[1:100]) #0.48
sum(FEATURE_one$RF_MeanDecreaseGini[1:300]) #0.74

FEATURE_one<-FEATURE_one[order(FEATURE_one$Lasso_import_moduliu, decreasing ='TRUE'),]
sum(FEATURE_one$Lasso_import_moduliu[1:100], na.rm = 'TRUE') #1
FEATURE_one<-FEATURE_one[order(FEATURE_one$kruskal_stat_mod, decreasing ='TRUE'),]
sum(FEATURE_one$kruskal_stat_mod[1:100], na.rm = 'TRUE') #0.52
FEATURE_one<-FEATURE_one[order(FEATURE_one$Corr_target_mod, decreasing ='TRUE'),]
sum(FEATURE_one$Corr_target_mod[1:100], na.rm = 'TRUE') #0.8727
FEATURE_one<-FEATURE_one[order(FEATURE_one$C_D_effsize_MOD, decreasing ='TRUE'),]
sum(FEATURE_one$kruskal_stat_mod[1:14], na.rm = 'TRUE') #0.25

#SUM

######VAR MOST change##############
FEATURE_change<-FEATURE[,]

FEATURE_change<-FEATURE_change[order(FEATURE_change$XGB_binary_Gain, decreasing = TRUE),]
FEATURE_change$XGB_change<-NA

for (i in 2:nrow(FEATURE_change)){
  if(!is.na(FEATURE_change$XGB_binary_Gain[i])){
    FEATURE_change$XGB_change[i]<-1-(FEATURE_change$XGB_binary_Gain[i]/FEATURE_change$XGB_binary_Gain[i-1])
  }
}

plot(FEATURE_change$XGB_change)

FEATURE_change<-FEATURE_change[order(FEATURE_change$RF_MeanDecreaseGini, decreasing = TRUE),]
FEATURE_change$RF_change<-NA

for (i in 2:nrow(FEATURE_change)){
  if(!is.na(FEATURE_change$RF_MeanDecreaseGini[i])){
    FEATURE_change$RF_change[i]<-1-(FEATURE_change$RF_MeanDecreaseGini[i]/FEATURE_change$RF_MeanDecreaseGini[i-1])
  }
}

plot(FEATURE_change$RF_change)

FEATURE_change<-FEATURE_change[order(FEATURE_change$Lasso_import_moduliu, decreasing = TRUE),]
FEATURE_change$LASSO_change<-NA

for (i in 2:nrow(FEATURE_change)){
  if(!is.na(FEATURE_change$Lasso_import_moduliu[i])){
    FEATURE_change$LASSO_change[i]<-1-(FEATURE_change$Lasso_import_moduliu[i]/FEATURE_change$Lasso_import_moduliu[i-1])
  }
}

plot(FEATURE_change$LASSO_change)

FEATURE_change<-FEATURE_change[order(FEATURE_change$kruskal_stat_mod, decreasing = TRUE),]
FEATURE_change$Kruskal_change<-NA

for (i in 2:nrow(FEATURE_change)){
  if(!is.na(FEATURE_change$kruskal_stat_mod[i])){
    FEATURE_change$Kruskal_change[i]<-1-(FEATURE_change$kruskal_stat_mod[i]/FEATURE_change$kruskal_stat_mod[i-1])
  }
}

plot(FEATURE_change$Kruskal_change)


FEATURE_change<-FEATURE_change[order(FEATURE_change$Corr_target_mod, decreasing = TRUE),]
FEATURE_change$Corr_change<-NA

for (i in 2:nrow(FEATURE_change)){
  if(!is.na(FEATURE_change$Corr_target_mod[i])){
    FEATURE_change$Corr_change[i]<-1-(FEATURE_change$Corr_target_mod[i]/FEATURE_change$Corr_target_mod[i-1])
  }
}

plot(FEATURE_change$Corr_change)

FEATURE_change<-FEATURE_change[order(FEATURE_change$C_D_effsize_MOD, decreasing = TRUE),]
FEATURE_change$CD_change<-NA

for (i in 2:nrow(FEATURE_change)){
  if(!is.na(FEATURE_change$C_D_effsize_MOD[i])){
    FEATURE_change$CD_change[i]<-1-(FEATURE_change$C_D_effsize_MOD[i]/FEATURE_change$C_D_effsize_MOD[i-1])
  }
}

plot(FEATURE_change$CD_change)

write.csv(FEATURE_change, 'C:/Users/Dovile/Desktop/feature.csv')

################################################
#2RF
######################################
for (i in (1:dim(FEATURE_RF2)[2])){
  print(names(FEATURE_RF2)[i])
  print(sum(!is.na(FEATURE_RF2[,i])))
}

FEATURE_RANK_RF<-data.frame(FEATURE_RF2$Feature)
#FEATURE_RANK$XGB_softmax<-as.numeric(prank(FEATURE_RF2$XGB_softmax_Gain))
FEATURE_RANK_RF$XGB_binary<-as.numeric(prank(FEATURE_RF2$XGB_binary_Gain))
FEATURE_RANK_RF$RF_GINI<-as.numeric(prank(FEATURE_RF2$RF_MeanDecreaseGini))
FEATURE_RANK_RF$LASSO<-as.numeric(prank(FEATURE_RF2$Lasso_import_moduliu))
FEATURE_RANK_RF$Cohens_D<-as.numeric(prank(FEATURE_RF2$C_D_effsize_MOD))
FEATURE_RANK_RF$Kruskal<-as.numeric(prank(FEATURE_RF2$kruskal_stat_mod))
FEATURE_RANK_RF$Corr<-as.numeric(prank(FEATURE_RF2$Corr_target_mod))
FEATURE_RANK_RF$RF_ACC<-as.numeric(prank(FEATURE_RF2$MeanDecreaseAccuracy))

FEATURE_RANK_RF$SUM_ALL<-rowSums(FEATURE_RANK_RF[,-c(1)], na.rm = TRUE)
FEATURE_RANK_RF$SUM_NA<-rowSums(is.na(FEATURE_RANK_RF[,1:8]))

FEATURE_RANK_RF_noNA<-subset(FEATURE_RANK_RF, SUM_NA==0)

FEATURE_RANK_RF<-FEATURE_RANK_RF[order(FEATURE_RANK_RF$SUM_ALL, decreasing ='TRUE'),]

#####################
col_order <- c(FEATURE_RANK_RF$FEATURE_RF2.Feature)
col_order<-c('TARGET', col_order)
train_data_F <- train_data[, col_order]
test_data_F <- test_data[, col_order]

names(train_data_F)
names(test_data_F)

sum(names(train_data_100) %in% names(train_data_F)[1:101])
#88 sutampa

FEATURE_RANK<-FEATURE_RANK[order(FEATURE_RANK$SUM_ALL, decreasing ='TRUE'),]

sum(FEATURE_RANK[1:100,'FEATURE.Feature'] %in% FEATURE_RANK_RF[1:100,'FEATURE_RF2.Feature'])
#88
sum(FEATURE_RANK[1:50,'FEATURE.Feature'] %in% FEATURE_RANK_RF[1:50,'FEATURE_RF2.Feature'])
#47
sum(FEATURE_RANK[1:30,'FEATURE.Feature'] %in% FEATURE_RANK_RF[1:30,'FEATURE_RF2.Feature'])
#27
sum(FEATURE_RANK[1:15,'FEATURE.Feature'] %in% FEATURE_RANK_RF[1:15,'FEATURE_RF2.Feature'])
#13