table(ALL_atr$FINAL_STATUS_II)
table(ALL_atr_ch_D$FINAL_STATUS_II)

setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2022 11 11 II Attribute selection strategy")

ALL_atr_train<-subset(ALL_atr, STATUS_YEAR_GROUP!=2022)
table(ALL_atr_train$STATUS_YEAR_GROUP)
table(ALL_atr_train$T_2_Long_yield_LAST_VALUE)




library(rstatix)
cohens_d_target<-cohens_d(ALL_atr_train, Address_change_quantity~FINAL_STATUS_II, paired = FALSE, var.equal = FALSE)
b_end<-as.numeric(dim(ALL_atr_train)[2])
for (i in (7:(b_end))){
  print(i)
  form <- as.formula(paste(colnames(ALL_atr_train)[i], "~FINAL_STATUS_II"))
  cohens_d_info <- cohens_d(ALL_atr_train, form, paired = FALSE, var.equal = FALSE)
  cohens_d_target<-rbind(cohens_d_target, cohens_d_info)
}

table(cohens_d_target$magnitude, useNA = 'always')

#STRATEGIJA B tik su large and moderate, kita ir su small
a_group<-c('large', 'moderate')
a_names<-cohens_d_target[c(which(cohens_d_target$magnitude %in% a_group)), 1]
a_names<-a_names$.y.

ALL_atr_ch_D_strong<-ALL_atr[,c(1:5,which(colnames(ALL_atr) %in% a_names))]
names(ALL_atr_ch_D_strong)

table(ALL_atr_ch_D_strong$FINAL_STATUS_II)


#######################################factor neveikia nes turi buti numeric charakteristika nors ir binary
a_names<-NA
for (i in 2:dim(ALL_atr_train)[2]){
  print(names(ALL_atr_train)[i])
  if(length(which(!(names(table(ALL_atr_train[,i])) %in% c(0,1)))) == 0)
  {a_names<-append(a_names, names(ALL_atr_train)[i])}}

a_names<-a_names[-1]
train_data_fak<-ALL_atr_train[,]
a_names
a_names<-a_names[-c(1,23,24,25,26,27,28)]
b_values<-which(names(train_data_fak) %in% a_names)
a_names


for (i in b_values){
  print(i)
  train_data_fak[,i]<-as.factor(train_data_fak[,i])
}

library(rstatix)
cohens_d_target2<-cohens_d(train_data_fak, Address_change_quantity~FINAL_STATUS_II, paired = FALSE, var.equal = FALSE)
b_end<-as.numeric(dim(train_data_fak)[2])
for (i in (7:(b_end))){
  print(i)
  form <- as.formula(paste(colnames(train_data_fak)[i], "~FINAL_STATUS_II"))
  cohens_d_info <- cohens_d(train_data_fak, form, paired = FALSE, var.equal = FALSE)
  cohens_d_target2<-rbind(cohens_d_target2, cohens_d_info)
}

table(cohens_d_target2$magnitude, useNA = 'always')

a_names<-cohens_d_target[c(which(cohens_d_target$magnitude %in% a_group)), 1]


#############################################KRUSKAL##########################################################

kruskal<-kruskal.test(Address_change_quantity~FINAL_STATUS_II, data = ALL_atr_train)

kruskal_stat<-as.numeric(kruskal$statistic)
kruskal_df<-as.numeric(kruskal$parameter)
kruskal_pvalue<-as.numeric(kruskal$p.value)
Colum_name<-names(ALL_atr_train)[6]
kruskal_target<-data.frame(Colum_name, kruskal_stat, kruskal_df, kruskal_pvalue)


b_end<-as.numeric(dim(ALL_atr_train)[2])

for (i in (7:(b_end))){
  print(i)
  kruskal<-kruskal.test(ALL_atr_train[,c(i)], ALL_atr_train[,c(2)])
  kruskal_a<-as.numeric(kruskal$statistic)
  kruskal_b<-as.numeric(kruskal$parameter)
  kruskal_c<-as.numeric(kruskal$p.value)
  b<-names(ALL_atr_train)[i]
  new_row = c(b,kruskal_a, kruskal_b, kruskal_c)
  kruskal_target<-rbind(kruskal_target, new_row)
}

kruskal_target$kruskal_pvalue_if<-ifelse(as.numeric(kruskal_target$kruskal_pvalue)>0.05,1,0)
table(kruskal_target$kruskal_pvalue_if, useNA = 'always')

kruskal_target$kruskal_stat_mod<-abs(as.numeric(kruskal_target$kruskal_stat))
kruskal_target$kruskal_if2<-ifelse(as.numeric(kruskal_target$kruskal_stat_mod)>1000,0,1)
table(kruskal_target$kruskal_if2, useNA = 'always')
kruskal_target_atrinkti<-subset(kruskal_target, kruskal_pvalue_if==0)
kruskal_target_atrinkti<-subset(kruskal_target_atrinkti, kruskal_if2==0)

a_names<-kruskal_target_atrinkti$Colum_name

ALL_atr_Kruskal<-ALL_atr[,c(1:5,which(colnames(ALL_atr) %in% a_names))]
names(ALL_atr_Kruskal)


########################################
#factor
  #################
kruskal<-kruskal.test(Address_change_quantity~FINAL_STATUS_II, data = train_data_fak)

kruskal_stat<-as.numeric(kruskal$statistic)
kruskal_df<-as.numeric(kruskal$parameter)
kruskal_pvalue<-as.numeric(kruskal$p.value)
Colum_name<-names(train_data_fak)[6]
kruskal_target2<-data.frame(Colum_name, kruskal_stat, kruskal_df, kruskal_pvalue)


b_end<-as.numeric(dim(train_data_fak)[2])

for (i in (7:(b_end))){
  print(i)
  kruskal<-kruskal.test(train_data_fak[,c(i)], train_data_fak[,c(2)])
  kruskal_a<-as.numeric(kruskal$statistic)
  kruskal_b<-as.numeric(kruskal$parameter)
  kruskal_c<-as.numeric(kruskal$p.value)
  b<-names(train_data_fak)[i]
  new_row = c(b,kruskal_a, kruskal_b, kruskal_c)
  kruskal_target2<-rbind(kruskal_target2, new_row)
}

kruskal_target2$kruskal_pvalue_if<-ifelse(as.numeric(kruskal_target2$kruskal_pvalue)>0.05,1,0)
table(kruskal_target2$kruskal_pvalue_if, useNA = 'always')

kruskal_target2$kruskal_stat_mod<-abs(as.numeric(kruskal_target2$kruskal_stat))
kruskal_target2$kruskal_if2<-ifelse(as.numeric(kruskal_target2$kruskal_stat_mod)>1000,0,1)
table(kruskal_target2$kruskal_if2, useNA = 'always')
kruskal_target2_atrinkti<-subset(kruskal_target2, kruskal_pvalue_if==0)
kruskal_target2_atrinkti<-subset(kruskal_target2_atrinkti, kruskal_if2==0)

sum(kruskal_target_atrinkti$Colum_name %in% kruskal_target2_atrinkti$Colum_name)


###################################################################
kruskal_target<-kruskal_target[order(kruskal_target$kruskal_stat_mod, decreasing = TRUE),]
col_order <- c(kruskal_target$Colum_name)
other_names<-names(ALL_atr)[1:5]
col_order<-c(other_names, col_order)
Kruskal_data_order <- ALL_atr[, col_order]

###################################################################
cohens_d_target$eff_mood<-abs(cohens_d_target$effsize)
cohens_d_target<-cohens_d_target[order(cohens_d_target$eff_mood, decreasing = TRUE),]
col_order <- c(cohens_d_target$.y.)
other_names<-names(ALL_atr)[1:5]
col_order<-c(other_names, col_order)
CohensD_data_order <- ALL_atr[, col_order]
