library(caret)

train_data2<-predict(df, TRAIN_ALL_atr)
names(train_data2)[1]<-'TARGET'

library(compare)

comparison <- compare(train_data, train_data2,allowAll=TRUE)
comparison$tM

a_names<-names(test_data)
b_values<-which(names(train_data2) %in% a_names)
train_data2<-train_data2[,c(b_values)]

library(compareDF)
df_compare = compare_df(train_data, train_data2, "row")

a1 <- data.frame(a = 1:5, b = letters[1:5])
a2 <- data.frame(a = 1:3, b = letters[1:3])
df_compare = compare_df(a1, a2, "row")
comparison <- compare(a1, a2,allowAll=TRUE)

train_data2$c <- Reduce(`&`, Map(`==`, train_data2, train_data))

library("dplyr")
train_data2$TARGET<-as.factor(train_data2$TARGET)
data_common2 <- inner_join(train_data2, train_data) 


#https://statisticsglobe.com/find-common-rows-between-two-data-frames-in-r
#https://cran.r-project.org/web/packages/arsenal/vignettes/comparedf.html#a-larger-example
#https://stackoverflow.com/questions/3171426/compare-two-data-frames-to-find-the-rows-in-data-frame-1-that-are-not-present-in