load("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2022 12 19 IV Attribute selection strategy/.RData")
setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2022 12 19 IV Attribute selection strategy")

TRAIN_ALL_atr<-subset(ALL_atr, STATUS_YEAR_GROUP !=2022)
TEST_ALL_atr<-subset(ALL_atr, STATUS_YEAR_GROUP ==2022)
names(ALL_atr)

TRAIN_ALL_atr<-TRAIN_ALL_atr[,-c(1,3:5)]
TEST_ALL_atr<-TEST_ALL_atr[,-c(1,3:5)]
df<-TRAIN_ALL_atr
library(caret)
df<-preProcess(df, method=c("range"))
train_data<-predict(df, TRAIN_ALL_atr)
test_data<-predict(df, TEST_ALL_atr)

train_data[is.na(train_data)] = 0
test_data[is.na(test_data)] = 0

#Variation check
table(train_data$T_1_Long_yield_MAX, useNA = 'always')
table(train_data$T_2_Long_yield_MIN, useNA = 'always')
table(train_data$T_2_Long_yield_LAST_VALUE, useNA = 'always')
table(train_data$Active_owner_at_the_same_time, useNA = 'always')
#trys atmetami
a_names<-c('T_1_Long_yield_MAX','T_2_Long_yield_MIN', 'T_2_Long_yield_LAST_VALUE', 'Active_owner_at_the_same_time')
b_values<-which(names(train_data) %in% a_names)
train_data<-train_data[,-c(b_values)]
test_data<-test_data[,-c(b_values)]

#####################################################

a_names<-NA
for (i in 2:dim(train_data)[2]){
  print(names(train_data)[i])
  if(length(which(!(names(table(train_data[,i])) %in% c(0,1)))) == 0)
  {a_names<-append(a_names, names(train_data)[i])}}


a_names
a_names<-a_names[-c(1,6:16,34:38)]
b_values<-which(names(train_data) %in% a_names)
a_names
for (i in b_values){
  print(i)
  train_data[,i]<-as.factor(train_data[,i])
  test_data[,i]<-as.factor(test_data[,i])
}

names(train_data)[1]<-'TARGET'
names(test_data)[1]<-'TARGET'
train_data$TARGET<-as.factor(train_data$TARGET)
test_data$TARGET<-as.factor(test_data$TARGET)


####################################################
# ATRIBUTE SELECTION BACKWORD
###################################################

#https://github.com/FrancisArgnR/R-FeatureSelection-Packages
#https://cran.r-project.org/web/packages/FSinR/vignettes/FSinR.html
#https://medium.com/analytics-vidhya/feature-selection-in-r-9bfae551d22b
#https://machinecreek.com/feature-subset-selection-in-r-using-wrappers/
#https://cran.r-project.org/web/packages/FSinR/vignettes/FSinR.html
#https://datasciencebeginners.com/2018/11/26/functions-and-packages-for-feature-selection-in-r/
#https://jtr13.github.io/cc21fall2/feature-selection-in-r.html

library(caret)
filterCtrl <- rfeControl(functions=rfFuncs, method="cv", number=3)
results <- rfe(x= train_data[,-c(1)],y= train_data[,1], sizes=c(1:972), rfeControl=filterCtrl, metric = "Kappa")
results
plot(results, type=c("g", "o"))

#https://rdrr.io/cran/caret/man/rfeControl.html
#https://stats.stackexchange.com/questions/277132/forward-backward-model-selection-what-is-the-starting-model
library(MASS)
fit1 <- glm(TARGET~.,  data=train_data, family = binomial(link = 'logit'))
fit2 <- glm(TARGET~1,  data=train_data, family = binomial(link = 'logit'))

start.time<-Sys.time()
model_back<-stepAIC(fit1,direction="backward")
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken
#stepAIC(fit2,direction="forward",scope=list(upper=fit1,lower=fit2))
#stepAIC(fit2,direction="both",scope=list(upper=fit1,lower=fit2))
summary(fit1)
a_names2<-a_names
