load("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/.RData")
setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG")

z=a
###############DATA###################
train_data<-train_data_Kruskal_order[,]
test_data<-test_data_Kruskal_order[,]

library(themis)
smotenc_data<-smotenc(train_data, var = 'TARGET', k = 5, over_ratio = 1)
table(smotenc_data$TARGET)

#NERA FAKTORINIU DUOMENU YRA TIK 

smotenc_data$the_same<-Reduce(`&`, Map(`==`, train_data, smotenc_data))
smotenc_data$row_number<-row.names(smotenc_data)

train_data<-smotenc_data[,]

set.seed(7)
rows <- sample(nrow(train_data))
train_data<-train_data[rows,]

last_columns<-length(train_data)
last_columns<-as.numeric(last_columns)
last_columns<-append(last_columns,last_columns-1)

Train_data_rows_identification<-train_data[,last_columns]

train_data<-train_data[,-c(last_columns)]

#########################################################################################
#                           MODELIAI
########################################################################################
expected_value <- factor(c(test_data[,(1)]))
Predicted_values<-as.data.frame(test_data$TARGET)
names(Predicted_values)[1]<-'Real_target'
########################################################################################


reg_model<-glm(TARGET~.,  data=train_data[,1:2], family = binomial(link = 'logit'))
reg_model
summary(reg_model)


a_names<-"none"
a_names<-a_names[-1]

for (i in (1:2)){
  print(paste('v',i, sep='_'))
  a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
  a_value<-as.numeric(a_order[1])
  if (a_value==1){
    a_value<-as.numeric(a_order[2])
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_data) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_data[,-c(b_names)], family = binomial(link = 'logit'))
    }}
  else{
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_data) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_data[,-c(b_names)], family = binomial(link = 'logit'))}
  }
}

summary(reg_model)

#PREDICT
pred<-predict(reg_model,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$LG_Kruskal_1<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

Palyginimo<-as.data.frame(bin_cm$record_level_cm)
a<-names(Palyginimo)
a<-a[c(1:6,12,13,16,17,18,22)]
Palyginimo<-Palyginimo[,which(names(Palyginimo) %in% a)]
library(MLmetrics)
Palyginimo$AUC<-AUC(predicted_value, expected_value)
library(dgof)
Palyginimo$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
Palyginimo$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
Palyginimo$Error_rate<-1-Palyginimo$Accuracy
Palyginimo$Type_I_err<-Palyginimo$Pred_0_Ref_1/(Palyginimo$Pred_0_Ref_1+Palyginimo$Pred_1_Ref_1)
Palyginimo$Type_II_err<-Palyginimo$Pred_1_Ref_0/(Palyginimo$Pred_1_Ref_0+Palyginimo$Pred_0_Ref_0)
Palyginimo$MCC<-((Palyginimo$Pred_0_Ref_0*Palyginimo$Pred_1_Ref_1)-(Palyginimo$Pred_1_Ref_0*Palyginimo$Pred_0_Ref_1))/
  sqrt(as.numeric(Palyginimo$Pred_0_Ref_0+Palyginimo$Pred_1_Ref_0)*as.numeric(Palyginimo$Pred_0_Ref_0+Palyginimo$Pred_0_Ref_1)*as.numeric(Palyginimo$Pred_1_Ref_1+Palyginimo$Pred_1_Ref_0)*as.numeric((Palyginimo$Pred_1_Ref_1+Palyginimo$Pred_0_Ref_1)))
Palyginimo$G_mean<-sqrt(as.numeric(Palyginimo$Recall)*as.numeric(Palyginimo$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-peKruskalormance-of-credit-score-models-59fe13ef420
Palyginimo$Gini<-2*Palyginimo$AUC-1
Palyginimo$Modelis<-"LG Kruskal1"

saveRDS(reg_model, file = paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/", "LG_Kruskal_", 1, ".rda"))

#LG_1 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/LG_Kruskal_1.rda")
#summary(LG_1)

######################2#################

reg_model<-glm(TARGET~.,  data=train_data[,c(1:3)], family = binomial(link = 'logit'))
reg_model
summary(reg_model)


a_names<-"none"
a_names<-a_names[-1]

for (i in (1:3)){
  print(paste('v',i, sep='_'))
  a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
  a_value<-as.numeric(a_order[1])
  if (a_value==1){
    a_value<-as.numeric(a_order[2])
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_data) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_data[,-c(b_names)], family = binomial(link = 'logit'))
    }}
  else{
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_data) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_data[,-c(b_names)], family = binomial(link = 'logit'))}
  }
}

summary(reg_model)

#PREDICT
pred<-predict(reg_model,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$aa<-predicted_value
col_name <- paste0("LG_Kruskal_", 2)
colnames(Predicted_values)[3] <- col_name

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
library(MLmetrics)
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-peKruskalormance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-paste('LG_Kruskal_',2)
Palyginimo<-rbind(Palyginimo, New_row_pal)
saveRDS(reg_model, file = paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/", "LG_Kruskal_", 2, ".rda"))

###############################################################
#                        3-15 cikliukas
################################################

setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG")
library(dgof)
library(MLmetrics)
library('ConfusionTableR')

train_used<-train_data[,]

for (j in (3:150)){
  print(j)
  n<-j+1
  train_used<-train_data[,c(1:n)]
  reg_model<-glm(TARGET~.,  data=train_used[,c(1:n)], family = binomial(link = 'logit'))
  a_names<-"none"
  a_names<-a_names[-1]
  for (i in (1:n)){
    print(paste('v',j,i, sep='_'))
    a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
    a_value<-as.numeric(a_order[1])
    if (a_value==1){
      a_value<-as.numeric(a_order[2])
      bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
      if (bigger==TRUE) {
        a_names<-append(a_names, names(reg_model$coefficients[a_value]))
        b_names<-as.numeric(which(names(train_used) %in% a_names))
        reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))
      }}
    else{
      bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
      if (bigger==TRUE) {
        a_names<-append(a_names, names(reg_model$coefficients[a_value]))
        b_names<-as.numeric(which(names(train_used) %in% a_names))
        reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))}
    }
  }
  pred<-predict(reg_model,test_data[,-c(1)])
  pred2<-ifelse(pred >= 0.5, 1, 0)
  predicted_value <- factor(c(pred2))
  Predicted_values$aa<-predicted_value
  col_name <- paste0("LG_Kruskal_", j)
  colnames(Predicted_values)[n] <- col_name
  
  bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
  New_row_pal<-as.data.frame(bin_cm$record_level_cm)
  New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
  New_row_pal$AUC<-AUC(predicted_value, expected_value)
  New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
  New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
  New_row_pal$Error_rate<-1-New_row_pal$Accuracy
  New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
  New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
  New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
    sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
  New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
  New_row_pal$Gini<-2*New_row_pal$AUC-1
  New_row_pal$Modelis<-paste('LG_Kruskal_',j)
  Palyginimo<-rbind(Palyginimo, New_row_pal)
  
  saveRDS(reg_model, file = paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/", "LG_Kruskal_", j, ".rda"))
  write.csv(Palyginimo, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/Kruskal_LG_pal.csv")
  write.csv(Predicted_values, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/Kruskal_LG_values.csv")
}

#LG_1 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/LG_Kruskal_15.rda")
#summary(LG_1)

###############################################################
#                        16:50 cikliukas
#  51 : 80
# 81:100
#101:150
################################################

setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG")
library(dgof)
library(MLmetrics)
library('ConfusionTableR')

train_used<-train_data[,]

for (j in (101:150)){
  print(j)
  n<-j+1
  train_used<-train_data[,c(1:n)]
  reg_model<-glm(TARGET~.,  data=train_used[,c(1:n)], family = binomial(link = 'logit'))
  a_names<-"none"
  a_names<-a_names[-1]
  for (i in (1:n)){
    print(paste('v',j,i, sep='_'))
    a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
    a_value<-as.numeric(a_order[1])
    if (a_value==1){
      a_value<-as.numeric(a_order[2])
      bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
      if (bigger==TRUE) {
        a_names<-append(a_names, names(reg_model$coefficients[a_value]))
        b_names<-as.numeric(which(names(train_used) %in% a_names))
        reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))
      }}
    else{
      bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
      if (bigger==TRUE) {
        a_names<-append(a_names, names(reg_model$coefficients[a_value]))
        b_names<-as.numeric(which(names(train_used) %in% a_names))
        reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))}
    }
  }
  pred<-predict(reg_model,test_data[,-c(1)])
  pred2<-ifelse(pred >= 0.5, 1, 0)
  predicted_value <- factor(c(pred2))
  Predicted_values$aa<-predicted_value
  col_name <- paste0("LG_Kruskal_", j)
  colnames(Predicted_values)[n] <- col_name
  
  bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
  New_row_pal<-as.data.frame(bin_cm$record_level_cm)
  New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
  New_row_pal$AUC<-AUC(predicted_value, expected_value)
  New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
  New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
  New_row_pal$Error_rate<-1-New_row_pal$Accuracy
  New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
  New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
  New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
    sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
  New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
  New_row_pal$Gini<-2*New_row_pal$AUC-1
  New_row_pal$Modelis<-paste('LG_Kruskal_',j)
  Palyginimo<-rbind(Palyginimo, New_row_pal)
  
  saveRDS(reg_model, file = paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/", "LG_Kruskal_", j, ".rda"))
  write.csv(Palyginimo, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/Kruskal_LG_pal.csv")
  write.csv(Predicted_values, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/Kruskal_LG_values.csv")
}

############################################################################
#NUO CIA

LG_1 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/LG_Kruskal_1.rda")
summary(LG_1)

Skaicius<-as.data.frame(LG_1$coefficients)
Skaicius$Feature<-row.names(Skaicius)
Skaicius<-Skaicius[,c(2,1)]
names(Skaicius)[2]<-'LG_Kruskal_1'

LG_2 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/LG_Kruskal_2.rda")

df<-as.data.frame(LG_2$coefficients)
df$Feature<-row.names(df)
df<-df[,c(2,1)]
names(df)[2]<-'LG_Kruskal_2'

library(dplyr)
Skaicius<-full_join(Skaicius, df, by = "Feature")

for (j in (3:10)){
  print(j)
  LG_2 = readRDS(paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/", "LG_Kruskal_", j, ".rda"))
  df<-as.data.frame(LG_2$coefficients)
  df$Feature<-row.names(df)
  names(df)[1]<-paste0("LG_Kruskal_", j)
  Skaicius<-full_join(Skaicius, df, by = "Feature")
}


for (j in (11:50)){
  print(j)
  LG_2 = readRDS(paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/", "LG_Kruskal_", j, ".rda"))
  df<-as.data.frame(LG_2$coefficients)
  df$Feature<-row.names(df)
  names(df)[1]<-paste0("LG_Kruskal_", j)
  Skaicius<-full_join(Skaicius, df, by = "Feature")
}

write.csv(Skaicius, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/Skaicius.csv")

for (j in (51:150)){
  print(j)
  LG_2 = readRDS(paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/", "LG_Kruskal_", j, ".rda"))
  df<-as.data.frame(LG_2$coefficients)
  df$Feature<-row.names(df)
  names(df)[1]<-paste0("LG_Kruskal_", j)
  Skaicius<-full_join(Skaicius, df, by = "Feature")
}

write.csv(Skaicius, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/Skaicius.csv")

151 - colSums(is.na(Skaicius), na.rm = TRUE)

Skaicius<-rbind(Skaicius, 151 - colSums(is.na(Skaicius), na.rm = TRUE))

Skaicius[152,1]<-'SAVYBIU SKAICIUS'
write.csv(Skaicius, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/Skaicius Kruskal.csv")

summary(LG_1)

with(summary(LG_1), 1 - deviance/null.deviance)

#R2

Reiksmingumas<-data.frame('LG_Kruskal_1', with(summary(LG_1), 1 - deviance/null.deviance))

names(Reiksmingumas)[1]<-'Modelis'
names(Reiksmingumas)[2]<-'R2'
LG_2 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/LG_Kruskal_2.rda")

df<-data.frame('LG_Kruskal_2', with(summary(LG_2), 1 - deviance/null.deviance))
names(df)[1]<-'Modelis'
names(df)[2]<-'R2'

Reiksmingumas<-rbind(Reiksmingumas,df)

LG_2 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/LG_Kruskal_3.rda")

df<-data.frame('LG_Kruskal_3', with(summary(LG_2), 1 - deviance/null.deviance))
names(df)[1]<-'Modelis'
names(df)[2]<-'R2'

LG_2 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/LG_Kruskal_4.rda")

df<-data.frame('LG_Kruskal_4', with(summary(LG_2), 1 - deviance/null.deviance))
names(df)<-c('Modelis', 'R2')
Reiksmingumas<-rbind(Reiksmingumas,df)

for (j in (4:10)){
  print(j)
  LG_2 = readRDS(paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/", "LG_Kruskal_", j, ".rda"))
  df<-data.frame(paste0('LG_Kruskal_', j), with(summary(LG_2), 1 - deviance/null.deviance))
  names(df)<-c('Modelis', 'R2')
  Reiksmingumas<-rbind(Reiksmingumas,df)}


for (j in (11:100)){
  print(j)
  LG_2 = readRDS(paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/", "LG_Kruskal_", j, ".rda"))
  df<-data.frame(paste0('LG_Kruskal_', j), with(summary(LG_2), 1 - deviance/null.deviance))
  names(df)<-c('Modelis', 'R2')
  Reiksmingumas<-rbind(Reiksmingumas,df)}

for (j in (101:150)){
  print(j)
  LG_2 = readRDS(paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/", "LG_Kruskal_", j, ".rda"))
  df<-data.frame(paste0('LG_Kruskal_', j), with(summary(LG_2), 1 - deviance/null.deviance))
  names(df)<-c('Modelis', 'R2')
  Reiksmingumas<-rbind(Reiksmingumas,df)}


#https://www.statology.org/glm-r-squared/
write.csv(Reiksmingumas, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/Reiksmingumas Kruskal.csv")


koreliacija<-cor(train_data[,2:151])
write.csv(koreliacija, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/koreliacija.csv")

summary(LG_2)
LG_2$aic
install.packages('DescTools')
library(DescTools)
PseudoR2(LG_2, which = 'McFadden')
PseudoR2(LG_2, which = 'McFaddenAdj')
PseudoR2(LG_2, which = 'CoxSnell')
PseudoR2(LG_2, which = 'Nagelkerke')
PseudoR2(LG_2, which = 'AldrichNelson')
PseudoR2(LG_2, which = 'VeallZimmermann')
PseudoR2(LG_2, which = 'Efron')
PseudoR2(LG_2, which = 'McKelveyZavoina')
PseudoR2(LG_2, which = 'Tjur')


PseudoR2(LG_2, which = 'all')

Reiksmingumas_Pseudo<-data.frame('LG_Kruskal_1', t(PseudoR2(LG_2, which = 'all')))
names(Reiksmingumas_Pseudo)[1]<-'Modelis'

Reiksmingumas_AIC<-data.frame('LG_Kruskal_1', LG_1$aic)
names(Reiksmingumas_AIC)<-c('Modelis', 'AIC')

LG_2 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/LG_Kruskal_2.rda")

df<-data.frame('LG_Kruskal_2',t(PseudoR2(LG_2, which = 'all')))
names(df)[1]<-'Modelis'

Reiksmingumas_Pseudo<-rbind(Reiksmingumas_Pseudo,df)

df2<-data.frame('LG_Kruskal_2', LG_2$aic)
names(df2)<-c('Modelis', 'AIC')

Reiksmingumas_AIC<-rbind(Reiksmingumas_AIC,df2)


for (j in (11:150)){
  print(j)
  LG_2 = readRDS(paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/", "LG_Kruskal_", j, ".rda"))
  df<-data.frame(paste0('LG_Kruskal_', j), t(PseudoR2(LG_2, which = 'all')))
  names(df)[1]<-c('Modelis')
  Reiksmingumas_Pseudo<-rbind(Reiksmingumas_Pseudo,df)
  df2<-data.frame(paste0('LG_Kruskal_', j), LG_2$aic)
  names(df2)<-c('Modelis', 'AIC')
  Reiksmingumas_AIC<-rbind(Reiksmingumas_AIC,df2)
}

write.csv(Reiksmingumas_Pseudo, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/Reiksmingumas_Pseudo.csv")
write.csv(Reiksmingumas_AIC, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/Reiksmingumas_AIC.csv")

####################
Reiksmingumas_Pseudo<-data.frame('LG_Kruskal_1', t(PseudoR2(LG_2, which = 'all')))
names(Reiksmingumas_Pseudo)[1]<-'Modelis'

Reiksmingumas_AIC<-data.frame('LG_Kruskal_1', LG_1$aic)
names(Reiksmingumas_AIC)<-c('Modelis', 'AIC')

LG_2 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/LG_Kruskal_2.rda")

df<-data.frame('LG_Kruskal_2',t(PseudoR2(LG_2, which = 'all')))
names(df)[1]<-'Modelis'


for (j in (3:150)){
  print(j)
  LG_2 = readRDS(paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Kruskal LG/", "LG_Kruskal_", j, ".rda"))
  df<-data.frame(paste0('LG_Kruskal_', j), t(PseudoR2(LG_2, which = 'all')))
  names(df)[1]<-c('Modelis')
  Reiksmingumas_Pseudo<-rbind(Reiksmingumas_Pseudo,df)
}
