


###########KORELIACIJA TARGET
#https://www.statology.org/point-biserial-correlation-r/ - for binary

Koreliacija_target<-data.frame('ab','ba')
names(Koreliacija_target)[1]<-'Column_name'
names(Koreliacija_target)[2]<-'Corr_target'
Koreliacija_target<-Koreliacija_target[-1,]
new_row = c(names(train_data_num)[2], (cor.test(train_data_num[,c(2)], as.numeric(train_data_num$TARGET)))$estimate)
Koreliacija_target<-rbind(Koreliacija_target, new_row)
new_row = c(names(train_data_num)[3], (cor.test(train_data_num[,c(3)], as.numeric(train_data_num[, c(1)])))$estimate)
Koreliacija_target<-rbind(Koreliacija_target, new_row)
names(Koreliacija_target)[1]<-'Column_name'
names(Koreliacija_target)[2]<-'Corr_target'

b_end<-as.numeric(dim(train_data_num)[2])
for (i in (4:(b_end))){
  a<-cor.test(train_data_num[,c(i)], as.numeric(train_data_num[,c(1)]))$estimate
  a<-as.numeric(a)
  b<-names(train_data_num)[i]
  new_row = c(b,a)
  Koreliacija_target<-rbind(Koreliacija_target, new_row)
}

Koreliacija_target$Corr_target<-as.numeric(Koreliacija_target$Corr_target)
Koreliacija_target$Corr_target_mod<-abs(Koreliacija_target$Corr_target)



#################KORELIACIJA LIKUSI

koreliacija<-cor(train_data_num[,c(2:(b_end))], use = "pairwise.complete.obs")
koreliacija_other <- as.data.frame(as.table(koreliacija))

koreliacija_other <- koreliacija_other[which(!koreliacija_other$Var1==koreliacija_other$Var2),]
koreliacija_other$modulis<-abs(koreliacija_other$Freq)
koreliacija_other<-koreliacija_other[which(koreliacija_other$modulis>0.7),]

names(Koreliacija_target)
names(koreliacija_other)[1]<-'Column_name'

library(dplyr)
koreliacija_other<-left_join(koreliacija_other, Koreliacija_target[c('Column_name', 'Corr_target_mod')], by = 'Column_name')
names(koreliacija_other)[1]<-'Column_name_V1'
names(koreliacija_other)[2]<-'Column_name'
names(koreliacija_other)[5]<-'V1_Target'
koreliacija_other<-left_join(koreliacija_other, Koreliacija_target[c('Column_name', 'Corr_target_mod')], by = 'Column_name')


koreliacija_other$salyga<-ifelse((koreliacija_other$V1_Target)>(koreliacija_other$Corr_target_mod), 1,2)
koreliacija_other<-subset(koreliacija_other, salyga ==1)
a_kor<-koreliacija_other$Column_name
a_kor<-unique(a_kor)
a_kor
a_kor<-c("TARGET", a_kor)

train_data_COR<-train_data[, which(names(train_data) %in% a_kor)]


#REG MODEL
reg_model_cor<-glm(TARGET~.,  data=train_data_COR, family = binomial(link = 'logit'))
reg_model_cor
summary(reg_model_cor_cor)

a_names<-"none"
a_names<-a_names[-1]

for (i in (1:dim(train_data_COR)[2])){
  print(i)
  a_order<-order(summary(reg_model_cor)$coefficients[,4], decreasing = TRUE)
  a_value<-as.numeric(a_order[1])
  if (a_value==1){
    a_value<-as.numeric(a_order[2])
    bigger<-summary(reg_model_cor)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model_cor$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_data_COR) %in% a_names))
      reg_model_cor<-glm(TARGET~.,  data=train_data_COR[,-c(b_names)], family = binomial(link = 'logit'))
    }}
  else{
    bigger<-summary(reg_model_cor)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model_cor$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_data_COR) %in% a_names))
      reg_model_cor<-glm(TARGET~.,  data=train_data_COR[,-c(b_names)], family = binomial(link = 'logit'))}
  }
}

summary(reg_model_cor)$coefficients
end.time<-Sys.time()
summary(reg_model_cor)

pred<-predict(reg_model_cor,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$LG_basic_COR<-predicted_value  ##########NAME CHANGE

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
library(MLmetrics)
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"LG basic"
Palyginimo<-rbind(Palyginimo, New_row_pal)