load("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 14 autoencoder/.RData")
setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 14 autoencoder")
train_data<-train3[,]
test_data<-test3[,]

train_data_num<-train_data[,]
test_data_num<-test_data[,]

train_data_u<-train_data_num[,]
train_data_u[is.na(train_data_u)] = 0
test_data_u<-test_data_num[,]
test_data_u[is.na(test_data_u)] = 0

train_data_u2<-train_data_u[,-c(1)]
test_data_u2<-test_data_u[,-c(1)]

#########################################################################################
#                           MODELIAI
########################################################################################
expected_value <- factor(c(test_data[,(1)]))
Predicted_values<-as.data.frame(test_data$TARGET)
names(Predicted_values)[1]<-'Real_target'

########################################################################################
#                             LDA
########################################################################################

library(klaR)
library(psych)
library(MASS)
library(ggord)
library(devtools)

LD_linear <- lda(TARGET~., train_data)

p<- predict(LD_linear, test_data[,-c(1)])
predicted_value<-p$class
Predicted_values$LDA_linear<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

Palyginimo<-as.data.frame(bin_cm$record_level_cm)
a<-names(Palyginimo)
a<-a[c(1:6,12,13,16,17,18,22)]
Palyginimo<-Palyginimo[,which(names(Palyginimo) %in% a)]
library(MLmetrics)
Palyginimo$AUC<-AUC(predicted_value, expected_value)
library(dgof)
Palyginimo$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
Palyginimo$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
Palyginimo$Error_rate<-1-Palyginimo$Accuracy
Palyginimo$Type_I_err<-Palyginimo$Pred_0_Ref_1/(Palyginimo$Pred_0_Ref_1+Palyginimo$Pred_1_Ref_1)
Palyginimo$Type_II_err<-Palyginimo$Pred_1_Ref_0/(Palyginimo$Pred_1_Ref_0+Palyginimo$Pred_0_Ref_0)
Palyginimo$MCC<-((Palyginimo$Pred_0_Ref_0*Palyginimo$Pred_1_Ref_1)-(Palyginimo$Pred_1_Ref_0*Palyginimo$Pred_0_Ref_1))/
  sqrt(as.numeric(Palyginimo$Pred_0_Ref_0+Palyginimo$Pred_1_Ref_0)*as.numeric(Palyginimo$Pred_0_Ref_0+Palyginimo$Pred_0_Ref_1)*as.numeric(Palyginimo$Pred_1_Ref_1+Palyginimo$Pred_1_Ref_0)*as.numeric((Palyginimo$Pred_1_Ref_1+Palyginimo$Pred_0_Ref_1)))
Palyginimo$G_mean<-sqrt(as.numeric(Palyginimo$Recall)*as.numeric(Palyginimo$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
Palyginimo$Gini<-2*Palyginimo$AUC-1
Palyginimo$Modelis<-"LDA (linear)"

LDA_quadratic <- qda(TARGET~., train_data)

p<- predict(LDA_quadratic, test_data[,-c(1)])
predicted_value<-p$class
Predicted_values$LDA_quadratic<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
library(MLmetrics)
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"QDA (quadratic)"
Palyginimo<-rbind(Palyginimo, New_row_pal)


############################################################################################
#                       GLM 
############################################################################################

#REG MODEL
reg_model<-glm(TARGET~.,  data=train_data, family = binomial(link = 'logit'))
reg_model
summary(reg_model)


a_names<-"none"
a_names<-a_names[-1]

start.time<-Sys.time()
for (i in (1:dim(train_data)[2])){
  print(i)
  a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
  a_value<-as.numeric(a_order[1])
  if (a_value==1){
    a_value<-as.numeric(a_order[2])
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_data) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_data[,-c(b_names)], family = binomial(link = 'logit'))
    }}
  else{
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_data) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_data[,-c(b_names)], family = binomial(link = 'logit'))}
  }
}

summary(reg_model)$coefficients
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken
summary(reg_model)

#PREDICT
pred<-predict(reg_model,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$LG_basic<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
library(MLmetrics)
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"LG basic"
Palyginimo<-rbind(Palyginimo, New_row_pal)


########################################################################################################################
#                                               DECISION TREE
####################################################################################################################

library(DAAG)
library(party)
library(rpart)
library(rpart.plot)
library(mlbench)
library(caret)
library(pROC)
library(tree)

set.seed(1234)
#Tree Classification CART.
tree <- rpart(TARGET~.,data=train_data) 
rpart.plot(tree)
printcp(tree)

#tree <- rpart(TRUE_STATUS~.,data=train_2,cp=0.06) #depends on 0.06 on root node error rel error https://www.r-bloggers.com/2021/04/decision-trees-in-r/
predicted_value<-predict(tree, test_data, type = "vector")
predicted_value<-ifelse(predicted_value==1,0,1)
predicted_value<-as.factor(predicted_value)
Predicted_values$DT<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
library(MLmetrics)
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"DT"
Palyginimo<-rbind(Palyginimo, New_row_pal)

########################################################################################################################
#                                               RANDOM FOREST
####################################################################################################################
#https://www.geeksforgeeks.org/random-forest-approach-in-r-programming/

library(caTools)
library(randomForest)
set.seed(120)  # Setting seed
classifier_RF = randomForest(x = train_data[-1],
                             y = train_data$TARGET,
                             ntree = 500)

classifier_RF
predicted_value = predict(classifier_RF, newdata = test_data[-1])
Predicted_values$RF_basic<-predicted_value

table(predicted_value)
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"RF basic"

Palyginimo<-rbind(Palyginimo, New_row_pal)

plot(classifier_RF)
varImpPlot(classifier_RF)


########################################################################################################################
#                                                     XGBOOST
########################################################################################################################

library(xgboost) # for xgboost
library(tidyverse) # general utility functions


X = data.matrix(train_data[,-c(1)])
X_test = data.matrix(test_data[,-c(1)])

#labels
y<-as.matrix(train_data$TARGET)
y_test<-as.matrix(test_data$TARGET)


xgb_train <- xgboost::xgb.DMatrix(data = X, label = y)
xgb_test <- xgboost::xgb.DMatrix(data = X_test, label = y_test)

set.seed(120)

xgb <- xgboost(data = xgb_train, # the data   
               nround = 300, # max number of boosting iterations
               objective = "binary:logistic")  # the objective function

#max_depth [default=6]
#https://xgboost.readthedocs.io/en/stable/parameter.html

y_pred <- predict(xgb, X_test)
print(length(y_pred))
print(length(y_test))

predicted_value<-ifelse(y_pred>0.5,1,0)
predicted_value<-as.factor(predicted_value)
Predicted_values$XGBoost_Binary<-predicted_value

library(pROC)
roc_object <- roc(as.numeric(expected_value), as.numeric(predicted_value))
auc(roc_object)

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(pROC)
roc_object <- roc(as.numeric(expected_value), as.numeric(predicted_value))
auc(roc_object)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"XGBoost Binary"
Palyginimo<-rbind(Palyginimo, New_row_pal)

set.seed(120)
xgb_softmax <- xgboost(data = xgb_train, # the data   
                       nround = 300, # max number of boosting iterations uztektu 50
                       objective = "multi:softmax",
                       num_class = 2)  # the objective function

y_pred <- predict(xgb_softmax, X_test)
print(length(y_pred))
print(length(y_test))

predicted_value<-ifelse(y_pred>0.5,1,0)
predicted_value<-as.factor(predicted_value)
Predicted_values$XGBoost_Softmax<-predicted_value

library(pROC)
roc_object <- roc(as.numeric(expected_value), as.numeric(predicted_value))
auc(roc_object)
####
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(pROC)
roc_object <- roc(as.numeric(expected_value), as.numeric(predicted_value))
auc(roc_object)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"XGBoost Softmax"
Palyginimo<-rbind(Palyginimo, New_row_pal)

###################################################################
# NAIVE
############################################################
library(e1071)
set.seed(120)
naive.fit=naiveBayes(TARGET~.,data=train_data)
summary(naive.fit)

# Predicting test set results
predicted_value=predict(naive.fit,test_data)

Predicted_values$Naive_bayes<-predicted_value
library(pROC)
roc_object <- roc(as.numeric(expected_value), as.numeric(predicted_value))
auc(roc_object)
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"Naive Bayes"
Palyginimo<-rbind(Palyginimo, New_row_pal)

#########################################################################################################################
#                                                              ANN 
#########################################################################################################################
##NO FACTOR ATRIBUTES

library(tidyverse)
library(keras)
#install_keras()
library(tensorflow)
#install_tensorflow()
library(DMwR)
#install.packages(c("zoo","xts","quantmod")) ## and perhaps mode
#install.packages( "Path/To/DMwR_0.4.1.tar.gz", repos=NULL, type="source" )
#install.packages("DMwR_0.4.1.tar.gz")
#install.packages("remotes")
#library(remotes)
#remotes::install_github("cran/DMwR")
#use_condaenv("r-tensorflow")
#install.packages('devtools')
#library(devtools)
#devtools::install_github("rstudio/tensorflow")

########

X_train<- train_data_num[, -c(1)]
y_train <- to_categorical(as.numeric(train_data_num$TARGET)-1)
X_test <- test_data_num[, -c(1)]
y_test <- to_categorical(as.numeric(test_data_num$TARGET)-1)
X_train <- as.matrix(X_train)
X_test <- as.matrix(X_test)

set.seed(120)
model <- keras_model_sequential() 

model %>% 
  layer_dense(units = 100, activation = 'relu', input_shape = ncol(X_train)) %>% 
  layer_dropout(rate = 0.4) %>% 
  layer_dense(units = 50, activation = 'relu') %>%
  layer_dropout(rate = 0.2) %>%
  layer_dense(units = 25, activation = 'relu') %>%
  layer_dropout(rate = 0.2) %>%
  layer_dense(units = 2, activation = 'sigmoid')

model %>% compile(
  loss = 'binary_crossentropy',
  optimizer = 'adam',
  metrics = c('accuracy')
)

model %>% fit(
  X_train, y_train, 
  epochs = 50, 
  batch_size = 32,
  validation_split = 0.2
)

model %>% save_model_hdf5("model_ANN_both.h5")

model %>% evaluate(X_test, y_test)

pred <- model %>% predict(X_test) %>% k_argmax() %>% k_get_value()
predicted_value<-as.factor(pred)
Predicted_values$ANN3<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"ANN-3"

Palyginimo<-rbind(Palyginimo, New_row_pal) 

####################################################
set.seed(120)
model2 <- keras_model_sequential() 

model2 %>% 
  layer_dense(units = 30, activation = 'relu', input_shape = ncol(X_train)) %>% 
  layer_dropout(rate = 0.4) %>% 
  layer_dense(units = 10, activation = 'relu') %>%
  layer_dropout(rate = 0.2) %>%
  layer_dense(units = 2, activation = 'sigmoid')

model2 %>% compile(
  loss = 'binary_crossentropy',
  optimizer = 'adam',
  metrics = c('accuracy')
)

model2 %>% fit(
  X_train, y_train, 
  epochs = 50, 
  batch_size = 32,
  validation_split = 0.2
)

model2 %>% save_model_hdf5("model_2ANN_both.h5")

model2 %>% evaluate(X_test, y_test)

pred <- model2 %>% predict(X_test) %>% k_argmax() %>% k_get_value()
predicted_value<-as.factor(pred)
Predicted_values$ANN2<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"ANN-2"

Palyginimo<-rbind(Palyginimo, New_row_pal)

####################################################
set.seed(120)
model1 <- keras_model_sequential() 

model1 %>% 
  layer_dense(units = 24, activation = 'relu', input_shape = ncol(X_train)) %>% 
  layer_dropout(rate = 0.2) %>%
  layer_dense(units = 2, activation = 'sigmoid')

model1 %>% compile(
  loss = 'binary_crossentropy',
  optimizer = 'adam',
  metrics = c('accuracy')
)

model1 %>% fit(
  X_train, y_train, 
  epochs = 50, 
  batch_size = 32,
  validation_split = 0.2
)

model1 %>% save_model_hdf5("model_1ANN_both.h5")

model1 %>% evaluate(X_test, y_test)

pred <- model1 %>% predict(X_test) %>% k_argmax() %>% k_get_value()
predicted_value<-as.factor(pred)
Predicted_values$ANN1<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"ANN-1"

Palyginimo<-rbind(Palyginimo, New_row_pal)


####################################################
set.seed(120)
model4 <- keras_model_sequential() 

model4 %>% 
  layer_dense(units = 100, activation = 'relu', input_shape = ncol(X_train)) %>% 
  layer_dropout(rate = 0.4) %>%
  layer_dense(units = 50, activation = 'relu') %>%
  layer_dropout(rate = 0.2) %>%
  layer_dense(units = 25, activation = 'relu') %>%
  layer_dropout(rate = 0.2) %>%
  layer_dense(units = 5, activation = 'relu') %>%
  layer_dropout(rate = 0.2) %>%
  layer_dense(units = 2, activation = 'sigmoid')

model4 %>% compile(
  loss = 'binary_crossentropy',
  optimizer = 'adam',
  metrics = c('accuracy')
)

model4 %>% fit(
  X_train, y_train, 
  epochs = 50, 
  batch_size = 32,
  validation_split = 0.2
)

model4 %>% save_model_hdf5("model_4ANN_both.h5")

model4 %>% evaluate(X_test, y_test)

pred <- model4 %>% predict(X_test) %>% k_argmax() %>% k_get_value()
predicted_value<-as.factor(pred)
Predicted_values$ANN4<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"ANN-4"

Palyginimo<-rbind(Palyginimo, New_row_pal)

#########################################################################################################################
#                                                              ELM
#                                             The Extreme Learning Machine Algorithm
#########################################################################################################################
library(elmNNRcpp)
set.seed(120)
ELM_model<-elm(TARGET~., train_data, nhid=150, actfun="sig")
pred<-predict(ELM_model, newdata = test_data[,-1])
predicted_value<-as.factor(pred)
Predicted_values$ELM_150<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"ELM_150"

Palyginimo<-rbind(Palyginimo, New_row_pal)

###################################################################################
library(elmNNRcpp)
set.seed(120)
ELM_model<-elm(TARGET~., train_data, nhid=100, actfun="sig")
pred<-predict(ELM_model, newdata = test_data[,-1])
predicted_value<-as.factor(pred)
Predicted_values$ELM_100<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"ELM_100"

Palyginimo<-rbind(Palyginimo, New_row_pal)

###################################################################################
library(elmNNRcpp)
set.seed(120)
ELM_model<-elm(TARGET~., train_data, nhid=200, actfun="sig")
pred<-predict(ELM_model, newdata = test_data[,-1])
predicted_value<-as.factor(pred)
Predicted_values$ELM_200<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"ELM_200"

Palyginimo<-rbind(Palyginimo, New_row_pal)

###################################################################################
library(elmNNRcpp)
set.seed(120)
ELM_model<-elm(TARGET~., train_data, nhid=300, actfun="sig")
pred<-predict(ELM_model, newdata = test_data[,-1])
predicted_value<-as.factor(pred)
Predicted_values$ELM_300<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"ELM_300"

Palyginimo<-rbind(Palyginimo, New_row_pal)


#########################################################################################################################
#                                                              CNN
#########################################################################################################################
##NO FACTOR ATRIBUTES
Sys.setenv("CUDA_VISIBLE_DEVICES" = -1)  
################ library
library(lattice)
library(tidyverse)
library(keras)
library(grid)
library(tensorflow)
library(DMwR)

#~~~~~~~~~~~~~~~~~~~~~DATA

xtrain = as.matrix(train_data_num[, -1])
ytrain = as.matrix(train_data_num[, 1])
xtest = as.matrix(test_data_num[, -1])
ytest = as.matrix(test_data_num[, 1]) 

dim(xtrain) # 101129    24
dim(ytrain) # 101129      1


xtrain = array(xtrain, dim = c(nrow(xtrain), 32, 1))
xtest = array(xtest, dim = c(nrow(xtest), 32, 1))
ytrain = to_categorical(ytrain)

dim(xtrain)
dim(ytrain)

#__________________models 1-------------------------
set.seed(120)

model5 = keras_model_sequential() %>%
  layer_conv_1d(filters=8, kernel_size=2, input_shape=c(32,1), activation="relu") %>%
  layer_conv_1d(filters = 4, kernel_size = c(2), activation = "relu") %>% 
  layer_max_pooling_1d(2) %>% 
  layer_dropout(rate = 0.2) %>% 
  layer_conv_1d(filters = 2, kernel_size = c(2), activation = "relu") %>% 
  layer_max_pooling_1d(2) %>% 
  layer_flatten() %>%
  layer_dropout(rate = 0.2) %>% 
  layer_dense(units = 2, activation = "softmax")

model5 %>% compile(loss = 'binary_crossentropy',
                   optimizer = 'adam',
                   metrics = 'accuracy')

model5 %>% summary()

#model %>% fit(xtrain, ytrain, epochs=100, verbose=0) #verbose nerodys eigos

model5 %>% fit(
  xtrain, ytrain, 
  epochs = 50, 
  batch_size = 32,
  validation_split = 0.2
)

scores = model5 %>% evaluate(xtrain, ytrain, verbose = 0) 
print(scores)

ypred = model5 %>% predict(xtest)
#head(ypred)
yhat = data.frame("ypred" = ifelse(max.col(ypred[ ,1:2])==1, "0", "1"))
model5 %>% save_model_hdf5("model_CNN5_both.h5")

predicted_value<-as.factor(yhat$ypred)
Predicted_values$CNN_5<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"CNN-3"
Palyginimo<-rbind(Palyginimo, New_row_pal)

#__________________models 2-------------------------
set.seed(120)

model6 = keras_model_sequential() %>%
  layer_conv_1d(filters=8, kernel_size=2, input_shape=c(24,1), activation="relu") %>%
  layer_max_pooling_1d(2) %>% 
  layer_dropout(rate = 0.2) %>% 
  layer_conv_1d(filters = 4, kernel_size = c(2), activation = "relu") %>% 
  layer_max_pooling_1d(2) %>% 
  layer_flatten() %>%
  layer_dropout(rate = 0.2) %>% 
  layer_dense(units = 2, activation = "softmax")

model6 %>% compile(loss = 'binary_crossentropy',
                   optimizer = 'adam',
                   metrics = 'accuracy')

model6 %>% summary()

#model %>% fit(xtrain, ytrain, epochs=100, verbose=0) #verbose nerodys eigos

model6 %>% fit(
  xtrain, ytrain, 
  epochs = 50, 
  batch_size = 32,
  validation_split = 0.2
)

scores = model6 %>% evaluate(xtrain, ytrain, verbose = 0) 
print(scores)

ypred = model6 %>% predict(xtest)
#head(ypred)
yhat = data.frame("ypred" = ifelse(max.col(ypred[ ,1:2])==1, "0", "1"))
model6 %>% save_model_hdf5("model_CNN3_both.h5")

predicted_value<-as.factor(yhat$ypred)
Predicted_values$CNN_2a<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"CNN-2_a"
Palyginimo<-rbind(Palyginimo, New_row_pal)

#__________________models 3-------------------------
set.seed(120)

model7 = keras_model_sequential() %>%
  layer_conv_1d(filters=4, kernel_size=2, input_shape=c(24,1), activation="relu") %>%
  layer_max_pooling_1d(2) %>% 
  layer_dropout(rate = 0.2) %>% 
  layer_conv_1d(filters = 2, kernel_size = c(2), activation = "relu") %>% 
  layer_max_pooling_1d(2) %>% 
  layer_flatten() %>%
  layer_dropout(rate = 0.2) %>% 
  layer_dense(units = 2, activation = "softmax")

model7 %>% compile(loss = 'binary_crossentropy',
                   optimizer = 'adam',
                   metrics = 'accuracy')

model7 %>% summary()

#model %>% fit(xtrain, ytrain, epochs=100, verbose=0) #verbose nerodys eigos

model7 %>% fit(
  xtrain, ytrain, 
  epochs = 50, 
  batch_size = 32,
  validation_split = 0.2
)

scores = model7 %>% evaluate(xtrain, ytrain, verbose = 0) 
print(scores)

ypred = model7 %>% predict(xtest)
#head(ypred)
yhat = data.frame("ypred" = ifelse(max.col(ypred[ ,1:2])==1, "0", "1"))
model7 %>% save_model_hdf5("model_CNN2_both.h5")

predicted_value<-as.factor(yhat$ypred)
Predicted_values$CNN_2b<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"CNN-2_b"
Palyginimo<-rbind(Palyginimo, New_row_pal)


#########################################################################################################################
#                                                               Knn
#########################################################################################################################
library(class)
knn_3<-knn(train_data[,-c(1)], test_data[,-c(1)], train_data$TARGET, k = 3)
predicted_value <- as.factor(c(knn_3))
Predicted_values$Knn_3<-predicted_value
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"Knn-3"

Palyginimo<-rbind(Palyginimo, New_row_pal)

#######################K5
library(class)
knn_5<-knn(train_data[,-c(1)], test_data[,-c(1)], train_data$TARGET, k = 5)
predicted_value <- as.factor(c(knn_5))
Predicted_values$Knn_5<-predicted_value
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"Knn-5"

Palyginimo<-rbind(Palyginimo, New_row_pal)

#########################K7
knn_7<-knn(train_data[,-c(1)], test_data[,-c(1)], train_data$TARGET, k = 7)
predicted_value <- as.factor(c(knn_7))
Predicted_values$Knn_7<-predicted_value
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"Knn-7"
Palyginimo<-rbind(Palyginimo, New_row_pal)

#########################################################################################################################
#                                                               ADA Boost
#########################################################################################################################
library(tidyverse)
library(caret)
library(adabag)

#ada_model<-train(TARGET~., method='AdaBoost.M1', data= train_data )

ada_model<-boosting(TARGET~., data=train_data, boos=TRUE, mfinal=50)
pred = predict(ada_model, test_data)
predicted_value <- factor(c(pred$class))
Predicted_values$Ada_boost<-predicted_value
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"Adaboost"
Palyginimo<-rbind(Palyginimo, New_row_pal)
