load("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2022 12 19 VI Attribute selection strategy/.RData")
setwd('C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2022 12 19 VI Attribute selection strategy')

is.factor(train_data$LF_UAB)
####TSENSE###
#https://www.r-bloggers.com/2019/05/quick-and-easy-t-sne-analysis-in-r/
library(M3C)
tsne(pollen$data,labels=as.factor(pollen$celltypes))

#https://crunchingthedata.com/when-to-use-t-sne/
#https://www.analyticsvidhya.com/blog/2017/01/t-sne-implementation-r-python/

library(Rtsne)
## Curating the database for analysis with both t-SNE and PCA
Labels<-train_data$TARGET
train_data$TARGET<-as.factor(train_data$TARGET)
## for plotting
colors = rainbow(length(unique(train_data$TARGET)))
names(colors) = unique(train_data$TARGET)

library(Rtsne)
## Executing the algorithm on curated data
tsne <- Rtsne(train_data[,-1], dims = 2, perplexity=30, verbose=TRUE, max_iter = 500)
exeTimeTsne<- system.time(Rtsne(train_data[,-1], dims = 2, perplexity=30, verbose=TRUE, max_iter = 500))


## Plotting
plot(tsne$Y, t='n', main="tsne")
text(tsne$Y, labels=train_data$TARGET, col=colors[train_data$TARGET])

#why not to use
#https://crunchingthedata.com/when-to-use-t-sne/


###########################################################################
#som
###

is.factor(train_data$LF_UAB)

a_names<-NA
for (i in 1:dim(train_data)[2]){
  print(names(train_data)[i])
  if(is.factor(train_data[,i]) == "TRUE")
  {a_names<-append(a_names, names(train_data)[i])}}

a_names<-a_names[-c(1:2)]
b_values<-which(names(train_data) %in% a_names)

train_data_num<-train_data[,]
test_data_num<-test_data[,]
for (i in b_values){
  print(names(train_data)[i])
  train_data_num[,i]<-as.numeric(train_data_num[,i])
  test_data_num[,i]<-as.numeric(test_data_num[,i])}


##############################################

library(kohonen)
library(tibble)
train_data_num <- as_tibble(train_data_num)

somGrid <- somgrid(xdim = 5, ydim = 5, topo = "hexagonal",
                   neighbourhood.fct = "bubble", toroidal = FALSE)

library(dplyr)
Train_Scaled <- train_data_num %>%
  select(-TARGET) %>%
  scale()
set.seed(111)
TRAIN_Som <- som(Train_Scaled, grid = somGrid, rlen = 500,
               alpha = c(0.05, 0.01))


#NEED SAVE 
#Listing 15.4 Plotting SOM diagnostics
par(mfrow = c(2, 3))

plotTypes <- c("codes", "changes", "counts", "quality",
               "dist.neighbours", "mapping")

library(purrr)
walk(plotTypes, ~plot(TRAIN_Som, type = ., shape = "straight"))

#Plotting heatmaps for each variable 
getCodes(TRAIN_Som) %>%
  as_tibble() %>%
  iwalk(~plot(TRAIN_Som, type = "property", property = .,
              main = .y, shape = "straight"))

#Listing 15.6 Plotting flea species onto the SOM
par(mfrow = c(1, 2))
nodeCols <- c("cyan3",  "purple")
plot(TRAIN_Som, type = "mapping", pch = 21,
     bg = nodeCols[as.numeric(train_data_num$TARGET)],
     shape = "straight", bgcol = "lightgrey")

par(mfrow = c(1, 2))
nodeCols <- c("cyan3",  "purple")
plot(TRAIN_Som, type = "mapping", pch = 21,
     bg = nodeCols[as.numeric(train_data_num$TARGET)],
     shape = "straight", bgcol = "lightgrey")

#NEW DATA
test_data_num2<-test_data_num[,-1]
test_data_num <- as_tibble(test_data_num)


newData <- test_data_num %>%
  select(-TARGET) %>%
  scale(center = attr(Train_Scaled, "scaled:center"),
        scale = attr(Train_Scaled, "scaled:scale"))

predicted <- predict(TRAIN_Som, newData)
par(mfrow = c(1, 1))
plot(TRAIN_Som, type = "mapping", classif = predicted, shape = "round")

nodeCols <- c("cyan3",  "purple")
plot(TRAIN_Som, type = "mapping", classif = predicted, pch = 21,
     bg = nodeCols[as.numeric(test_data_num$TARGET)],
     shape = "straight", bgcol = "lightgrey")


#######################################################
#not scale use numeric
###################################################


library(kohonen)
library(tibble)
train_data_num <- as_tibble(train_data_num)

somGrid <- somgrid(xdim = 5, ydim = 5, topo = "hexagonal",
                   neighbourhood.fct = "bubble", toroidal = FALSE)

library(dplyr)
Train_Scaled2 <- train_data_num %>%
  select(-TARGET) %>%
  as.matrix()

set.seed(111)
TRAIN_Som2 <- som(Train_Scaled2, grid = somGrid, rlen = 500,
                 alpha = c(0.05, 0.01))


#NEED SAVE 
#Listing 15.4 Plotting SOM diagnostics
par(mfrow = c(2, 3))

plotTypes <- c("codes", "changes", "counts", "quality",
               "dist.neighbours", "mapping")

library(purrr)
walk(plotTypes, ~plot(TRAIN_Som2, type = ., shape = "straight"))


#Listing 15.6 Plotting flea species onto the SOM
par(mfrow = c(1, 2))
nodeCols <- c("cyan3",  "purple")
plot(TRAIN_Som2, type = "mapping", pch = 21,
     bg = nodeCols[as.numeric(train_data_num$TARGET)],
     shape = "straight", bgcol = "lightgrey")



#NEW DATA
test_data_num2<-test_data_num[,-1]
test_data_num <- as_tibble(test_data_num)


newData2 <- test_data_num %>%
  select(-TARGET) %>%
  as.matrix()

predicted2 <- predict(TRAIN_Som2, newData2)
par(mfrow = c(1, 1))
plot(TRAIN_Som2, type = "mapping", classif = predicted2, shape = "round")

nodeCols <- c("cyan3",  "purple")
plot(TRAIN_Som, type = "mapping", classif = predicted, pch = 21,
     bg = nodeCols[as.numeric(test_data_num$TARGET)],
     shape = "straight", bgcol = "lightgrey")
setwd('C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2022 12 19 VI Attribute selection strategy')
#https://finnstats.com/index.php/2021/04/27/self-organizing-maps/


##############
trainY<-as.factor(train_data_num[,1])
trainY<-factor(trainY)

set.seed(223)
map1 <- xyf(Train_Scaled2,
            classvec2classmat(factor(trainY)),
            grid = somgrid(5, 5, "hexagonal"),
            rlen = 500)
plot(map1, type='codes',palette.name = rainbow)

par(mfrow = c(1,2))
plot(map1,
     type = 'codes',
     main = c("Codes X", "Codes Y"))
map1.hc <- cutree(hclust(dist(map1$codes[[2]])), 2)
add.cluster.boundaries(map1, map1.hc)
par(mfrow = c(1,1))

nodeCols <- c("cyan3",  "purple")
plot(map1, type = "mapping", pch = 21,
     bg = nodeCols[as.numeric(train_data_num$TARGET)],
     shape = "straight", bgcol = "lightgrey")

#SAVE BEFORE
test<-test_data_num
test[,1] <- 0
testXY <- list(independent = newData2, dependent = test[,1])

#pred <- predict(map1, newdata = newData2)
#pred <- predict(map1, newdata = testXY)
#pos.prediction <- predict(NBA.SOM3, newdata = NBA.testing, whatmap = 1)
pred <- predict(map1, newdata = newData2, whatmap = 1)

nodeCols <- c("cyan3",  "purple")
plot(map1, type = "mapping", classif = pred, pch = 21,
     bg = nodeCols[as.numeric(test_data_num$TARGET)],
     shape = "straight", bgcol = "lightgrey")

predicted_value<-pred$predictions[[2]]

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, test_data_num$TARGET)
(bin_cm$record_level_cm)
