setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG")

train_data<-subset(PCA_TRAIN_ALL)
test_data<-subset(PCA_TEST_ALL)
names(train_data)[1]<-'TARGET'
names(test_data)[1]<-'TARGET'
#########################################################################################
#                           MODELIAI
########################################################################################
expected_value <- factor(c(test_data[,(1)]))
Predicted_values<-as.data.frame(test_data$TARGET)
names(Predicted_values)[1]<-'Real_target'
########################################################################################

reg_model<-glm(TARGET~.,  data=train_data[,1:2], family = binomial(link = 'logit'))
reg_model
summary(reg_model)


a_names<-"none"
a_names<-a_names[-1]
train_used<-train_data[,c(1:2)]

for (i in (1:dim(train_used)[2])){
  print(paste('v',i, sep='_'))
  a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
  a_value<-as.numeric(a_order[1])
  if (a_value==1){
    a_value<-as.numeric(a_order[2])
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_used) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))
    }}
  else{
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_used) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))}
  }
}

summary(reg_model)

#PREDICT
pred<-predict(reg_model,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$LG_PCA_1<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

Palyginimo<-as.data.frame(bin_cm$record_level_cm)
a<-names(Palyginimo)
a<-a[c(1:6,12,13,16,17,18,22)]
Palyginimo<-Palyginimo[,which(names(Palyginimo) %in% a)]
library(MLmetrics)
Palyginimo$AUC<-AUC(predicted_value, expected_value)
library(dgof)
Palyginimo$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
Palyginimo$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
Palyginimo$Error_rate<-1-Palyginimo$Accuracy
Palyginimo$Type_I_err<-Palyginimo$Pred_0_Ref_1/(Palyginimo$Pred_0_Ref_1+Palyginimo$Pred_1_Ref_1)
Palyginimo$Type_II_err<-Palyginimo$Pred_1_Ref_0/(Palyginimo$Pred_1_Ref_0+Palyginimo$Pred_0_Ref_0)
Palyginimo$MCC<-((Palyginimo$Pred_0_Ref_0*Palyginimo$Pred_1_Ref_1)-(Palyginimo$Pred_1_Ref_0*Palyginimo$Pred_0_Ref_1))/
  sqrt(as.numeric(Palyginimo$Pred_0_Ref_0+Palyginimo$Pred_1_Ref_0)*as.numeric(Palyginimo$Pred_0_Ref_0+Palyginimo$Pred_0_Ref_1)*as.numeric(Palyginimo$Pred_1_Ref_1+Palyginimo$Pred_1_Ref_0)*as.numeric((Palyginimo$Pred_1_Ref_1+Palyginimo$Pred_0_Ref_1)))
Palyginimo$G_mean<-sqrt(as.numeric(Palyginimo$Recall)*as.numeric(Palyginimo$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-pePCAormance-of-credit-score-models-59fe13ef420
Palyginimo$Gini<-2*Palyginimo$AUC-1
Palyginimo$Modelis<-"LG_PCA_1"

saveRDS(reg_model, file = paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG/", "LG_PCA_", 1, ".rda"))

#LG_1 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG/LG_PCA_1.rda")
#summary(LG_1)

######################2#################

reg_model<-glm(TARGET~.,  data=train_data[,c(1:3)], family = binomial(link = 'logit'))
reg_model
summary(reg_model)


a_names<-"none"
a_names<-a_names[-1]
train_used<-train_data[,c(1:3)]

for (i in (1:dim(train_used)[2])){
  print(paste('v',i, sep='_'))
  a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
  a_value<-as.numeric(a_order[1])
  if (a_value==1){
    a_value<-as.numeric(a_order[2])
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_used) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))
    }}
  else{
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_used) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))}
  }
}

summary(reg_model)

#PREDICT
pred<-predict(reg_model,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$aa<-predicted_value
col_name <- paste0("LG_PCA_", 2)
colnames(Predicted_values)[3] <- col_name

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
library(MLmetrics)
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-pePCAormance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-paste('LG_PCA_',2)
Palyginimo<-rbind(Palyginimo, New_row_pal)
saveRDS(reg_model, file = paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG/", "LG_PCA_", 2, ".rda"))

###############################################################
#                        3-15 cikliukas
################################################

setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG")
library(dgof)
library(MLmetrics)
library('ConfusionTableR')

train_used<-train_data[,]

for (j in (3:50)){
  print(j)
  n<-j+1
  train_used<-train_data[,c(1:n)]
  reg_model<-glm(TARGET~.,  data=train_used[,c(1:n)], family = binomial(link = 'logit'))
  a_names<-"none"
  a_names<-a_names[-1]
  for (i in (1:n)){
    print(paste('v',j,i, sep='_'))
    a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
    a_value<-as.numeric(a_order[1])
    if (a_value==1){
      a_value<-as.numeric(a_order[2])
      bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
      if (bigger==TRUE) {
        a_names<-append(a_names, names(reg_model$coefficients[a_value]))
        b_names<-as.numeric(which(names(train_used) %in% a_names))
        reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))
      }}
    else{
      bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
      if (bigger==TRUE) {
        a_names<-append(a_names, names(reg_model$coefficients[a_value]))
        b_names<-as.numeric(which(names(train_used) %in% a_names))
        reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))}
    }
  }
  pred<-predict(reg_model,test_data[,-c(1)])
  pred2<-ifelse(pred >= 0.5, 1, 0)
  predicted_value <- factor(c(pred2))
  Predicted_values$aa<-predicted_value
  col_name <- paste0("LG_PCA_", j)
  colnames(Predicted_values)[n] <- col_name
  
  bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
  New_row_pal<-as.data.frame(bin_cm$record_level_cm)
  New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
  New_row_pal$AUC<-AUC(predicted_value, expected_value)
  New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
  New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
  New_row_pal$Error_rate<-1-New_row_pal$Accuracy
  New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
  New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
  New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
    sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
  New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
  New_row_pal$Gini<-2*New_row_pal$AUC-1
  New_row_pal$Modelis<-paste('LG_PCA_',j)
  Palyginimo<-rbind(Palyginimo, New_row_pal)
  
  saveRDS(reg_model, file = paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG/", "LG_PCA_", j, ".rda"))
  write.csv(Palyginimo, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG/PCA_LG_pal.csv")
  write.csv(Predicted_values, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG/PCA_LG_values.csv")
}

#LG_1 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG/LG_PCA_15.rda")
#summary(LG_1)

###############################################################
#                        16:50 cikliukas
#51-100
################################################

setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG")
library(dgof)
library(MLmetrics)
library('ConfusionTableR')

train_used<-train_data[,]

for (j in (101:150)){
  print(j)
  n<-j+1
  train_used<-train_data[,c(1:n)]
  reg_model<-glm(TARGET~.,  data=train_used[,c(1:n)], family = binomial(link = 'logit'))
  a_names<-"none"
  a_names<-a_names[-1]
  for (i in (1:n)){
    print(paste('v',j,i, sep='_'))
    a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
    a_value<-as.numeric(a_order[1])
    if (a_value==1){
      a_value<-as.numeric(a_order[2])
      bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
      if (bigger==TRUE) {
        a_names<-append(a_names, names(reg_model$coefficients[a_value]))
        b_names<-as.numeric(which(names(train_used) %in% a_names))
        reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))
      }}
    else{
      bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
      if (bigger==TRUE) {
        a_names<-append(a_names, names(reg_model$coefficients[a_value]))
        b_names<-as.numeric(which(names(train_used) %in% a_names))
        reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))}
    }
  }
  pred<-predict(reg_model,test_data[,-c(1)])
  pred2<-ifelse(pred >= 0.5, 1, 0)
  predicted_value <- factor(c(pred2))
  Predicted_values$aa<-predicted_value
  col_name <- paste0("LG_PCA_", j)
  colnames(Predicted_values)[n] <- col_name
  
  bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
  New_row_pal<-as.data.frame(bin_cm$record_level_cm)
  New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
  New_row_pal$AUC<-AUC(predicted_value, expected_value)
  New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
  New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
  New_row_pal$Error_rate<-1-New_row_pal$Accuracy
  New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
  New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
  New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
    sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
  New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
  New_row_pal$Gini<-2*New_row_pal$AUC-1
  New_row_pal$Modelis<-paste('LG_PCA_',j)
  Palyginimo<-rbind(Palyginimo, New_row_pal)
  
  saveRDS(reg_model, file = paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG/", "LG_PCA_", j, ".rda"))
  write.csv(Palyginimo, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG/PCA_LG_pal.csv")
  write.csv(Predicted_values, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG/PCA_LG_values.csv")
}

#########################################################################################

LG_1 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG/LG_PCA_1.rda")
summary(LG_1)

Skaicius<-as.data.frame(LG_1$coefficients)
Skaicius$Feature<-row.names(Skaicius)
Skaicius<-Skaicius[,c(2,1)]
names(Skaicius)[2]<-'LG_PCA_1'

LG_2 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG/LG_PCA_2.rda")

df<-as.data.frame(LG_2$coefficients)
df$Feature<-row.names(df)
df<-df[,c(2,1)]
names(df)[2]<-'LG_PCA_2'

library(dplyr)
Skaicius<-full_join(Skaicius, df, by = "Feature")


Reiksmingumas<-data.frame('LG_PCA_1', with(summary(LG_1), 1 - deviance/null.deviance))
names(Reiksmingumas)[1]<-'Modelis'
names(Reiksmingumas)[2]<-'R2'

df2<-data.frame('LG_PCA_2', with(summary(LG_2), 1 - deviance/null.deviance))
names(df2)[1]<-'Modelis'
names(df2)[2]<-'R2'

Reiksmingumas<-rbind(Reiksmingumas,df2)


for (j in (3:10)){
  print(j)
  LG_2 = readRDS(paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG/", "LG_PCA_", j, ".rda"))
  df<-as.data.frame(LG_2$coefficients)
  df$Feature<-row.names(df)
  names(df)[1]<-paste0("LG_PCA_", j)
  Skaicius<-full_join(Skaicius, df, by = "Feature")
  df2<-data.frame(paste0('LG_PCA_', j), with(summary(LG_2), 1 - deviance/null.deviance))
  names(df2)<-c('Modelis', 'R2')
  Reiksmingumas<-rbind(Reiksmingumas,df2)}



for (j in (11:150)){
  print(j)
  LG_2 = readRDS(paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG/", "LG_PCA_", j, ".rda"))
  df<-as.data.frame(LG_2$coefficients)
  df$Feature<-row.names(df)
  names(df)[1]<-paste0("LG_PCA_", j)
  Skaicius<-full_join(Skaicius, df, by = "Feature")
  df2<-data.frame(paste0('LG_PCA_', j), with(summary(LG_2), 1 - deviance/null.deviance))
  names(df2)<-c('Modelis', 'R2')
  Reiksmingumas<-rbind(Reiksmingumas,df2)}

write.csv(Reiksmingumas, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG/PCA_reiksmingumas.csv")
write.csv(Skaicius, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 PCA LG/PCA_skaicius.csv")

for (j in 1:150){
  Reiksmingumas[j,1]<-paste0("LG_PCA_", j)
}

for (j in 2:151){
  names(Skaicius)[j]<-paste0("LG_PCA_", j-1)
}
