load("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2023 02 08 PCA dalimis/.RData")
setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2023 02 08 PCA dalimis")

###############################################################################
#PCA
###############################################################################
#BALANCE

library(stats)

pca_balance <- prcomp(train_balance,
                    center = TRUE,
                    scale. = TRUE) 



plot(pca_balance, type = "l")
summary(pca_balance)

pca_test_balance <-predict(pca_balance, 
                   newdata=test_balance)

#biplot(pca_balance)

names(pca_balance)
dim(pca_balance$x)
pr.var=pca_balance$sdev^2
pve=pr.var/sum(pr.var)
plot(cumsum(pve), col="red", xlab="Principal Component",ylab="Cumulative Proportion of Variance Explained",ylim=c(0,1),type="b")

# First 80 Principal Components which explain about 80% of the variation are selected for further analysis
sum(pve[1:9])# 95 proc., 100 - 90 proc.
loadings <- as.data.frame(pca_balance$rotation[,1:9])

df_train=as.data.frame(pca_balance$x[,1:9])

df_train=cbind(train_data_num$TARGET,df_train)
df_test=as.data.frame(pca_test_balance[,1:9])
df_test=cbind(test_data_num$TARGET,df_test)

names(df_train)<-paste0('balance_', names(df_train))
names(df_test)<-paste0('balance_', names(df_test))

names(df_train)[1]<-'TARGET'
names(df_test)[1]<-'TARGET'
library(stats)
plot(pca_balance $x[,1], pca_balance$x[,2], pch=18, xlab='1 komponente', col=train_data_num$TARGET, ylab='2 komponete')
plot(df_test$balance_PC1, df_test$balance_PC2, pch=18, xlab='1 komponente', col=test_data_num$TARGET, ylab='2 komponete')

TRAIN_DATA_PCA<-df_train[,]
TEST_DATA_PCA<-df_test[,]

##RATIO
library(stats)

pca_ratio <- prcomp(train_ratio,
                      center = TRUE,
                      scale. = TRUE) 



plot(pca_ratio, type = "l")

pca_test_ratio <-predict(pca_ratio, 
                           newdata=test_ratio)

dim(pca_ratio$x)
pr.var=pca_ratio$sdev^2
pve=pr.var/sum(pr.var)
plot(cumsum(pve), col="red", xlab="Principal Component",ylab="Cumulative Proportion of Variance Explained",ylim=c(0,1),type="b")

# First 80 Principal Components which explain about 80% of the variation are selected for further analysis
sum(pve[1:30])# 95 proc., 100 - 90 proc.
loadings <- as.data.frame(pca_ratio$rotation[,1:30])

df_train=as.data.frame(pca_ratio$x[,1:30])

df_test=as.data.frame(pca_test_ratio[,1:30])


names(df_train)<-paste0('ratio_', names(df_train))
names(df_test)<-paste0('ratio_', names(df_test))

plot(pca_ratio $x[,1], pca_ratio$x[,2], pch=18, xlab='1 komponente', col=train_data_num$TARGET, ylab='2 komponete')
plot(df_test$ratio_PC1, df_test$ratio_PC2, pch=18, xlab='1 komponente', col=test_data_num$TARGET, ylab='2 komponete')

TRAIN_DATA_PCA<-cbind(TRAIN_DATA_PCA, df_train)
TEST_DATA_PCA<-cbind(TEST_DATA_PCA, df_test)

##makro
library(stats)

pca_makro <- prcomp(train_makro,
                    center = TRUE,
                    scale. = TRUE) 



plot(pca_makro, type = "l")

pca_test_makro <-predict(pca_makro, 
                         newdata=test_makro)

dim(pca_makro$x)
pr.var=pca_makro$sdev^2
pve=pr.var/sum(pr.var)
plot(cumsum(pve), col="red", xlab="Principal Component",ylab="Cumulative Proportion of Variance Explained",ylim=c(0,1),type="b")

# First 80 Principal Components which explain about 80% of the variation are selected for further analysis
sum(pve[1:2])# 95 proc., 100 - 90 proc.
loadings <- as.data.frame(pca_makro$rotation[,1:2])

df_train=as.data.frame(pca_makro$x[,1:2])
df_test=as.data.frame(pca_test_makro[,1:2])

names(df_train)<-paste0('makro_', names(df_train))
names(df_test)<-paste0('makro_', names(df_test))

library(stats)
plot(pca_makro $x[,1], pca_makro$x[,2], pch=18, xlab='1 komponente', col=train_data_num$TARGET, ylab='2 komponete')
plot(df_test$makro_PC1, df_test$makro_PC2, pch=18, xlab='1 komponente', col=test_data_num$TARGET, ylab='2 komponete')

TRAIN_DATA_PCA<-cbind(TRAIN_DATA_PCA, df_train)
TEST_DATA_PCA<-cbind(TEST_DATA_PCA, df_test)


##sector_ratio
library(stats)

pca_sector_ratio <- prcomp(train_sector_ratio,
                    center = TRUE,
                    scale. = TRUE) 



plot(pca_sector_ratio, type = "l")

pca_test_sector_ratio <-predict(pca_sector_ratio, 
                         newdata=test_sector_ratio)

dim(pca_sector_ratio$x)
pr.var=pca_sector_ratio$sdev^2
pve=pr.var/sum(pr.var)
plot(cumsum(pve), col="red", xlab="Principal Component",ylab="Cumulative Proportion of Variance Explained",ylim=c(0,1),type="b")

# First 80 Principal Components which explain about 80% of the variation are selected for further analysis
sum(pve[1:5])# 95 proc., 100 - 90 proc.
loadings <- as.data.frame(pca_sector_ratio$rotation[,1:5])

df_train=as.data.frame(pca_sector_ratio$x[,1:5])
df_test=as.data.frame(pca_test_sector_ratio[,1:5])

names(df_train)<-paste0('sector_ratio_', names(df_train))
names(df_test)<-paste0('sector_ratio_', names(df_test))

library(stats)
plot(pca_sector_ratio $x[,1], pca_sector_ratio$x[,2], pch=18, xlab='1 komponente', col=train_data_num$TARGET, ylab='2 komponete')
plot(df_test$sector_ratio_PC1, df_test$sector_ratio_PC2, pch=18, xlab='1 komponente', col=test_data_num$TARGET, ylab='2 komponete')

TRAIN_DATA_PCA<-cbind(TRAIN_DATA_PCA, df_train)
TEST_DATA_PCA<-cbind(TEST_DATA_PCA, df_test)

##Sodra_emp
library(stats)

pca_Sodra_emp <- prcomp(train_Sodra_emp,
                           center = TRUE,
                           scale. = TRUE) 



plot(pca_Sodra_emp, type = "l")

pca_test_Sodra_emp <-predict(pca_Sodra_emp, 
                                newdata=test_Sodra_emp)

dim(pca_Sodra_emp$x)
pr.var=pca_Sodra_emp$sdev^2
pve=pr.var/sum(pr.var)
plot(cumsum(pve), col="red", xlab="Principal Component",ylab="Cumulative Proportion of Variance Explained",ylim=c(0,1),type="b")

# First 80 Principal Components which explain about 80% of the variation are selected for further analysis
sum(pve[1:3])# 95 proc., 100 - 90 proc.
loadings <- as.data.frame(pca_Sodra_emp$rotation[,1:3])

df_train=as.data.frame(pca_Sodra_emp$x[,1:3])
df_test=as.data.frame(pca_test_Sodra_emp[,1:3])

names(df_train)<-paste0('Sodra_emp_', names(df_train))
names(df_test)<-paste0('Sodra_emp_', names(df_test))

library(stats)
plot(pca_Sodra_emp $x[,1], pca_Sodra_emp$x[,2], pch=18, xlab='1 komponente', col=train_data_num$TARGET, ylab='2 komponete')
plot(df_test$Sodra_emp_PC1, df_test$Sodra_emp_PC2, pch=18, xlab='1 komponente', col=test_data_num$TARGET, ylab='2 komponete')

TRAIN_DATA_PCA<-cbind(TRAIN_DATA_PCA, df_train)
TEST_DATA_PCA<-cbind(TEST_DATA_PCA, df_test)

##Sodra_Delay
library(stats)

pca_Sodra_Delay <- prcomp(train_Sodra_Delay,
                        center = TRUE,
                        scale. = TRUE) 



plot(pca_Sodra_Delay, type = "l")

pca_test_Sodra_Delay <-predict(pca_Sodra_Delay, 
                             newdata=test_Sodra_Delay)

dim(pca_Sodra_Delay$x)
pr.var=pca_Sodra_Delay$sdev^2
pve=pr.var/sum(pr.var)
plot(cumsum(pve), col="red", xlab="Principal Component",ylab="Cumulative Proportion of Variance Explained",ylim=c(0,1),type="b")

# First 80 Principal Components which explain about 80% of the variation are selected for further analysis
sum(pve[1:13])# 95 proc., 100 - 90 proc.
loadings <- as.data.frame(pca_Sodra_Delay$rotation[,1:13])

df_train=as.data.frame(pca_Sodra_Delay$x[,1:13])
df_test=as.data.frame(pca_test_Sodra_Delay[,1:13])

names(df_train)<-paste0('Sodra_Delay_', names(df_train))
names(df_test)<-paste0('Sodra_Delay_', names(df_test))

library(stats)
plot(pca_Sodra_Delay $x[,1], pca_Sodra_Delay$x[,2], pch=18, xlab='1 komponente', col=train_data_num$TARGET, ylab='2 komponete')
plot(df_test$Sodra_Delay_PC1, df_test$Sodra_Delay_PC2, pch=18, xlab='1 komponente', col=test_data_num$TARGET, ylab='2 komponete')

TRAIN_DATA_PCA<-cbind(TRAIN_DATA_PCA, df_train)
TEST_DATA_PCA<-cbind(TEST_DATA_PCA, df_test)

##cort
library(stats)

pca_cort <- prcomp(train_cort,
                          center = TRUE,
                          scale. = TRUE) 



plot(pca_cort, type = "l")

pca_test_cort <-predict(pca_cort, 
                               newdata=test_cort)

dim(pca_cort$x)
pr.var=pca_cort$sdev^2
pve=pr.var/sum(pr.var)
plot(cumsum(pve), col="red", xlab="Principal Component",ylab="Cumulative Proportion of Variance Explained",ylim=c(0,1),type="b")

# First 80 Principal Components which explain about 80% of the variation are selected for further analysis
sum(pve[1:6])# 95 proc., 100 - 90 proc.
loadings <- as.data.frame(pca_cort$rotation[,1:6])

df_train=as.data.frame(pca_cort$x[,1:6])
df_test=as.data.frame(pca_test_cort[,1:6])

names(df_train)<-paste0('cort_', names(df_train))
names(df_test)<-paste0('cort_', names(df_test))

library(stats)
plot(pca_cort $x[,1], pca_cort$x[,2], pch=18, xlab='1 komponente', col=train_data_num$TARGET, ylab='2 komponete')
plot(df_test$cort_PC1, df_test$cort_PC2, pch=18, xlab='1 komponente', col=test_data_num$TARGET, ylab='2 komponete')

TRAIN_DATA_PCA<-cbind(TRAIN_DATA_PCA, df_train)
TEST_DATA_PCA<-cbind(TEST_DATA_PCA, df_test)

##Board
library(stats)

pca_Board <- prcomp(train_Board,
                   center = TRUE,
                   scale. = TRUE) 



plot(pca_Board, type = "l")

pca_test_Board <-predict(pca_Board, 
                        newdata=test_Board)

dim(pca_Board$x)
pr.var=pca_Board$sdev^2
pve=pr.var/sum(pr.var)
plot(cumsum(pve), col="red", xlab="Principal Component",ylab="Cumulative Proportion of Variance Explained",ylim=c(0,1),type="b")

# First 80 Principal Components which explain about 80% of the variation are selected for further analysis
sum(pve[1:12])# 95 proc., 100 - 90 proc.
loadings <- as.data.frame(pca_Board$rotation[,1:12])

df_train=as.data.frame(pca_Board$x[,1:12])
df_test=as.data.frame(pca_test_Board[,1:12])

names(df_train)<-paste0('Board_', names(df_train))
names(df_test)<-paste0('Board_', names(df_test))

library(stats)
plot(pca_Board $x[,1], pca_Board$x[,2], pch=18, xlab='1 komponente', col=train_data_num$TARGET, ylab='2 komponete')
plot(df_test$Board_PC1, df_test$Board_PC2, pch=18, xlab='1 komponente', col=test_data_num$TARGET, ylab='2 komponete')

TRAIN_DATA_PCA<-cbind(TRAIN_DATA_PCA, df_train)
TEST_DATA_PCA<-cbind(TEST_DATA_PCA, df_test)

##VMI
library(stats)

pca_VMI <- prcomp(train_VMI,
                    center = TRUE,
                    scale. = TRUE) 



plot(pca_VMI, type = "l")

pca_test_VMI <-predict(pca_VMI, 
                         newdata=test_VMI)

dim(pca_VMI$x)
pr.var=pca_VMI$sdev^2
pve=pr.var/sum(pr.var)
plot(cumsum(pve), col="red", xlab="Principal Component",ylab="Cumulative Proportion of Variance Explained",ylim=c(0,1),type="b")

# First 80 Principal Components which explain about 80% of the variation are selected for further analysis
sum(pve[1])# 95 proc., 100 - 90 proc.
loadings <- as.data.frame(pca_VMI$rotation[,1])

df_train=as.data.frame(pca_VMI$x[,1])
df_test=as.data.frame(pca_test_VMI[,1])

names(df_train)<-paste0('VMI_', names(df_train))
names(df_test)<-paste0('VMI_', names(df_test))

library(stats)
plot(pca_VMI $x[,1], pca_VMI$x[,2], pch=18, xlab='1 komponente', col=train_data_num$TARGET, ylab='2 komponete')
plot(df_test$VMI_PC1, df_test$VMI_PC2, pch=18, xlab='1 komponente', col=test_data_num$TARGET, ylab='2 komponete')

TRAIN_DATA_PCA<-cbind(TRAIN_DATA_PCA, df_train)
TEST_DATA_PCA<-cbind(TEST_DATA_PCA, df_test)

##other
library(stats)

pca_other <- prcomp(train_other,
                    center = TRUE,
                    scale. = TRUE) 



plot(pca_other, type = "l")

pca_test_other <-predict(pca_other, 
                         newdata=test_other)

dim(pca_other$x)
pr.var=pca_other$sdev^2
pve=pr.var/sum(pr.var)
plot(cumsum(pve), col="red", xlab="Principal Component",ylab="Cumulative Proportion of Variance Explained",ylim=c(0,1),type="b")

# First 80 Principal Components which explain about 80% of the variation are selected for further analysis
sum(pve[1:6])# 95 proc., 100 - 90 proc.
loadings <- as.data.frame(pca_other$rotation[,1:6])

df_train=as.data.frame(pca_other$x[,1:6])
df_test=as.data.frame(pca_test_other[,1:6])

names(df_train)<-paste0('other_', names(df_train))
names(df_test)<-paste0('other_', names(df_test))

library(stats)
plot(pca_other $x[,1], pca_other$x[,2], pch=18, xlab='1 komponente', col=train_data_num$TARGET, ylab='2 komponete')
plot(df_test$other_PC1, df_test$other_PC2, pch=18, xlab='1 komponente', col=test_data_num$TARGET, ylab='2 komponete')

TRAIN_DATA_PCA<-cbind(TRAIN_DATA_PCA, df_train)
TEST_DATA_PCA<-cbind(TEST_DATA_PCA, df_test)


####################################
library("FactoMineR")
library('ggplot2')
library(factoextra)
#https://www.kaggle.com/code/intelligencerefinery/factor-analysis-of-mixed-data-in-r

train_type <- lapply(train_type, as.factor)
train_type<-as.data.frame(train_type)
train_type2 <-cbind(TRAIN_DATA_PCA$TARGET, train_type)
names(train_type2)[1]<-'TARGET'

res.famd_type <- FAMD(train_type2, 
                   sup.var = 1,  ## Set the target variable "Churn" as a supplementary variable
                   graph =  FALSE, 
                   ncp=2)

test_type <- lapply(test_type, as.factor)
test_type<-as.data.frame(test_type)
test_type2 <-cbind(TEST_DATA_PCA$TARGET, test_type)
names(test_type2)[1]<-'TARGET'

FAMD_pred<-predict(res.famd_type, newdata=test_type2)


df_train<-get_famd_ind(res.famd_type)
df_train<-as.data.frame(df_train$coord)
df_test<-as.data.frame(FAMD_pred$coord)

names(df_train)<-paste0('type_', names(df_train))
names(df_test)<-paste0('type_', names(df_test))
names(df_test)<-names(df_train)

library(stats)
plot(df_train$type_Dim.1, df_train$type_Dim.1, pch=18, xlab='1 komponente', col=train_data_num$TARGET, ylab='2 komponete')
plot(df_test$`type_Dim.1`,df_test$type_Dim.1, pch=18, xlab='1 komponente', col=test_data_num$TARGET, ylab='2 komponete')

TRAIN_DATA_PCA<-cbind(TRAIN_DATA_PCA, df_train)
TEST_DATA_PCA<-cbind(TEST_DATA_PCA, df_test)

library("FactoMineR")
library('ggplot2')
library(factoextra)
#https://www.kaggle.com/code/intelligencerefinery/factor-analysis-of-mixed-data-in-r

train_sector_class <- lapply(train_sector_class, as.factor)
train_sector_class<-as.data.frame(train_sector_class)
train_sector_class2 <-cbind(TRAIN_DATA_PCA$TARGET, train_sector_class)
names(train_sector_class2)[1]<-'TARGET'

res.famd_sector_class <- FAMD(train_sector_class2, 
                      sup.var = 1,  ## Set the target variable "Churn" as a supplementary variable
                      graph =  FALSE, 
                      ncp=4)

test_sector_class <- lapply(test_sector_class, as.factor)
test_sector_class<-as.data.frame(test_sector_class)
test_sector_class2 <-cbind(TEST_DATA_PCA$TARGET, test_sector_class)
names(test_sector_class2)[1]<-'TARGET'

FAMD_pred<-predict(res.famd_sector_class, newdata=test_sector_class2)


df_train<-get_famd_ind(res.famd_sector_class)
df_train<-as.data.frame(df_train$coord)
df_test<-as.data.frame(FAMD_pred$coord)

names(df_train)<-paste0('sector_class_', names(df_train))
names(df_test)<-paste0('sector_class_', names(df_test))
names(df_test)<-names(df_train)

library(stats)
plot(df_train$sector_class_Dim.1, df_train$sector_class_Dim.1, pch=18, xlab='1 komponente', col=train_data_num$TARGET, ylab='2 komponete')
plot(df_test$`sector_class_Dim.1`,df_test$sector_class_Dim.1, pch=18, xlab='1 komponente', col=test_data_num$TARGET, ylab='2 komponete')

TRAIN_DATA_PCA<-cbind(TRAIN_DATA_PCA, df_train)
TEST_DATA_PCA<-cbind(TEST_DATA_PCA, df_test)
