



setwd('C:/Users/Dovile/Desktop/Disertacija/DATA 22_08 kas liko/04_03 Atributu vizualizavimas')

Train_grafikai<-TRAIN_ALL_atr[,c(1,2,41,326,16,337,206,488,458)]
names(Train_grafikai)[1]<-'Class'
Train_grafikai$Class<-as.factor(Train_grafikai$Class)
names(Train_grafikai)<-c('Class', '9_History_Bad_freq', "2_ROA_Y1", '4_As_debtor_freq', '7_Delay_Y1_M12', '1_Director_change_freq', '8_Payment_Y1', '6_Retention_ratio_Y1', '5_GDP_PROC_Y1_Q3')

Train_grafikai_smote<-train_data[,c(1,2,41,326,16,337,206,488,458)]
Test_grafikai<-TEST_ALL_atr[,c(1,2,41,326,16,337,206,488,458)]

names(Train_grafikai)
names(Train_grafikai_smote)
names(Test_grafikai)



names(Train_grafikai)<-c('Class', '9_History_Bad_freq', "2_ROA_Y1", '4_As_debtor_freq', '7_Delay_Y1_M12', '1_Director_change_freq', '8_Payment_Y1', '6_Retention_ratio_Y1', '5_GDP_PROC_Y1_Q3')
names(Train_grafikai_smote)<-names(Train_grafikai)
names(Test_grafikai)<-names(Train_grafikai)
Train_grafikai$Class<-as.factor(Train_grafikai$Class)
Train_grafikai_smote$Class<-as.factor(Train_grafikai_smote$Class)
Test_grafikai$Class<-as.factor(Test_grafikai$Class)

Train_grafikai$Class<-ifelse(Train_grafikai$Class==1, 'Financial distress', "Non-Financial distress")
library(tidyr)
library(dplyr)
library(ggplot2)
library(ggridges)

#install.packages('forcats')
library('forcats')
Train_grafikai %>%
  gather(variable, value, -Class) %>%
  mutate(variable = fct_rev(variable)) %>%
  ggplot(aes(y = variable, 
             fill = Class, 
             x = percent_rank(value))) +
  geom_density_ridges(alpha=.3)+
  labs(title="Attributes density curve (train data)",x="Percentage", y = "Density ")+
  scale_fill_manual(values = c( "grey", '#4E84C4'))+
  theme(text = element_text(size = 20))+labs(colour =" liai ")



TG<-Train_grafikai %>%
  gather(variable, value, -Class) %>%
  mutate(variable = fct_rev(variable)) %>%
  ggplot(aes(y = variable, 
             fill = Class, 
             x = percent_rank(value))) +
  geom_density_ridges(alpha=.3)+
  labs(title=" ",x=" ", y = " ")+
  scale_fill_manual(values = c('#4E84C4', "grey"))+  #kadangi pakeiciau pavadinima tai ir spalvas sukeisti reikia
  theme(text = element_text(size = 20))

TGS<-Train_grafikai_smote %>%
  gather(variable, value, -Class) %>%
  mutate(variable = fct_rev(variable)) %>%
  ggplot(aes(y = variable, 
             fill = Class, 
             x = percent_rank(value))) +
  geom_density_ridges(alpha=.3)+
  labs(title=" ",x=" ", y = "Density")+
  scale_fill_manual(values = c( "grey", '#4E84C4'))+
  theme(text = element_text(size = 20))
TGS

TsG<-Test_grafikai %>%
  gather(variable, value, -Class) %>%
  mutate(variable = fct_rev(variable)) %>%
  ggplot(aes(y = variable, 
             fill = Class, 
             x = percent_rank(value))) +
  geom_density_ridges(alpha=.3)+
  labs(title=" ",x=" ", y = "Density")+
  scale_fill_manual(values = c( "grey", '#4E84C4'))+
  theme(text = element_text(size = 20))
TsG

library(ggpubr)
ggarrange(TG,
          TGS + 
            theme(axis.text.y = element_blank(),
                  axis.ticks.y = element_blank(),
                  axis.title.y = element_blank() ), 
         TsG + 
            theme(axis.text.y = element_blank(),
                  axis.ticks.y = element_blank(),
                  axis.title.y = element_blank()),
          common.legend = TRUE,  legend="bottom",
          labels = c("a)", "b)", "c)"),
          ncol = 3, nrow = 1, widths = c(0.4, 0.3,0.3))



#############

table(TRAIN_ALL_atr$LF_AB, TRAIN_ALL_atr$FINAL_STATUS_II, useNA = "always")
table(TRAIN_ALL_atr$LF_UAB, TRAIN_ALL_atr$FINAL_STATUS_II, useNA = "always")
table(TRAIN_ALL_atr$LF_II, TRAIN_ALL_atr$FINAL_STATUS_II, useNA = "always")
table(TRAIN_ALL_atr$LF_MB, TRAIN_ALL_atr$FINAL_STATUS_II, useNA = "always")

table(TEST_ALL_atr$LF_AB, TEST_ALL_atr$FINAL_STATUS_II, useNA = "always")
table(TEST_ALL_atr$LF_UAB, TEST_ALL_atr$FINAL_STATUS_II, useNA = "always")
table(TEST_ALL_atr$LF_II, TEST_ALL_atr$FINAL_STATUS_II, useNA = "always")
table(TEST_ALL_atr$LF_MB, TEST_ALL_atr$FINAL_STATUS_II, useNA = "always")

table(train_data$LF_AB, train_data$Class, useNA = "always")
table(train_data$LF_UAB, train_data$Class, useNA = "always")
table(train_data$LF_II, train_data$Class,useNA = "always")
table(train_data$LF_MB, train_data$Class, useNA = "always")


names(ALL_atr)
Nace_values<-as.data.frame(colSums(ALL_atr[,422:438]))

names(Nace_values)[1]<-'value'
Nace_values$Sector<-rownames(Nace_values)

install.packages('treemap')
library(treemap)
treemap(Nace_values,
        index="Sector",
        vSize="value",
        type="index",
        border.col=c("black")
)

#############################

library("cowplot")
ggdraw() +
  draw_plot(TG, x = 0, y = 0, width = .3, height = 1) +
  draw_plot(TGS, x = .33, y = 0, width = .3, height = 1) +
  draw_plot(TsG, x = 0.66, y = 0, width = .3, height = 1) +
  draw_plot_label(label = c("a)", "b)", 'c)'), size = 20,
                  x = c(0,0.33,0.66), y = c(1, 1, 1))


library(ggplot2)
library(cowplot)
library(rlang)

legend <- get_legend(TG)

# align all plots vertically
plots <- align_plots(TG, TGS, TsG, align = 'v', axis = 'l')

plot_grid(
  plots[[2]], plots[[3]], legend,
  labels = c(,"A" "B", "C"),
  rel_widths = c(1, 1, .3),
  nrow = 1
)

plot_grid(plots[[1]], plots[[2]],plots[[3]], legend , nrow = 1)
