setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2022 11 30 h20")


table(ALL_atr_ch_D_strong$FINAL_STATUS_II)

TRAIN_ALL_atr<-subset(ALL_atr_ch_D_strong, STATUS_YEAR_GROUP !=2022)
TEST_ALL_atr<-subset(ALL_atr_ch_D_strong, STATUS_YEAR_GROUP ==2022)
names(TEST_ALL_atr)

TRAIN_ALL_atr<-TRAIN_ALL_atr[,-c(1,3:5)]
TEST_ALL_atr<-TEST_ALL_atr[,-c(1,3:5)]
df<-TRAIN_ALL_atr
library(caret)
df<-preProcess(df, method=c("range"))
train_data<-predict(df, TRAIN_ALL_atr)
test_data<-predict(df, TEST_ALL_atr)


train_data[is.na(train_data)] = 0
test_data[is.na(test_data)] = 0

names(train_data)[1]<-'TARGET'
names(test_data)[1]<-'TARGET'
train_data$TARGET<-as.factor(train_data$TARGET)
test_data$TARGET<-as.factor(test_data$TARGET)

#pamaisymas
set.seed(7)
rows <- sample(nrow(train_data))
train_data<-train_data[rows,]
rows <- sample(nrow(test_data))
test_data<-test_data[rows,]
table(train_data$TARGET)
prop.table(table(train_data$TARGET))
table(test_data$TARGET)
prop.table(table(test_data$TARGET))
##########################UNSUPERVISED METHODS###################

###############ISOLATION FOREST############################


library(isotree)
X = data.matrix(train_data[,-c(1)])
X_test = data.matrix(test_data[,-c(1)])

#labels
#y<-train_data$TARGET
#y_test<-test_data$TARGET

y<-as.matrix(train_data$TARGET)
y_test<-as.matrix(test_data$TARGET)

iso_train <- isolation.forest(X)

model <- isolation.forest(iso_train)
#ndim=1Number of columns to combine to produce a split


iso <- isolation.forest(as.matrix(Inventi_ML1_train[,-c(2)]))

isopredict1 <- predict(iso, as.matrix(Inventi_ML1_test[,-c(2)]))

isopredict1 <- as.factor(ifelse(isopredict1 > 0.5, 1, 0))


library(h2o)
h2o.init()

df.hex <- as.h2o(train_data)
predictors<-names(train_data)
predictors<-predictors[-1]

model <- h2o.extendedIsolationForest(x = predictors,
                                     training_frame = df.hex,
                                     model_id = "eif.hex",
                                     ntrees = 100,
                                     sample_size = 256,
                                     extension_level = length(predictors) - 1)
score <- h2o.predict(model, df.hex)
anomaly_score <- score$anomaly_score
score
h2o.giniCoef(score)



################
df.hex[,'TARGET'] <- as.factor(df.hex[,'TARGET'])
test_h2o[,y] <- as.factor(test_h2o[,y])

svm_model <- h2o.psvm(gamma = 0.01,
                      rank_ratio = 0.1,
                      y = "TARGET",
                      training_frame = df.hex,
                      disable_training_metrics = FALSE)

# Eval performance:
valid<-as.h2o(test_data)
perf <- h2o.performance(svm_model, valid)
pred<-h2o.predict(svm_model, valid)


perf
h2o.giniCoef(perf)
h2o.mcc(perf)

summary(perf)

cvpreds_id <- svm_model@model$cross_validation_holdout_predictions_frame_id$name
cvpreds <- h2o.getFrame(cvpreds_id)


pred <- h2o.predict(svm_model, valid)  # predict(aml, test) also works

# or:
pred <- h2o.predict(svm_model@leader, valid)

