load("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2022 12 19 V Attribute selection strategy/.RData")
setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2022 12 19 V Attribute selection strategy")


TRAIN_ALL_atr<-subset(ALL_atr, STATUS_YEAR_GROUP !=2022)
TEST_ALL_atr<-subset(ALL_atr, STATUS_YEAR_GROUP ==2022)
names(ALL_atr)

TRAIN_ALL_atr<-TRAIN_ALL_atr[,-c(1,3:5)]
TEST_ALL_atr<-TEST_ALL_atr[,-c(1,3:5)]
df<-TRAIN_ALL_atr
library(caret)
df<-preProcess(df, method=c("range"))
train_data<-predict(df, TRAIN_ALL_atr)
test_data<-predict(df, TEST_ALL_atr)

train_data[is.na(train_data)] = 0
test_data[is.na(test_data)] = 0

#Variation check
table(train_data$T_1_Long_yield_MAX, useNA = 'always')
table(train_data$T_2_Long_yield_MIN, useNA = 'always')
table(train_data$T_2_Long_yield_LAST_VALUE, useNA = 'always')
table(train_data$Active_owner_at_the_same_time, useNA = 'always')
#trys atmetami
a_names<-c('T_1_Long_yield_MAX','T_2_Long_yield_MIN', 'T_2_Long_yield_LAST_VALUE', 'Active_owner_at_the_same_time')
b_values<-which(names(train_data) %in% a_names)
train_data<-train_data[,-c(b_values)]
test_data<-test_data[,-c(b_values)]

#####################################################

a_names<-NA
for (i in 2:dim(train_data)[2]){
  print(names(train_data)[i])
  if(length(which(!(names(table(train_data[,i])) %in% c(0,1)))) == 0)
  {a_names<-append(a_names, names(train_data)[i])}}


a_names
a_names<-a_names[-c(1,6:16,34:38)]
b_values<-which(names(train_data) %in% a_names)
a_names
for (i in b_values){
  print(i)
  train_data[,i]<-as.factor(train_data[,i])
  test_data[,i]<-as.factor(test_data[,i])
}

names(train_data)[1]<-'TARGET'
names(test_data)[1]<-'TARGET'
train_data$TARGET<-as.factor(train_data$TARGET)
test_data$TARGET<-as.factor(test_data$TARGET)

#####################################################SMOTE################################
###################################
library(themis)
smotenc_data<-smotenc(train_data, var = 'TARGET', k = 5, over_ratio = 1)
table(smotenc_data$TARGET)

smotenc_data$the_same<-Reduce(`&`, Map(`==`, train_data, smotenc_data))
smotenc_data$row_number<-row.names(smotenc_data)

train_data<-smotenc_data[,]

set.seed(7)
rows <- sample(nrow(train_data))
train_data<-train_data[rows,]

last_columns<-length(train_data)
last_columns<-as.numeric(last_columns)
last_columns<-append(last_columns,last_columns-1)

Train_data_rows_identification<-train_data[,last_columns]

train_data<-train_data[,-c(last_columns)]

#################################
a_names<-NA
for (i in 1:dim(train_data)[2]){
  print(names(train_data)[i])
  if(is.factor(train_data[,i]) == "TRUE")
  {a_names<-append(a_names, names(train_data)[i])}}

a_names<-a_names[-c(1:2)]
b_values<-which(names(train_data) %in% a_names)

train_data_num<-train_data[,]
test_data_num<-test_data[,]
for (i in b_values){
  print(names(train_data)[i])
  train_data_num[,i]<-as.numeric(train_data_num[,i])
  test_data_num[,i]<-as.numeric(test_data_num[,i])}

#####################for only numeric
a_names
b_values<-which(names(train_data_num) %in% a_names)
train_data_num2<-train_data_num[,-c(b_values)]
test_data_num2<-test_data_num[,-c(b_values)]


###########################################################################################
# LDA
####################################################################################

library(klaR)
library(psych)
library(MASS)
library(ggord)
library(devtools)

linear <- lda(TARGET~., train_data_num)
linear

p <- predict(linear, train_data_num)
LDA_train_data<-data.frame(p)
LDA_train_data<-cbind(train_data[,c(1)],LDA_train_data)
names(LDA_train_data)[1]<-'TARGET'
LDA_train_data_2<-LDA_train_data[,c(1,5)]


p2 <- predict(linear, test_data_num)
#TARGET
p2_class<-p2$class

LDA_test_data<-data.frame(p2)
LDA_test_data<-cbind(test_data[,c(1)],LDA_test_data)
names(LDA_test_data)[1]<-'TARGET'
LDA_test_data_2<-LDA_test_data[,c(1,5)]



#quadratic LDA _____________NESUSIDARE

quadratic <- qda(TARGET~., train_data_num)
quadratic

pq <- predict(quadratic, train_data_num)
QDA_train_data<-data.frame(pq)
QDA_train_data<-cbind(train_data[,c(1)],QDA_train_data)
names(QDA_train_data)[1]<-'TARGET'
QDA_train_data_2<-QDA_train_data[,c(1,5)]


pq2 <- predict(quadratic, test_data_num)
#TARGET
pq2_class<-p2$class

QDA_test_data<-data.frame(pq2)
QDA_test_data<-cbind(test_data[,c(1)],QDA_test_data)
names(QDA_test_data)[1]<-'TARGET'
QDA_test_data_2<-QDA_test_data[,c(1,5)]


###############################################################################
#PCA
###############################################################################
#1 PCA ALL
#######################################################################

library(stats)

I.variables<-train_data_num[,-1]

pca_train <- prcomp(I.variables,
                    center = TRUE,
                    scale. = TRUE) 



plot(pca_train, type = "l")
summary(pca_train)

pca_test <-predict(pca_train, 
                   newdata=test_data_num[,-1])

biplot(pca_train)


#pr.out=prcomp(B_CAll_app_Norm[,2:31],scale=TRUE)
names(pca_train)
summary(pca_train)
dim(pca_train$x)
pr.var=pca_train$sdev^2
pve=pr.var/sum(pr.var)
plot(cumsum(pve), col="red", xlab="Principal Component",ylab="Cumulative Proportion of Variance Explained",ylim=c(0,1),type="b")

# First 80 Principal Components which explain about 80% of the variation are selected for further analysis
sum(pve[1:100])# 95 proc., 100 - 90 proc.
loadings <- as.data.frame(pca_train$rotation[,1:100])

PCA_TRAIN_data.final=as.data.frame(pca_train$x[,1:100])

PCA_TRAIN_data.final=cbind(train_data$TARGET,PCA_TRAIN_data.final)
dim(pca_test)
PCA_TEST_data.final=as.data.frame(pca_test[,1:100])
PCA_TEST_data.final=cbind(test_data$TARGET,PCA_TEST_data.final)

names(PCA_TEST_data.final)[1]<-'TARGET'
names(PCA_TRAIN_data.final)[1]<-'TARGET'
library(stats)
plot(pca_train$x[,1], pca_train$x[,2], pch=18, xlab='1 komponente', col=PCA_TRAIN_data.final$TARGET, ylab='2 komponete')
plot(PCA_TRAIN_data.final$PC1, PCA_TRAIN_data.final$PC2, pch=18, xlab='1 komponente', col=PCA_TRAIN_data.final$TARGET, ylab='2 komponete')

plot(PCA_TEST_data.final$PC1, PCA_TEST_data.final$PC2, pch=18, xlab='1 komponente', col=PCA_TEST_data.final$TARGET, ylab='2 komponete', main = 'TEST')


plot(PCA_TRAIN_data.final$PC2, PCA_TRAIN_data.final$PC3, pch=18, xlab='2 komponente', col=PCA_TRAIN_data.final$TARGET, ylab='3 komponete')

plot(PCA_TEST_data.final$PC2, PCA_TEST_data.final$PC3, pch=18, xlab='2 komponente', col=PCA_TEST_data.final$TARGET, ylab='3 komponete', main = 'TEST')


plot(PCA_TRAIN_data.final$PC3, PCA_TRAIN_data.final$PC4, pch=18, xlab='3 komponente', col=PCA_TRAIN_data.final$TARGET, ylab='4 komponete')

plot(PCA_TEST_data.final$PC3, PCA_TEST_data.final$PC4, pch=18, xlab='3 komponente', col=PCA_TEST_data.final$TARGET, ylab='4 komponete', main = 'TEST')


plot(PCA_TRAIN_data.final$PC4, PCA_TRAIN_data.final$PC5, pch=18, xlab='4 komponente', col=PCA_TRAIN_data.final$TARGET, ylab='5 komponete')

plot(PCA_TEST_data.final$PC4, PCA_TEST_data.final$PC5, pch=18, xlab='4 komponente', col=PCA_TEST_data.final$TARGET, ylab='5 komponete', main = 'TEST')



PCA_TRAIN_ALL=as.data.frame(pca_train$x)
PCA_TRAIN_ALL=cbind(train_data$TARGET,PCA_TRAIN_ALL)
PCA_TEST_ALL=as.data.frame(pca_test)
PCA_TEST_ALL=cbind(test_data$TARGET,PCA_TEST_ALL)
sum(names(PCA_TEST_ALL) %in% names(PCA_TRAIN_ALL))

###############################################################################
#2 PCA Only numeric
#######################################################################

library(stats)

I.variables_num<-train_data_num2[,-1]

pca_train_num <- prcomp(I.variables_num,
                    center = TRUE,
                    scale. = TRUE) 



plot(pca_train_num, type = "l")
summary(pca_train_num)

pca_test_num <-predict(pca_train_num, 
                   newdata=test_data_num2[,-1])

biplot(pca_train_num)


#pr.out=prcomp(B_CAll_app_Norm[,2:31],scale=TRUE)
names(pca_train_num)
summary(pca_train_num)
dim(pca_train_num$x)
pr.var.num=pca_train_num$sdev^2
pve.num=pr.var.num/sum(pr.var)
plot(cumsum(pve.num), col="red", xlab="Principal Component",ylab="Cumulative Proportion of Variance Explained",ylim=c(0,1),type="b")

# First 80 Principal Components which explain about 80% of the variation are selected for further analysis
sum(pve.num[1:78])# 95 proc., 100 - 90 proc.
loadings2<- as.data.frame(pca_train_num$rotation[,1:100])

##########BAIGIAU CIA
PCA_TRAIN_data.final_num=as.data.frame(pca_train_num$x[,1:100])

PCA_TRAIN_data.final_num=cbind(train_data$TARGET,PCA_TRAIN_data.final_num)
dim(pca_test)
PCA_TEST_data.final_num=as.data.frame(pca_test_num[,1:100])
PCA_TEST_data.final_num=cbind(test_data$TARGET,PCA_TEST_data.final_num)

names(PCA_TEST_data.final_num)[1]<-'TARGET'
names(PCA_TRAIN_data.final_num)[1]<-'TARGET'
library(stats)
plot(pca_train_num$x[,1], pca_train_num$x[,2], pch=18, xlab='1 komponente', col=PCA_TRAIN_data.final_num$TARGET, ylab='2 komponete')
plot(PCA_TRAIN_data.final_num$PC1, PCA_TRAIN_data.final_num$PC2, pch=18, xlab='1 komponente', col=PCA_TRAIN_data.final_num$TARGET, ylab='2 komponete')

plot(PCA_TEST_data.final_num$PC1, PCA_TEST_data.final_num$PC2, pch=18, xlab='1 komponente', col=PCA_TEST_data.final_num$TARGET, ylab='2 komponete', main = 'TEST')


plot(PCA_TRAIN_data.final_num$PC2, PCA_TRAIN_data.final_num$PC3, pch=18, xlab='2 komponente', col=PCA_TRAIN_data.final_num$TARGET, ylab='3 komponete')

plot(PCA_TEST_data.final_num$PC2, PCA_TEST_data.final_num$PC3, pch=18, xlab='2 komponente', col=PCA_TEST_data.final_num$TARGET, ylab='3 komponete', main = 'TEST')


plot(PCA_TRAIN_data.final_num$PC3, PCA_TRAIN_data.final_num$PC4, pch=18, xlab='3 komponente', col=PCA_TRAIN_data.final_num$TARGET, ylab='4 komponete')

plot(PCA_TEST_data.final_num$PC3, PCA_TEST_data.final_num$PC4, pch=18, xlab='3 komponente', col=PCA_TEST_data.final_num$TARGET, ylab='4 komponete', main = 'TEST')


plot(PCA_TRAIN_data.final_num$PC4, PCA_TRAIN_data.final_num$PC5, pch=18, xlab='4 komponente', col=PCA_TRAIN_data.final_num$TARGET, ylab='5 komponete')

plot(PCA_TEST_data.final_num$PC4, PCA_TEST_data.final_num$PC5, pch=18, xlab='4 komponente', col=PCA_TEST_data.final_num$TARGET, ylab='5 komponete', main = 'TEST')



###############################################################################
#3 PCA NUMERIC ADDIG FACTORS
#######################################################################

sum(pve.num[1:78])# 95 proc., 100 - 90 proc.
loadings3 <- as.data.frame(pca_train_num$rotation[,1:78])

a_names
b_values<-which(names(train_data) %in% a_names)

PCA_TRAIN_data.final_num_factors=as.data.frame(pca_train_num$x[,1:78])
PCA_TEST_data.final_num_factors=as.data.frame(pca_test_num[,1:78])
PCA_TRAIN_data.final_num_factors=cbind(train_data$TARGET,PCA_TRAIN_data.final_num_factors)
PCA_TEST_data.final_num_factors=cbind(test_data$TARGET,PCA_TEST_data.final_num_factors)

PCA_TRAIN_data.final_num_factors=cbind(PCA_TRAIN_data.final_num_factors, train_data[,c(b_values)])
PCA_TEST_data.final_num_factors=cbind(PCA_TEST_data.final_num_factors, test_data[,c(b_values)])
names(PCA_TRAIN_data.final_num_factors)
names(PCA_TEST_data.final_num_factors)
names(PCA_TEST_data.final_num_factors)[1]<-"TARGET"
names(PCA_TRAIN_data.final_num_factors)[1]<-"TARGET"
###############################################################################
#FAMD   Factorial Analysis of Mixed Data (FAMD) FACTORS PCA
#############################################################################
load("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2022 12 19 V Attribute selection strategy FAMD/.RData")
setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2022 12 19 V Attribute selection strategy FAMD")

library("FactoMineR")
data(wine)
res.famd <- FAMD(wine[,c(1,2, 16, 22, 29, 28, 30,31)], graph = FALSE)

# Eigenvalues/variances of dimensions
fviz_screeplot(res.famd)
fviz_famd_var(res.famd)
fviz_famd_var(res.famd, "quanti.var", repel = TRUE, col.var = "black")
fviz_famd_ind(res.famd, col.ind = "cos2",
              gradient.cols = c("#00AFBB", "#E7B800", "#FC4E07"),
              repel = TRUE)


#http://rpkgs.datanovia.com/factoextra/reference/fviz_famd.html
library("FactoMineR")
library('ggplot2')
library(factoextra)
#https://www.kaggle.com/code/intelligencerefinery/factor-analysis-of-mixed-data-in-r
res.famd <- FAMD(train_data, 
                 sup.var = 1,  ## Set the target variable "Churn" as a supplementary variable
                 graph =  FALSE, 
                 ncp=100)

## Inspect principal components
FAMD_TABLE<-get_eigenvalue(res.famd)

options(repr.plot.width = 14, repr.plot.height = 12)

## Plot individual observations
fviz_famd_ind(res.famd, label = "none", 
              habillage = "TARGET", palette = c("#00AFBB", "#FC4E07"), # color by groups 
              repel = TRUE, alpha.ind = 0.5) + 
  theme(text = element_text(size=20), axis.text.x = element_text(size=20), axis.text.y = element_text(size=20))

# Plot of variables
fviz_famd_var(res.famd, repel = TRUE)
# Contribution to the first dimension
fviz_contrib(res.famd, "var", axes = 1)
# Contribution to the second dimension
fviz_contrib(res.famd, "var", axes = 2)

test_data2<-test_data[,-1]
FAMD_pred<-predict(res.famd, newdata=test_data2)

summary(res.famd)

FAMD_TRAIN<-get_famd_ind(res.famd)
FAMD_TRAIN2<-as.data.frame(FAMD_TRAIN$coord)
FAMD_TEST<-as.data.frame(FAMD_pred$coord)

FAMD_TRAIN2=cbind(train_data$TARGET,FAMD_TRAIN2)
FAMD_TEST=cbind(test_data$TARGET,FAMD_TEST)

names(FAMD_TEST)[1]<-"TARGET"
names(FAMD_TRAIN2)[1]<-"TARGET"

FAMD_TRAIN3<-as.data.frame(FAMD_TRAIN$cos2)
######################################################################
#http://www.sthda.com/english/articles/31-principal-component-methods-in-r-practical-guide/115-famd-factor-analysis-of-mixed-data-in-r-essentials/

########################################
#FAMD 50
library("FactoMineR")
library('ggplot2')
library(factoextra)
#https://www.kaggle.com/code/intelligencerefinery/factor-analysis-of-mixed-data-in-r
res.famd50 <- FAMD(train_data, 
                 sup.var = 1,  ## Set the target variable "Churn" as a supplementary variable
                 graph =  FALSE, 
                 ncp=50)

fviz_famd_var(res.famd50, repel = TRUE)

FAMD_pred<-predict(res.famd50, newdata=test_data2)

FAMD_TRAIN50<-get_famd_ind(res.famd50)
FAMD_TRAIN50<-as.data.frame(FAMD_TRAIN50$coord)
FAMD_TEST50<-as.data.frame(FAMD_pred$coord)

FAMD_TRAIN50=cbind(train_data$TARGET,FAMD_TRAIN50)
FAMD_TEST50=cbind(test_data$TARGET,FAMD_TEST50)

names(FAMD_TEST50)[1]<-"TARGET"
names(FAMD_TRAIN50)[1]<-"TARGET"

library("FactoMineR")
library('ggplot2')
library(factoextra)
#https://www.kaggle.com/code/intelligencerefinery/factor-analysis-of-mixed-data-in-r
res.famd30 <- FAMD(train_data, 
                   sup.var = 1,  ## Set the target variable "Churn" as a supplementary variable
                   graph =  FALSE, 
                   ncp=30)

FAMD_pred<-predict(res.famd30, newdata=test_data2)

FAMD_TRAIN30<-get_famd_ind(res.famd30)
FAMD_TRAIN30<-as.data.frame(FAMD_TRAIN30$coord)
FAMD_TEST30<-as.data.frame(FAMD_pred$coord)

FAMD_TRAIN30=cbind(train_data$TARGET,FAMD_TRAIN30)
FAMD_TEST30=cbind(test_data$TARGET,FAMD_TEST30)

names(FAMD_TEST30)[1]<-"TARGET"
names(FAMD_TRAIN30)[1]<-"TARGET"

library("FactoMineR")
library('ggplot2')
library(factoextra)
#https://www.kaggle.com/code/intelligencerefinery/factor-analysis-of-mixed-data-in-r
res.famd15 <- FAMD(train_data, 
                   sup.var = 1,  ## Set the target variable "Churn" as a supplementary variable
                   graph =  FALSE, 
                   ncp=15)

FAMD_pred<-predict(res.famd15, newdata=test_data2)

FAMD_TRAIN15<-get_famd_ind(res.famd15)
FAMD_TRAIN15<-as.data.frame(FAMD_TRAIN15$coord)
FAMD_TEST15<-as.data.frame(FAMD_pred$coord)

FAMD_TRAIN15=cbind(train_data$TARGET,FAMD_TRAIN15)
FAMD_TEST15=cbind(test_data$TARGET,FAMD_TEST15)

names(FAMD_TEST15)[1]<-"TARGET"
names(FAMD_TRAIN15)[1]<-"TARGET"

#other SOM
#Autoencoder # all #by source type
#T_SNE

setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2022 12 19 FAMD")

