load("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 19 XGB LG/.RData")
setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 19 XGB LG")

###############DATA###################
train_data<-train_data_XGB_order[,]
test_data<-test_data_XGB_order[,]

library(themis)
smotenc_data<-smotenc(train_data, var = 'TARGET', k = 5, over_ratio = 1)
table(smotenc_data$TARGET)

#NERA FAKTORINIU DUOMENU YRA TIK 

smotenc_data$the_same<-Reduce(`&`, Map(`==`, train_data, smotenc_data))
smotenc_data$row_number<-row.names(smotenc_data)

train_data<-smotenc_data[,]

set.seed(7)
rows <- sample(nrow(train_data))
train_data<-train_data[rows,]

last_columns<-length(train_data)
last_columns<-as.numeric(last_columns)
last_columns<-append(last_columns,last_columns-1)

Train_data_rows_identification<-train_data[,last_columns]

train_data<-train_data[,-c(last_columns)]

#########################################################################################
#                           MODELIAI
########################################################################################
expected_value <- factor(c(test_data[,(1)]))
Predicted_values<-as.data.frame(test_data$TARGET)
names(Predicted_values)[1]<-'Real_target'
########################################################################################



reg_model<-glm(TARGET~.,  data=train_data[,1:2], family = binomial(link = 'logit'))
reg_model
summary(reg_model)


a_names<-"none"
a_names<-a_names[-1]
train_used<-train_data[,c(1:2)]

for (i in (1:dim(train_used)[2])){
  print(paste('v',i, sep='_'))
  a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
  a_value<-as.numeric(a_order[1])
  if (a_value==1){
    a_value<-as.numeric(a_order[2])
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_used) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))
    }}
  else{
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_used) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))}
  }
}

summary(reg_model)

#PREDICT
pred<-predict(reg_model,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$LG_XGB_1<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

Palyginimo<-as.data.frame(bin_cm$record_level_cm)
a<-names(Palyginimo)
a<-a[c(1:6,12,13,16,17,18,22)]
Palyginimo<-Palyginimo[,which(names(Palyginimo) %in% a)]
library(MLmetrics)
Palyginimo$AUC<-AUC(predicted_value, expected_value)
library(dgof)
Palyginimo$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
Palyginimo$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
Palyginimo$Error_rate<-1-Palyginimo$Accuracy
Palyginimo$Type_I_err<-Palyginimo$Pred_0_Ref_1/(Palyginimo$Pred_0_Ref_1+Palyginimo$Pred_1_Ref_1)
Palyginimo$Type_II_err<-Palyginimo$Pred_1_Ref_0/(Palyginimo$Pred_1_Ref_0+Palyginimo$Pred_0_Ref_0)
Palyginimo$MCC<-((Palyginimo$Pred_0_Ref_0*Palyginimo$Pred_1_Ref_1)-(Palyginimo$Pred_1_Ref_0*Palyginimo$Pred_0_Ref_1))/
  sqrt(as.numeric(Palyginimo$Pred_0_Ref_0+Palyginimo$Pred_1_Ref_0)*as.numeric(Palyginimo$Pred_0_Ref_0+Palyginimo$Pred_0_Ref_1)*as.numeric(Palyginimo$Pred_1_Ref_1+Palyginimo$Pred_1_Ref_0)*as.numeric((Palyginimo$Pred_1_Ref_1+Palyginimo$Pred_0_Ref_1)))
Palyginimo$G_mean<-sqrt(as.numeric(Palyginimo$Recall)*as.numeric(Palyginimo$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-peXGBormance-of-credit-score-models-59fe13ef420
Palyginimo$Gini<-2*Palyginimo$AUC-1
Palyginimo$Modelis<-"LG_XGB_1"

saveRDS(reg_model, file = paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 19 XGB LG/", "LG_XGB_", 1, ".rda"))

#LG_1 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 19 XGB LG/LG_XGB_1.rda")
#summary(LG_1)

######################2#################

reg_model<-glm(TARGET~.,  data=train_data[,c(1:3)], family = binomial(link = 'logit'))
reg_model
summary(reg_model)


a_names<-"none"
a_names<-a_names[-1]
train_used<-train_data[,c(1:3)]

for (i in (1:dim(train_used)[2])){
  print(paste('v',i, sep='_'))
  a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
  a_value<-as.numeric(a_order[1])
  if (a_value==1){
    a_value<-as.numeric(a_order[2])
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_used) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))
    }}
  else{
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_used) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))}
  }
}

summary(reg_model)

#PREDICT
pred<-predict(reg_model,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$aa<-predicted_value
col_name <- paste0("LG_XGB_", 2)
colnames(Predicted_values)[3] <- col_name

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
library(MLmetrics)
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-peXGBormance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-paste('LG_XGB_',2)
Palyginimo<-rbind(Palyginimo, New_row_pal)
saveRDS(reg_model, file = paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 19 XGB LG/", "LG_XGB_", 2, ".rda"))

###############################################################
#                        3-15 cikliukas
################################################

setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 19 XGB LG")
library(dgof)
library(MLmetrics)
library('ConfusionTableR')

train_used<-train_data[,]

for (j in (3:15)){
  print(j)
  n<-j+1
  train_used<-train_data[,c(1:n)]
  reg_model<-glm(TARGET~.,  data=train_used[,c(1:n)], family = binomial(link = 'logit'))
  a_names<-"none"
  a_names<-a_names[-1]
  for (i in (1:n)){
    print(paste('v',j,i, sep='_'))
    a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
    a_value<-as.numeric(a_order[1])
    if (a_value==1){
      a_value<-as.numeric(a_order[2])
      bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
      if (bigger==TRUE) {
        a_names<-append(a_names, names(reg_model$coefficients[a_value]))
        b_names<-as.numeric(which(names(train_used) %in% a_names))
        reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))
      }}
    else{
      bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
      if (bigger==TRUE) {
        a_names<-append(a_names, names(reg_model$coefficients[a_value]))
        b_names<-as.numeric(which(names(train_used) %in% a_names))
        reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))}
    }
  }
  pred<-predict(reg_model,test_data[,-c(1)])
  pred2<-ifelse(pred >= 0.5, 1, 0)
  predicted_value <- factor(c(pred2))
  Predicted_values$aa<-predicted_value
  col_name <- paste0("LG_XGB_", j)
  colnames(Predicted_values)[n] <- col_name
  
  bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
  New_row_pal<-as.data.frame(bin_cm$record_level_cm)
  New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
  New_row_pal$AUC<-AUC(predicted_value, expected_value)
  New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
  New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
  New_row_pal$Error_rate<-1-New_row_pal$Accuracy
  New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
  New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
  New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
    sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
  New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
  New_row_pal$Gini<-2*New_row_pal$AUC-1
  New_row_pal$Modelis<-paste('LG_XGB_',j)
  Palyginimo<-rbind(Palyginimo, New_row_pal)
  
  saveRDS(reg_model, file = paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 19 XGB LG/", "LG_XGB_", j, ".rda"))
  write.csv(Palyginimo, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 19 XGB LG/XGB_LG_pal.csv")
  write.csv(Predicted_values, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 19 XGB LG/XGB_LG_values.csv")
}

#LG_1 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 19 XGB LG/LG_XGB_15.rda")
#summary(LG_1)

###############################################################
#                        16:50 cikliukas
################################################

setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 19 XGB LG")
library(dgof)
library(MLmetrics)
library('ConfusionTableR')

train_used<-train_data[,]

for (j in (16:50)){
  print(j)
  n<-j+1
  train_used<-train_data[,c(1:n)]
  reg_model<-glm(TARGET~.,  data=train_used[,c(1:n)], family = binomial(link = 'logit'))
  a_names<-"none"
  a_names<-a_names[-1]
  for (i in (1:n)){
    print(paste('v',j,i, sep='_'))
    a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
    a_value<-as.numeric(a_order[1])
    if (a_value==1){
      a_value<-as.numeric(a_order[2])
      bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
      if (bigger==TRUE) {
        a_names<-append(a_names, names(reg_model$coefficients[a_value]))
        b_names<-as.numeric(which(names(train_used) %in% a_names))
        reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))
      }}
    else{
      bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
      if (bigger==TRUE) {
        a_names<-append(a_names, names(reg_model$coefficients[a_value]))
        b_names<-as.numeric(which(names(train_used) %in% a_names))
        reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))}
    }
  }
  pred<-predict(reg_model,test_data[,-c(1)])
  pred2<-ifelse(pred >= 0.5, 1, 0)
  predicted_value <- factor(c(pred2))
  Predicted_values$aa<-predicted_value
  col_name <- paste0("LG_XGB_", j)
  colnames(Predicted_values)[n] <- col_name
  
  bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
  New_row_pal<-as.data.frame(bin_cm$record_level_cm)
  New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
  New_row_pal$AUC<-AUC(predicted_value, expected_value)
  New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
  New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
  New_row_pal$Error_rate<-1-New_row_pal$Accuracy
  New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
  New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
  New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
    sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
  New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
  New_row_pal$Gini<-2*New_row_pal$AUC-1
  New_row_pal$Modelis<-paste('LG_XGB_',j)
  Palyginimo<-rbind(Palyginimo, New_row_pal)
  
  saveRDS(reg_model, file = paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 19 XGB LG/", "LG_XGB_", j, ".rda"))
  write.csv(Palyginimo, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 19 XGB LG/XGB_LG_pal.csv")
  write.csv(Predicted_values, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 19 XGB LG/XGB_LG_values.csv")
}