setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2022 11 16 III Attribute selection strategy2")

TRAIN_ALL_atr<-subset(ALL_atr, STATUS_YEAR_GROUP !=2022)
TEST_ALL_atr<-subset(ALL_atr, STATUS_YEAR_GROUP ==2022)

names(TEST_ALL_atr)
TEST_ALL_NEW<-TEST_ALL_atr[,c(1,3:935)]
library(dplyr)
TEST_ALL_NEW<-left_join(TEST_ALL_NEW, STATUS_2022[,-c(9)], by='regnumn')
names(TEST_ALL_NEW)

TEST_ALL_NEW<-TEST_ALL_NEW[,c(1,935,2:934,936:941)]
TEST_ALL_NEW<-cbind(TEST_ALL_NEW, TEST_ALL_atr[,c(942:981)])

names(ALL_atr)

TRAIN_ALL_atr<-TRAIN_ALL_atr[,-c(1,3:5)]
TEST_ALL_atr<-TEST_ALL_atr[,-c(1,3:5)]
TEST_ALL_NEW<-TEST_ALL_NEW[,-c(1,3:5)]
df<-TRAIN_ALL_atr
library(caret)
df<-preProcess(df, method=c("range"))
train_data<-predict(df, TRAIN_ALL_atr)
test_data<-predict(df, TEST_ALL_atr)
test_data_NEW<-predict(df, TEST_ALL_NEW)

train_data[is.na(train_data)] = 0
test_data[is.na(test_data)] = 0
test_data_NEW[is.na(test_data_NEW)] = 0

#Variation check
table(train_data$T_1_Long_yield_MAX, useNA = 'always')
table(train_data$T_2_Long_yield_MIN, useNA = 'always')
table(train_data$T_2_Long_yield_LAST_VALUE, useNA = 'always')
table(train_data$Active_owner_at_the_same_time, useNA = 'always')
#trys atmetami
a_names<-c('T_1_Long_yield_MAX','T_2_Long_yield_MIN', 'T_2_Long_yield_LAST_VALUE', 'Active_owner_at_the_same_time')
b_values<-which(names(test_data_NEW) %in% a_names)
train_data<-train_data[,-c(b_values)]
test_data<-test_data[,-c(b_values)]
test_data_NEW<-test_data_NEW[,-c(b_values)]
#####################################################

a_names<-NA
for (i in 2:dim(train_data)[2]){
  print(names(train_data)[i])
  if(length(which(!(names(table(train_data[,i])) %in% c(0,1)))) == 0)
  {a_names<-append(a_names, names(train_data)[i])}}


a_names
a_names<-a_names[-c(1,6:16,34:38)]
b_values<-which(names(train_data) %in% a_names)
a_names
for (i in b_values){
  print(i)
  train_data[,i]<-as.factor(train_data[,i])
  test_data[,i]<-as.factor(test_data[,i])
}

names(train_data)[1]<-'TARGET'
names(test_data)[1]<-'TARGET'
names(test_data_NEW)[1]<-'TARGET'
train_data$TARGET<-as.factor(train_data$TARGET)
test_data$TARGET<-as.factor(test_data$TARGET)
test_data_NEW$TARGET<-as.factor(test_data_NEW$TARGET)

####################################################
# ATRIBUTE SELECTION RF
###################################################
library(caTools)
library(randomForest)
set.seed(120)  # Setting seed
classifier_RF = randomForest(x = train_data[-1],
                             y = train_data$TARGET,
                             ntree = 500)

plot(classifier_RF)
RF_import<-as.data.frame(importance(classifier_RF))
varImpPlot(classifier_RF,  type = 1)

RF_import$Feature<-row.names(RF_import)
RF_import<-RF_import[order(RF_import$MeanDecreaseGini, decreasing = 'TRUE'),]
RF_import_atrinkti<-RF_import[1:100,]
RF_import_atrinkti_50<-RF_import[1:50,]
RF_import_atrinkti_30<-RF_import[1:30,]
RF_import_atrinkti_15<-RF_import[1:15,]

library(randomForest)
set.seed(120)  # Setting seed
classifier_RF2 = randomForest(x = train_data[-1],
                             y = train_data$TARGET,
                             ntree = 500, importance = TRUE)

plot(classifier_RF2)
RF_import2<-as.data.frame(importance(classifier_RF2, type=1))
varImpPlot(classifier_RF2,  type = 1)
varImpPlot(classifier_RF2,  type = 2)

RF_import2$Feature<-row.names(RF_import2)
RF_import2<-RF_import2[order(RF_import2$MeanDecreaseAccuracy, decreasing = 'TRUE'),]

summary(RF_import2)
sum(RF_import2$MeanDecreaseAccuracy >=mean(RF_import2$MeanDecreaseAccuracy))

RF_import2$Feature<-row.names(RF_import2)
RF_import2<-RF_import2[order(RF_import2$MeanDecreaseAccuracy, decreasing = 'TRUE'),]
RF_import_atrinkti2<-RF_import2[1:100,]
sum(RF_import_atrinkti$Feature %in% RF_import_atrinkti2$Feature)
#34 persidengia

train_data_rf<-train_data[,c(1, which(names(train_data) %in% RF_import_atrinkti$Feature))]
names(train_data_rf)
test_data_rf<-test_data[,c(1, which(names(test_data) %in% RF_import_atrinkti$Feature))]
names(test_data_rf)
train_data_rf_50<-train_data[,c(1, which(names(train_data) %in% RF_import_atrinkti_50$Feature))]
names(train_data_rf_50)
test_data_rf_50<-test_data[,c(1, which(names(test_data) %in% RF_import_atrinkti_50$Feature))]
names(test_data_rf_50)
train_data_rf_30<-train_data[,c(1, which(names(train_data) %in% RF_import_atrinkti_30$Feature))]
names(train_data_rf_30)
test_data_rf_30<-test_data[,c(1, which(names(test_data) %in% RF_import_atrinkti_30$Feature))]
names(test_data_rf_30)

NEW_test_data_rf_30<-test_data_NEW[,c(1, which(names(test_data_NEW) %in% RF_import_atrinkti_30$Feature))]
names(NEW_test_data_rf_30)

train_data_rf_15<-train_data[,c(1, which(names(train_data) %in% RF_import_atrinkti_15$Feature))]
names(train_data_rf_15)
test_data_rf_15<-test_data[,c(1, which(names(test_data) %in% RF_import_atrinkti_15$Feature))]
names(test_data_rf_15)

####################################################D
# ATRIBUTE SELECTION XGBOOST
###################################################


library(xgboost) # for xgboost
library(tidyverse) # general utility functions


X = data.matrix(train_data[,-c(1)])
X_test = data.matrix(test_data[,-c(1)])

y<-as.matrix(train_data$TARGET)
y_test<-as.matrix(test_data$TARGET)


xgb_train <- xgboost::xgb.DMatrix(data = X, label = y)
xgb_test <- xgboost::xgb.DMatrix(data = X_test, label = y_test)

set.seed(120)

xgb <- xgboost(data = xgb_train, # the data   
               nround = 300, # max number of boosting iterations
               objective = "binary:logistic")  # the objective function

xgb_softmax <- xgboost(data = xgb_train, # the data   
                       nround = 300, # max number of boosting iterations uztektu 50
                       objective = "multi:softmax",
                       num_class = 2)  # the objective function

importance_matrix <- xgb.importance(model = xgb_softmax)
print(importance_matrix)
xgb.plot.importance(importance_matrix = importance_matrix[1:30])


VAR_import<-data.frame(importance_matrix)
names(VAR_import)
names(VAR_import)<-c(names(VAR_import)[1],paste('XGB_softmax',names(VAR_import)[2:4], sep = '_'))


library(dplyr)
VAR_import<-full_join(VAR_import, importance_matrix, by = 'Feature')
names(VAR_import)<-c(names(VAR_import)[1:4],paste('XGB_binary',names(VAR_import)[5:7], sep = '_'))

VAR_import<-full_join(VAR_import, RF_import, by = 'Feature')
names(VAR_import)<-c(names(VAR_import)[1:7],paste('RF',names(VAR_import)[8], sep = '_'))

##################################################
VAR_import<-VAR_import[order(VAR_import$XGB_softmax_Gain, decreasing = TRUE), ]
a<-VAR_import[1:100,'Feature']
VAR_import<-VAR_import[order(VAR_import$XGB_binary_Gain, decreasing = TRUE), ]
b<-VAR_import[1:100,'Feature']
sum(a %in% b)

#visi yra nera skirtumo kuri rinktis
#binary
importance_matrix <- xgb.importance(model = xgb)
print(importance_matrix)
xgb.plot.importance(importance_matrix = importance_matrix[1:30])

XGB_import_atrinkti<-importance_matrix[1:100,]
XGB_import_atrinkti50<-importance_matrix[1:50,]
XGB_import_atrinkti30<-importance_matrix[1:30,]
XGB_import_atrinkti15<-importance_matrix[1:15,]

train_data_xgb<-train_data[,c(1, which(names(train_data) %in% XGB_import_atrinkti$Feature))]
names(train_data_xgb)
test_data_xgb<-test_data[,c(1, which(names(test_data) %in% XGB_import_atrinkti$Feature))]
names(test_data_xgb)
train_data_xgb50<-train_data[,c(1, which(names(train_data) %in% XGB_import_atrinkti50$Feature))]
names(train_data_xgb50)
test_data_xgb50<-test_data[,c(1, which(names(test_data) %in% XGB_import_atrinkti50$Feature))]
names(test_data_xgb50)
train_data_xgb30<-train_data[,c(1, which(names(train_data) %in% XGB_import_atrinkti30$Feature))]
names(train_data_xgb30)
test_data_xgb30<-test_data[,c(1, which(names(test_data) %in% XGB_import_atrinkti30$Feature))]
names(test_data_xgb30)
train_data_xgb15<-train_data[,c(1, which(names(train_data) %in% XGB_import_atrinkti15$Feature))]
names(train_data_xgb15)
test_data_xgb15<-test_data[,c(1, which(names(test_data) %in% XGB_import_atrinkti15$Feature))]
names(test_data_xgb15)


####################################################
# ATRIBUTE SELECTION LASSO
###################################################
library(data.table) # used for reading and manipulation of data
library(dplyr)      # used for data manipulation and joining
library(glmnet)     # used for regression
library(ggplot2)    # used for ploting
library(caret)      # used for modeling
library(xgboost)    # used for building XGBoost model
library(e1071)      # used for skewness
library(cowplot)    # u
#must be numeric
train_data_num<-train_data[,]
test_data_num<-test_data[,]

for (i in b_values){
  print(i)
  train_data_num[,i]<-as.factor(train_data[,i])
  test_data_num[,i]<-as.factor(test_data[,i])
}


lasso_model = train(x = train_data[, -c(1)],
                    y = train_data$TARGET,
                    method = "glmnet"
)
lasso_model


#define response variable
y <- (train_data$TARGET)

#define matrix of predictor variables
x <- data.matrix(train_data[, -c(1)])

glmmod <- glmnet(x, y, alpha=1, family="binomial")
plot(glmmod, xvar="lambda")
glmmod
cv.glmmod <- cv.glmnet(x, y=as.numeric(y), alpha=1)
plot(cv.glmmod)
best.lambda <- cv.glmmod$lambda.min

coef(glmmod,best.lambda)
#https://khrc.ucsf.edu/lasso-correlated-variable-selection
#https://www.yourdatateacher.com/2021/05/05/feature-selection-in-machine-learning-using-lasso-regression/
#As we can see, there are 3 features with 0 importance. Those features have been discarded by our model.
#These are standardized regression beta coefficients, 
#showing us that predictors 12 and 13 are associated with lower values of the outcome, 
#while predictors 1, 5, 9, and 10 are associated with higher values.

#Isolate the most important features by inspecting the beta coefficients for each variable in the loss function
#To interpret these coefficients, recall that each feature is scaled so that a one-unit change represents a one-unit change
#in standard deviation. So, for each of the features, we can interpret each coefficient as the effect of the change in 
#the target for being one standard deviation from the mean. For example, looking at BMI, having a 
#BMI one standard deviation from the mean increases a person’s progression of Diabetes by 25.6.


coef_Lasso<-coef(glmmod,best.lambda)
coef_Lasso<-as.data.frame(summary(coef_Lasso))

coef_Lasso$Feature<-NA

for (i in (1:dim(coef_Lasso)[1])){
  a<-coef_Lasso$i[i]
  print(a)
  coef_Lasso$Feature[i]<-names(train_data)[a]
}

coef_Lasso<-coef_Lasso[-c(1),]
names(coef_Lasso)[3]<-'Lasso_import'
library(dplyr)
VAR_import<-full_join(VAR_import, coef_Lasso[c('Lasso_import', 'Feature')], by = 'Feature')

VAR_import$Lasso_import_moduliu<-abs(VAR_import$Lasso_import)

colSums(is.na(VAR_import))

coef_Lasso$Lasso_import_moduliu<-abs(coef_Lasso$Lasso_import)
coef_Lasso<-coef_Lasso[order(coef_Lasso$Lasso_import_moduliu, decreasing = 'TRUE'),]

#bet mes turim tik 98 svarbius tai visus ir traukiam
train_data_LASSO<-train_data[,c(1, which(names(train_data) %in% coef_Lasso$Feature))]
names(train_data_LASSO)
test_data_LASSO<-test_data[,c(1, which(names(test_data) %in% coef_Lasso$Feature))]
names(test_data_LASSO)


write.csv(VAR_import, 'C:/Users/Dovile/Desktop/VAR_IMPORT.csv')


###############################################################################



###############################################################################


####IKI CIA ATRINKIMO METODAI

##################NETAIKOMA
####################################################
# ATRIBUTE SELECTION Light GBM
###################################################

library(lightgbm)
library(data.table)
library(Matrix)
library(dplyr)
library(MLmetrics)
train_sparse = Matrix(as.matrix(train_data[,-1]), sparse=TRUE)
test_sparse  = Matrix(as.matrix(test_data[,-1]), sparse=TRUE)

y_train  = train_data$TARGET

lgb.train = lgb.Dataset(data=train_sparse, label=y_train)

lgb.grid = list(objective = "binary",
                metric = "auc",
                min_sum_hessian_in_leaf = 1,
                feature_fraction = 0.7,
                bagging_fraction = 0.7,
                bagging_freq = 5,
                min_data = 100,
                max_bin = 50,
                lambda_l1 = 8,
                lambda_l2 = 1.3,
                min_data_in_bin=100,
                min_gain_to_split = 10,
                min_data_in_leaf = 30,
                is_unbalance = TRUE)

lgb.normalizedgini = function(preds, dtrain){
  actual = getinfo(dtrain, "label")
  score  = NormalizedGini(preds,actual)
  return(list(name = "gini", value = score, higher_better = TRUE))
}



lgb.model = lgb.train(params = lgb.grid, data = lgb.train, learning_rate = 0.2,
                      num_leaves = 25, num_threads = 2 , nrounds = 300,
                      eval_freq = 20, eval = lgb.normalizedgini)



####################################################
# ATRIBUTE SELECTION LOGISTIC REGRESION
###################################################
start.time<-Sys.time()
reg_model<-glm(TARGET~.,  data=train_data, family = binomial(link = 'logit'))
reg_model

reg_model_full<-reg_model

reg_model$rank
length(reg_model$coefficients)
#NA KOFICIENTAI del multikolinarumo ir atsikartojancios info todel juos reikia ismestis

coef_reg_model<-as.data.frame(summary(reg_model)$coef)
names(coef_reg_model)<-'reiksme'
coef_reg_model$mod<-abs(as.numeric(coef_reg_model$reiksme))
coef_reg_model$pav<-row.names(coef_reg_model)

train_data2<-train_data[,c(1, which(names(train_data) %in% coef_reg_model$pav))]

reg_model<-glm(TARGET~.,  data=train_data2, family = binomial(link = 'logit'))


a_names<-"none"
a_names<-a_names[-1]

start.time<-Sys.time()
for (i in (1:dim(train_data2)[2])){
  print(i)
  a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
  a_value<-as.numeric(a_order[1])
  if (a_value==1){
    a_value<-as.numeric(a_order[2])
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_data2) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_data2[,-c(b_names)], family = binomial(link = 'logit'))
    }}
  else{
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_data2) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_data2[,-c(b_names)], family = binomial(link = 'logit'))}
  }
}

summary(reg_model)$coefficients
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken
summary(reg_model)

#VAR IMPORTANCE
library(caret)
aa<-varImp(reg_model, scale = FALSE)
aa$pav<-row.names(aa)
#roc_imp <- filterVarImp(x = train_data[, -1], y = train_data$TARGET)
#head(roc_imp)
# https://topepo.github.io/caret/variable-importance.html
#write.csv(varImp(reg_model, scale = FALSE), 'C:/Users/Dovile/Desktop/Reg_iportance.csv')
#write.csv(roc_imp, 'C:/Users/Dovile/Desktop/Reg_iportance2.csv')

library(tidyverse)
library(caret)
coef_reg_model<-as.data.frame(summary(reg_model)$coef[,1])
names(coef_reg_model)<-'reiksme'
coef_reg_model$mod<-abs(as.numeric(coef_reg_model$reiksme))
coef_reg_model$pav<-row.names(coef_reg_model)
coef_reg_model$pav<-row.names(coef_reg_model)

library(dplyr)
coef_reg_model<-left_join(coef_reg_model, aa, by = 'pav')
names(coef_reg_model)[4]<-"Var_imp"
#https://topepo.github.io/caret/variable-importance.html

#https://stats.stackexchange.com/questions/464803/variable-importance-logistic-and-random-forest
#If you like the variable importance to reflect how useful the variable is at predicting correctly, 
#I think a fairer comparison might be change in deviance, so we can try something like:
v_glm = anova(reg_model)[-1,2,drop=FALSE]
v_glm = v_glm[order(v_glm[,1]),drop=FALSE,]
v_glm[,1] = 100*v_glm[,1]/max(v_glm[,1])
barplot(t(v_glm),horiz=FALSE,main="glm_deviance",las=2.5)
v_glm$pav<-row.names(v_glm)

library(dplyr)
coef_reg_model<-left_join(coef_reg_model, v_glm, by = 'pav')
names(coef_reg_model)[5]<-"v_glm"
#

#####################
#DATA REORDER BY THE IMPORTANCE
col_order <- c(RF_import2$Feature)
col_order<-c('TARGET', col_order)
train_data_RF_order <- train_data[, col_order]
test_data_RF_order <- test_data[, col_order]

######################
col_order2 <- c(importance_matrix$Feature)
col_order2<-c('TARGET', col_order2)
train_data_XGB_order <- train_data[, col_order2]
test_data_XGB_order <- test_data[, col_order2]

#####################
col_order3 <- c(coef_Lasso$Feature)
col_order3<-c('TARGET', col_order3)
train_data_LASSO_order <- train_data[, col_order3]
test_data_LASSO_order <- test_data[, col_order3]
