###########KORELIACIJA TARGET
#https://www.statology.org/point-biserial-correlation-r/ - for binary
#https://www.statology.org/point-biserial-correlation-r/

Koreliacija_target<-data.frame('ab','ba')
names(Koreliacija_target)[1]<-'Column_name'
names(Koreliacija_target)[2]<-'Corr_target'
Koreliacija_target<-Koreliacija_target[-1,]

train_data_num$TARGET<-as.numeric(train_data_num$TARGET)
form <- as.formula(paste('~',colnames(train_data_num)[2],"+TARGET"))

new_row = c(names(train_data_num)[2], cor.test(formula = form,
                                               data = train_data_num)$estimate)

Koreliacija_target<-rbind(Koreliacija_target, new_row)

names(Koreliacija_target)[1]<-'Column_name'
names(Koreliacija_target)[2]<-'Corr_target'

b_end<-as.numeric(dim(train_data_num)[2])
for (i in (3:(b_end))){
  form <- as.formula(paste('~',colnames(train_data_num)[i],"+TARGET"))
  a<-cor.test(formula = form,
              data = train_data_num)$estimate
  a<-as.numeric(a)
  b<-names(train_data_num)[i]
  new_row = c(b,a)
  Koreliacija_target<-rbind(Koreliacija_target, new_row)
}

Koreliacija_target$Corr_target<-as.numeric(Koreliacija_target$Corr_target)
Koreliacija_target$Corr_target_mod<-abs(Koreliacija_target$Corr_target)

#names(train_data_num)[82]<-'VMI_PCA'

#################KORELIACIJA LIKUSI

koreliacija<-cor(train_data_num[,c(2:(b_end))], use = "pairwise.complete.obs")
koreliacija_other <- as.data.frame(as.table(koreliacija))

koreliacija_other <- koreliacija_other[which(!koreliacija_other$Var1==koreliacija_other$Var2),]
koreliacija_other$modulis<-abs(koreliacija_other$Freq)

##############DAROMAS SMARKIAI KORELIUOJANCIU ATRIBUTU ATMETIMAS

koreliacija_other<-koreliacija_other[which(koreliacija_other$modulis>0.7),]

names(Koreliacija_target)
names(koreliacija_other)[1]<-'Column_name'

library(dplyr)
koreliacija_other<-left_join(koreliacija_other, Koreliacija_target[c('Column_name', 'Corr_target_mod')], by = 'Column_name')
names(koreliacija_other)[1]<-'Column_name_V1'
names(koreliacija_other)[2]<-'Column_name'
names(koreliacija_other)[5]<-'V1_Target'
koreliacija_other<-left_join(koreliacija_other, Koreliacija_target[c('Column_name', 'Corr_target_mod')], by = 'Column_name')


koreliacija_other$salyga<-ifelse((koreliacija_other$V1_Target)>(koreliacija_other$Corr_target_mod), 1,2)
koreliacija_other<-subset(koreliacija_other, salyga ==1)
a_kor<-koreliacija_other$Column_name
a_kor<-unique(a_kor)
a_kor

#ATMETAMI LABAI KORELIUOTI KINTAMIEJI
train_data_COR<-train_data[, which(!names(train_data) %in% a_kor)]


#REG MODEL
reg_model_cor<-glm(TARGET~.,  data=train_data_COR, family = binomial(link = 'logit'))
reg_model_cor
summary(reg_model_cor)

a_names<-"none"
a_names<-a_names[-1]

for (i in (1:dim(train_data_COR)[2])){
  print(i)
  a_order<-order(summary(reg_model_cor)$coefficients[,4], decreasing = TRUE)
  a_value<-as.numeric(a_order[1])
  if (a_value==1){
    a_value<-as.numeric(a_order[2])
    bigger<-summary(reg_model_cor)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model_cor$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_data_COR) %in% a_names))
      reg_model_cor<-glm(TARGET~.,  data=train_data_COR[,-c(b_names)], family = binomial(link = 'logit'))
    }}
  else{
    bigger<-summary(reg_model_cor)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model_cor$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_data_COR) %in% a_names))
      reg_model_cor<-glm(TARGET~.,  data=train_data_COR[,-c(b_names)], family = binomial(link = 'logit'))}
  }
}

summary(reg_model_cor)$coefficients
end.time<-Sys.time()
summary(reg_model_cor)

pred<-predict(reg_model_cor,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$LG_basic_COR<-predicted_value  ##########NAME CHANGE

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
library(MLmetrics)
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"LG basic COR"
Palyginimo<-rbind(Palyginimo, New_row_pal)

#####################################################################################################
#VAR IMPORTANCE
library(tidyverse)
library(caret)
coef(reg_model_cor)
coef_reg_model_cor<-as.data.frame(summary(reg_model_cor)$coef[,1])
names(coef_reg_model_cor)<-'reiksme'
coef_reg_model_cor$mod<-abs(as.numeric(coef_reg_model_cor$reiksme))
coef_reg_model_cor$pav<-row.names(coef_reg_model_cor)
coef_reg_model_cor$pav<-row.names(coef_reg_model_cor)

library(caret)
aa_cor<-varImp(reg_model_cor, scale = FALSE)
aa_cor$pav<-row.names(aa_cor)
#roc_imp <- filterVarImp(x = train_data[, -1], y = train_data$TARGET)
#head(roc_imp)
# https://topepo.github.io/caret/variable-importance.html
#write.csv(varImp(reg_model_cor, scale = FALSE), 'C:/Users/Dovile/Desktop/Reg_iportance.csv')
#write.csv(roc_imp, 'C:/Users/Dovile/Desktop/Reg_iportance2.csv')
library(dplyr)
coef_reg_model_cor<-left_join(coef_reg_model_cor, aa_cor, by = 'pav')
names(coef_reg_model_cor)[4]<-"Var_imp"
#https://topepo.github.io/caret/variable-importance.html

#https://stats.stackexchange.com/questions/464803/variable-importance-logistic-and-random-forest
#If you like the variable importance to reflect how useful the variable is at predicting correctly, 
#I think a fairer comparison might be change in deviance, so we can try something like:
v_glm = anova(reg_model_cor)[-1,2,drop=FALSE]
v_glm = v_glm[order(v_glm[,1]),drop=FALSE,]
v_glm[,1] = 100*v_glm[,1]/max(v_glm[,1])
barplot(t(v_glm),horiz=FALSE,main="glm_deviance",las=2.5)
v_glm$pav<-row.names(v_glm)
#
coef_reg_model_cor<-left_join(coef_reg_model_cor, v_glm, by = 'pav')
names(coef_reg_model_cor)[5]<-"v_glm"


#The list of importance
coef_reg_model_cor<-coef_reg_model_cor[order(coef_reg_model_cor$mod, decreasing = TRUE),]
start.time<-Sys.time()
reg_model_cor_coef<-glm(TARGET~.,  data=train_data_COR[,c(1,which(colnames(train_data_COR) %in% coef_reg_model_cor[1:30,'pav']))], family = binomial(link = 'logit'))
summary(reg_model_cor_coef)

pred<-predict(reg_model_cor_coef,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$LG_Coefficients_COR<-predicted_value

bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"LG Coefficients COR"
Palyginimo<-rbind(Palyginimo, New_row_pal)

coef_reg_model_cor<-coef_reg_model_cor[order(coef_reg_model_cor$Var_imp, decreasing = TRUE),]
reg_model_cor_var<-glm(TARGET~.,  data=train_data_COR[,c(1,which(colnames(train_data_COR) %in% coef_reg_model_cor[1:30,'pav']))], family = binomial(link = 'logit'))
summary(reg_model_cor_var)
pred<-predict(reg_model_cor_var,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$LG_VarImport_COR<-predicted_value

bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"LG VarImport COR"
Palyginimo<-rbind(Palyginimo, New_row_pal)


coef_reg_model_cor<-coef_reg_model_cor[order(coef_reg_model_cor$v_glm, decreasing = TRUE),]
reg_model_cor_VarAnova<-glm(TARGET~.,  data=train_data_COR[,c(1,which(colnames(train_data_COR) %in% coef_reg_model_cor[1:30,'pav']))], family = binomial(link = 'logit'))
summary(reg_model_cor_VarAnova)

pred<-predict(reg_model_cor_VarAnova,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$LG_VarAnova_COR<-predicted_value

bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"LG VarAnova COR"
Palyginimo<-rbind(Palyginimo, New_row_pal)

##########################################################################
#CAT BOOST IN R
###########################################################################

library(catboost)
library(dplyr)

label<-(train_data$TARGET)
label<-as.numeric(train_data$TARGET)
label<-ifelse(label==1, 0,1)

label2<-as.numeric(test_data$TARGET)
table(label2)
label2<-ifelse(label2==1, 0,1)

train_pool <- catboost.load_pool(data=train_data[,-c(1)], 
                                 label = label)

#train_pool <- catboost.load_pool(data=as.matrix(train_data$LD1), 
 #                                label = label)

test_pool <- catboost.load_pool(data=test_data[,-1], 
                                label = label2)
#test_pool <- catboost.load_pool(data=as.matrix(test_data$LD1), 
   #                             label = label2)
set.seed(321)
modelcat <- catboost.train(train_pool,  NULL,
                           params = list(loss_function = 'Logloss',
                                         iterations = 300, metric_period=10, task_type = 'GPU'))


prediction <- catboost.predict(modelcat, test_pool, prediction_type='Class')


predicted_value <- factor(c(prediction))
Predicted_values$CATBOOST<-predicted_value  ##########NAME CHANGE

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
library(MLmetrics)
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"CATBOOST"
Palyginimo<-rbind(Palyginimo, New_row_pal)


#########################################################################################################################
#                                                               Knn
#########################################################################################################################
library(class)
knn_3<-knn(train_data[,-c(1)], test_data[,-c(1)], train_data$TARGET, k = 3)
predicted_value <- as.factor(c(knn_3))
Predicted_values$Knn_3<-predicted_value
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"Knn-3"

Palyginimo<-rbind(Palyginimo, New_row_pal)

#######################K5
library(class)
knn_5<-knn(train_data[,-c(1)], test_data[,-c(1)], train_data$TARGET, k = 5)
predicted_value <- as.factor(c(knn_5))
Predicted_values$Knn_5<-predicted_value
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"Knn-5"

Palyginimo<-rbind(Palyginimo, New_row_pal)

#########################K7
knn_7<-knn(train_data[,-c(1)], test_data[,-c(1)], train_data$TARGET, k = 7)
predicted_value <- as.factor(c(knn_7))
Predicted_values$Knn_7<-predicted_value
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"Knn-7"
Palyginimo<-rbind(Palyginimo, New_row_pal)

